c-- sir code for fourier                         Release 93.02
      subroutine fourie(host,ier)
      character*80 host,name
      character cff
c
c     *************************** exfft ********************************
c     fast fourier transform program   -    january  1980
c     modification of program by l. f. ten eyck
c     *************************** exfft ********************************
c     read output tape from multan and expand data to space group p1
c     before calling fourier transform routines
      common /misc/ t(3,3),dxmax(3),mconx,iwt,fom(11),pts
      common /xdata/ x(30000),dumm1(15000),dumm2(15000),dumd(100000),
     *               dummpc(84000)
      common /atoms/ xyz(5,200),icvet(200),idumx(21)
      common /atomo/ xyzo(5,200),nzo(200),dold(400)
      common /refl/ ih(100),g(2,100)
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
      common/trig/sint(450),pi,twopi,dtor,rtod
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,nat,f(9),nalf(8)
      common /kuse/ kuser1,kuser2,kuser3
      common /tran/ scale,mh(3),level,it4,xlim(3)
      common /tape/ cell(6),neqv,icent,lat,natm,ts(3,24),is(2,3,24),nsym
     *             ,dumb(3)
      common /sdir/ dm,npc,nproj,nojoin
      common/spec/ soper(3,4,24),centrt(7,12),aaa(6),noper,ncentr,icentx
     *        ,kpol,jsys,latx,indv(32),mpv(64),jspini,ddmin,ncawu,ncwu
      common /dd/ a2,b2,c2,ab,ac,bc,bterm,wscale
      common/xfour/ itype,iprint,numero,iw,il  ,im  ,iv  ,ix
      common/ureq/ ihx(3),ksigma,knw,jpart,jtran,fosog,nonos,iprin,iflag
      common/inpcl/ntype,ttype(10,5),nprojx,nbond,dmaxi,radnew(8)
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,bfac(200),lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      common/c/flgw(30),flgd(30),avr(30),dcv(50),slope,flgk,bt,sc,del,ks
      dimension izpk(500)
c
      jrest = 0
      write(cff,'(i1)') kff
      write(lo,10) cff,itle
   10 format(///,a1 ,120('+'),//,
     1 39h fourier routine                       ,68x,14hRelease  93.02
     2 ,//,20x,20a4)
c
c     preliminary section        define all necessary program parameters
c
      itype=1
      iform=2
      jop=jopen(jrel ,name,nlen,itype,iform,ier)
      if (jop.lt.0) go to 9000
      jop=jopen(ifour,name,nlen,itype,iform,ier)
      if (jop.lt.0) go to 9010
c
      erreo=999999.9
      erre =1.0
      krecy=0
      call defco(nsize)
      call dirfou(jpfile,ier)
      if (ier.lt.0) return
      if (jpfile.eq.0) write(lo,20)
   20 format(1h ,120('+'),//,
     *       19x,'***  fast fourier transform section   ***',/)
      if (bt.lt.0.0) bt=0.1
      do 190 i=1,200
  190 bfac(i)=bt
      biso=bt
      iprint=iprin
      if (jpfile.ne.0) then
                         iprsav=iprin
                         if (iprin.eq.0) iprin=2
                         call getplt(jpfile,ier)
                         if (ier.lt.0) return
                         call xspinb
                         interp=0
                         if (nemap(4).gt.0) then
                                      kact=1
                                      call outpea(host,izpk,kact)
                                           interp=1
                                          endif
                         call frm15(nats,numset,interp)
                         iprin=iprsav
                         jrecyc=100
                       endif
c
c    mode = 1  primo calcolo fourier
c    mode = 2  secondo calcolo fourier
c    mode = 3  terzo   calcolo fourier
c
      numb2=0
      mode=1
      if (jrecyc.eq.0) then
                         erreo=-1.0
                         erre =-1.0
                       endif
      if (jrecyc.le.0) then
                         iprsav=iprin
                         if (iprin.eq.0) iprin=1
                         call fft(numb2,mode,anat,ccfom,nsize,ier)
                         if (ier.lt.0) return
                         kact=3
                         call outpea(host,izpk,kact)
                         interp=1
                         call frm15(nats,numset,interp)
                         if (jrecyc.lt.0) jrecyc = - jrecyc
                         iprin=iprsav
                       endif
      if (jrecyc.gt.0) then
                         call cp1530
                         modef=jrecyc+1
                         istop=-1
                         do 200 mode=2,modef
                            if (istop.eq.1) go to 200
                            if (mode.eq.modef) istop=1
                            call defco(nsize)
                            call fft(numb2,mode,anat,ccfom,nsize,ier)
                            if (ier.eq.0) then
                                      if (istop.eq.0) then
*                                                       kact=5
                                                      else
                                                        kact=2
                                      call outpea(host,izpk,kact)
                                                      endif
                                          interp=1
                                          call frm15(nats,numset,interp)
                       else if (ier.gt.0) then
                                          ier=0
                                          istop=istop+1
CCCCCCCC                                  if (istop.ne.1) then
                                          if (istop.eq.0) then
                                             iprsav=iprin
                                             if (iprin.eq.0) iprin=1
                                             kresav=krecy
                                             krecy=1000
                                      kact=3
                                      call outpea(host,izpk,kact)
                                             iprin=iprsav
                                             krecy=kresav
                                           else
                                           endif
                                        endif
  200                    continue
                         if (ier.lt.0) return
c
c-- stop recycling
c
                         call stopr(host,izpk,mode)
                       endif
      if (ier.lt.0) return
      close(jrel )
      close(ifour)
c--
      return
 9000 continue
      write(lo,9020) ier,jrel
      ier=-1
      return
 9010 continue
      write(lo,9030) ier,ifour
      ier=-1
 9020 format(' *** error ***  open error on scratch file jrel, code ='
     *,i5,',  channel =',i5)
 9030 format(' *** error ***  open error on scratch file ifour, code ='
     *,i5,',  channel =',i5)
      ier=-1
      return
      end
c     ----------------------------------------------------------------
      subroutine defco(nsize)
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common /kuse/ kuser1,kuser2,kuser3
      common /sdir/ dm,npc,nproj,nojoin
c     define constants
c     kuser1 = dimension of arrays ihkl,e,iphaz,ep = maximum number
c     of independent reflections which can be input  (kuser1 .ge. numb)
c     dimension of x = 3 * kuser1
      kuser1 = 10000
corig nsize = 3 * kuser1 - 1
      nsize = 160000
c     kuser2 = maximum number of peaks to be found + 20, also maximum
c     number of peaks for interpretation and dimension of several arrays
      kuser2 = 200
c     kuser3 = size of array nstore for storing 3 sections of e-map
      kuser3 = 159856
c     if 2 e-map peaks are closer than dm the smaller is eliminated
      dm=0.85
      return
      end
c     ----------------------------------------------------------------
      subroutine fft(numb2,mode,anat,ccfom,nsize,ier)
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,nat,f(9),nalf(8)
      common /xdata/ x(160000),dummpc(84000)
c
      call expand(numb2,mode,ccfom,ier)
      if (ier.ne.0) return
      call pp1(x,nsize,np(1),np(2),np(3),ier)
      if (ier.lt.0) return
      call search(mode,anat,ier)
      if (ier.lt.0) return
      return
      end
c----------------------------------------------------------------------
      subroutine search(mode,anat,ier)
c     ************************** search ********************************
c       routine for the automatic search of e-maps
c     original version    january   1980           university of york
c     ------------------------------------------------------------------
      common /xdata/ nstore(159856),is(2,3,24),dummpc(84000)
      common /atoms/ x(5,200),icvet(200),idumx(21)
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common/impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
      common /sdir/ dm,npc,nproj,nojoin
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,nat,f(9),nalf(8)
      common /kuse/ kuser1,kuser2,kuser3
      common /misc/ t(3,3),dxmax(3),mconx,iwt,fom(11),pts
      common /cent/ tl(3,4),fs(3,3,24),mlat
      common /tape/ cell(6),neqv,icent,lat,natm,ts(3,24),kj(2,3,24),nsym
     *             ,dumb(3)
      common/ureq/ ihx(3),ksigma,knw,jpart,jtran,fosog,nonos,iprin,iflag
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,bfac(200),lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
c
      npc = min0(npc, kuser2-20)
c     input data from fft file
      rewind jrel
      read (jrel) itle,numset,cell,neqv,icent,lat,natm,ts,is
      if(numset.lt.0) go to 2000
      anat=float(nat)/(pts*float((icent+1)*neqv))
      if (mode.eq.1) write(lo,720) anat
  720 format(10x,'a  number  of  atoms  has to be found'
     *    ,/,10x,'such that the sum of site occupancies'
     *    ,/,10x,'( occ. ) is equal to ',f8.3,/)
      if (npc .le. 0) go to 760
      nats = npc
      npic = npc
      write(lo,740) npc
  740 format(/31x,35hnumber of peaks to be considered is,i6)
      go to 800
  760 nats =  min0(2*(int(11.0*anat+13.0))/9, kuser2-20)
Corig npic = min0(int(3.0*anat+1.0), kuser2-20)
      npic = min0(int(3.0*anat+3.0), kuser2-20)
c
c
c
      if (nats.lt.20) nats=20
      if (npic.lt.20) npic=20
c
c
c
  800 continue
      if (nproj .gt. 0) write(lo,860) nproj
  860 format(/9x,55hnumber of projections  of each  cluster to be output
     1 is,i3)
c     halve y-axis by c.of.s. or lattice type if possible
      ihalf=0
      if (icent.eq.1) ihalf=-1
      if (ihalf.ne.0) goto 888
      goto (888,886,888,886,886,886,888), lat
  886 ihalf = 1
  888 call centre (1,1)
c     expand to full space group symmetry
c     put centring translations in tl(i,j)
      go to (940,890,890,890,890,910,920),lat
  890 call centre(2,lat)
      go to 940
  910 call centre(2,2)
      call centre(3,3)
      call centre(4,4)
      go to 940
  920 call centre(2,6)
      call centre(3,7)
  940 do 1000 i=1,neqv
      do 970 j=1,3
      do 950 k=1,3
      fs(k,j,i)=0.0
  950 continue
      do 960 k=1,2
      m=iabs(is(k,j,i))
      if(m.gt.0) fs(m,j,i)=float(isign(1,is(k,j,i)))
  960 continue
  970 continue
      if (i.eq.1.or.ihalf.ne.0) goto 1000
c     halve y-axis by symmetry op. if possible
      do 980 j=1,3
      if (iabs(is(1,j,i)).ne.j.or.is(2,j,i).ne.0) goto 1000
  980 continue
      if(is(1,2,i).eq.(-2).and.abs(ts(2,i)).lt.1e-6) ihalf= -1
      if(is(1,2,i).eq.2.and.abs(ts(2,i)-0.5).lt.1e-6) ihalf=1
 1000 continue
      nsym=neqv*(icent+1)*mlat
c     set up constants
      ca=cos(dtor*cell(4))
      cb=cos(dtor*cell(5))
      cc=cos(dtor*cell(6))
      v=cell(1)*cell(2)*cell(3)*sqrt(1.0-ca*ca-cb*cb-cc*cc+2.0*ca*cb*cc)
      dxmax(1)=dm*cell(2)*cell(3)*sin(dtor*cell(4))/v
      dxmax(2)=dm*cell(3)*cell(1)*sin(dtor*cell(5))/v
      dxmax(3)=dm*cell(1)*cell(2)*sin(dtor*cell(6))/v
      dm=dm*dm
c     set up matrix to calculate distances and angles
      do 1020 i=4,6
      j=8/i
      k=15/i
      t(j,k)=cos(dtor*cell(i))
      t(k,j)=t(j,k)
 1020 continue
      do 1060 i=1,3
      t(i,i)=1.0
      do 1040 j=1,3
      t(i,j)=t(i,j)*cell(i)*cell(j)
 1040 continue
 1060 continue
c     if (ihalf.ne.0) write(lo,1080)
c1080 format (/22x,76h** since space group symmetry permits, only half t
c    1he map will be searched **)
c     search map for peak positions and record peak heights
      call pksrch(anat,nstore,ihalf,mode,ier)
 2000 return
      end
c     ------------------------------------------------------------------
c     retrieve centring translations
      subroutine centre(j,l)
      common /cent/ tl(3,4),fs(216),mlat
      dimension tst(21)
      data tst/0.,0.,0., 0.,0.5,0.5, 0.5,0.,0.5, 0.5,0.5,0., 0.5,0.5,0.5
     1 , 0.333333,0.666667,0.666667, 0.666667,0.333333,0.333333/
      mlat=j
      m=3*l-2
      tl(1,j)=tst(m)
      tl(2,j)=tst(m+1)
      tl(3,j)=tst(m+2)
      return
      end
c     ------------------------------------------------------------------
      subroutine rdsect(nr3d,max,nnxp2,nnz,nxz3)
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common /sdir/ dm,npc,nproj,nojoin
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common /kuse/ kuser1,kuser2,kuser3
      dimension  nr3d(kuser3)
      if (max .ge. nxz3) max = 0
      mx = max
      max = max - 2
      do 1320 iz=1,nnz
      min = max + 3
      max = max + nnxp2
      read (jrel)(nr3d(ix),ix=min,max)
      nr3d(max+1) = nr3d(min)
      nr3d(max+2) = nr3d(min+1)
 1320 continue
      min = max + 3
      max = max + nnxp2 + nnxp2 + 2
      do 1340 ix=min,max
      mx = mx + 1
      nr3d(ix) = nr3d(mx)
 1340 continue
      return
      end
c     ------------------------------------------------------------------
c     sort peaks in order of peak height or in order of plotting
      subroutine sortf(x,nats,n)
      common /kuse/ kuser1,kuser2,kuser3
      dimension x(5,kuser2),t(5)
      int=2
 1000 int=int+int
      if(int.lt.nats)go to 1000
      int=min0(nats,(3*int)/4-1)
 1020 int=int/2
      ifin=nats-int
      do 1200 ii=1,ifin
      i=ii
      j=i+int
      if(x(n,i).ge.x(n,j))go to 1200
      do 1060 k=1,5
      t(k)=x(k,j)
 1060 continue
 1080 do 1100 k=1,5
      x(k,j)=x(k,i)
 1100 continue
      j=i
      i=i-int
      if(i)1140,1140,1120
 1120 if(x(n,i).lt.t(n))go to 1080
 1140 do 1160 k=1,5
      x(k,j)=t(k)
 1160 continue
 1200 continue
      if(int.ne.1)go to 1020
      return
      end
c     ------------------------------------------------------------------
c     function used in the calculation of distances and angles
      function quadr(x1,x2,t)
      dimension x1(3),x2(3),t(3,3)
      quadr=0.0
      sum=0.0
      do 1000 i=1,3
      q1    = t(i,1)*x1(1)
      q2    = t(i,2)*x1(2)
      q3    = t(i,3)*x1(3)
      qq    = q1+q2+q3
      qqp   = x2(i)*qq
      sum=sum+qqp
c     quadr = quadr+x2(i)*(t(i,1)*x1(1)+t(i,2)*x1(2)+t(i,3)*x1(3))
 1000 continue
      quadr = sum
      return
      end
c     ------------------------------------------------------------------
c     apply j'th symmetry element to x,y,z & put result in xn
      subroutine oper(j,xn,x,y,z)
      dimension xn(3)
      common /cent/ tl(12),fs(216),mlat
      common /tape/ cell(6),neqv,icent,lat,natm,ts(72  ),is(2,3,24),nsym
     *             ,dumb(3)
      isym=mod(j,neqv)
      if(isym.eq.0) isym=neqv
      ip=(j-1)/neqv
      ilat=3*mod(ip,mlat)
      jt=3*(isym-1)
      jj=9*isym-8
      do 20 l=1,3
      ind1=jt+l
      ind2=ilat+l
      xn(l)=x*fs(jj)+y*fs(jj+1)+z*fs(jj+2)
      if(ip.ge.mlat) xn(l)=-xn(l)
      xn(l)=xn(l)+ts(ind1)+tl(ind2)
      jj=jj+3
   20 continue
      return
      end
c----------------------------------------------------------------------
c     find positions of peaks by fitting quadratic function to 19 points
      subroutine pksrch(anat,nr3d,ihalf,mode,ier)
      common /atoms/ x(5,200),icvet(200),idumx(21)
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common /sdir/ dm,npc,nproj,nojoin
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common /kuse/ kuser1,kuser2,kuser3
      common /misc/ t(3,3),dxmax(3),mconx,iwt,fom(11),pts
      common /tape/ cell(6),neqv,icent,lat,natm,ts(3,24),is(2,3,24),nsym
     *             ,dumb(3)
      common /ureq1/ jpatt,jpunt(501),ksacc,jseteq,jumpp,jmpsie,nsec
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,bfac(200),lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      dimension  nr3d(kuser3), xs(3), x1(3), idiff(19), b(19)
      dimension xo(11),xn(11),key(10),newvet(48,3)
c
c     input dimensions of e-map and check array size
      read (jrel) nnx,nnz,nny
c     halve y-axis if possible
      nnyold=nny
      if (ihalf.ne.0) nny=nny-nny/2
      nnxp2 = nnx + 2
      nxz = nnxp2 * (nnz + 2)
      nxz3 = 3 * nxz
      if (nxz3 .le. kuser3) go to 1020
      write (lo,940) kuser3, nxz3
  940 format(//33h not enough room in array nstore.,10x,18hspace availab
     1le  =,i7,10x,17hspace required  =,i7)
      ier=-1
      return
c     initialise constants
 1020 dx = 1.0 / float(nnx)
      dy = 1.0/float(nnyold)
      dz = 1.0/float(nnz)
      level = 0
      limit = min0(kuser2, 2*nats)
c     set up table of offsets to look up 19 points in e-map
 1100 idiff(1) = -nxz - 1
      idiff(2) = -nxz - nnxp2
      idiff(3) = -nxz
      idiff(4) = -nxz + nnxp2
      idiff(5) = -nxz + 1
      idiff(6) = -nnxp2 - 1
      idiff(7) = -1
      idiff(8) = nnxp2 - 1
      idiff(9) = -nnxp2
      idiff(10) = 0
      do 1120 i=1,9
      j=20-i
      idiff(j) = -idiff(i)
 1120 continue
c     initialise variables
      no = 0
      iy = -1
      ny = 0
c     if (level .eq. 0) go to 1300
c     reposition file to read in first two sections again
 1200 rewind jrel
      read(jrel)
      read(jrel)
      if (iy+2.eq.nnyold) goto 1400
c     read in first section (end of last unit cell)
 1300 max=nxz
      iskip=nnyold-1
      do 1305 i=1,iskip
      read (jrel)
 1305 continue
      call rdsect(nr3d,max,nnxp2,nnz,nxz3)
      rewind jrel
c     read second section (start of unit cell)
      read(jrel)
      read(jrel)
      call rdsect(nr3d,max,nnxp2,nnz,nxz3)
c     read in the next section
 1400 mx = max - nxz + nnx + 1
      call rdsect(nr3d,max,nnxp2,nnz,nxz3)
      iy = iy + 1
      ny = mod(ny+2, 3) - 1
      kk = nxz3
      if (ny) 1440,1460,1500
 1440 kk = -nxz3
 1460 do 1480 i=1,5
      idiff(i) = idiff(i) - kk
 1480 continue
      if (ny .eq. 0) go to 1540
 1500 do 1520 i=15,19
      idiff(i) = idiff(i) - kk
 1520 continue
c     search one section of the e-map
 1540 do 2000 iz=1,nnz
      mn = mx + 3
      mx = mx + nnxp2
      do 1980 ix=mn,mx
      if (nr3d(ix) .lt. level) go to 1980
c     locate grid point with maximum density
      do 1560 i=1,9
      j = idiff(i) + ix
      if (nr3d(ix) .le. nr3d(j)) go to 1980
 1560 continue
      do 1580 i=11,19
      j = idiff(i) + ix
      if (nr3d(ix) .lt. nr3d(j)) go to 1980
 1580 continue
c     fit quadratic function to 19 points
c     dens = a + c*x + d*y + e*z - 0.5*f*(x*x + y*y + z*z)
      do 1600 i=1,19
      j = idiff(i) + ix
      b(i) = nr3d(j)
 1600 continue
      b1 = b(3) + b(7) + b(9) + b(11) + b(13) + b(17)
      b2 = b(1) + b(2) + b(4) + b(5) + b(6) + b(8) + b(12) + b(14) +
     1  b(15) + b(16) + b(18) + b(19)
      f = (30.0 * b(10) + 11.0 * b1 - 8.0 * b2) / 63.0
      c = (b(5)+b(12)+b(13)+b(14)+b(19)-b(1)-b(6)-b(7)-b(8)-b(15))/10.0
      deltax = c / f
      if (abs(deltax) .gt. 1.0) go to 1620
      d = (b(15)+b(16)+b(17)+b(18)+b(19)-b(1)-b(2)-b(3)-b(4)-b(5))/10.0
      deltay = d / f
      if (abs(deltay) .gt. 1.0) go to 1620
      e = (b(4)+b(8)+b(11)+b(14)+b(18)-b(2)-b(6)-b(9)-b(12)-b(16))/10.0
      deltaz = e / f
      if (abs(deltaz) .le. 1.0) go to 1640
 1620 deltax = 0.0
      deltay = 0.0
      deltaz = 0.0
 1640 xx = (float(ix-mn+1) + deltax) * dx
      yy = (float(iy) + deltay) * dy
      zz = (float(iz) + deltaz) * dz
c     peak height interpolation - not suitable if peak shape is poor
c     a = (9.0 * b(10) + 4.0 * b1 - b2) / 21.0
c     b(10) = amax1(a+0.5*(c*deltax+d*deltay+e*deltaz), b(10))
      nop1 = no+1
      x(1,nop1) = xx
      x(2,nop1) = yy
      x(3,nop1) = zz
      x(4,nop1) = b(10)
      if (no .eq. 0) go to 1820
      ir=0
c     if two peaks are closer than dm angstroms eliminate the smaller
      do 1800 k=1,nsym
      call oper(k,xs,xx,yy,zz)
      do 1780 i=1,no
      do 1720 l=1,3
      x1(l) = x(l,i) - xs(l)
 1680 if (abs(x1(l)) .le. 0.5) go to 1700
      x1(l) = x1(l) - sign(1.0, x1(l))
      go to 1680
 1700 if (abs(x1(l)) .gt. dxmax(l)) go to 1780
 1720 continue
      if (quadr(x1,x1,t) .gt. dm) go to 1780
      if(ir.gt.0) x(4,ir)=0.0
      ir=0
      if (b(10) .le. x(4,i)) go to 1980
      x(1,i) = xx
      x(2,i) = yy
      x(3,i) = zz
      x(4,i) = b(10)
      ir=i
 1780 continue
 1800 continue
      if(ir.gt.0) go to 1980
 1820 no = nop1
      if (no .lt. limit) go to 1980
      call sortf(x,no,4)
      no = npic
      level = x(4,npic) + 0.5
 1980 continue
 2000 continue
      if (iy .ge. nny) go to 2100
      if (iy - nnyold + 2) 1400,1200,1400
c     sort peaks in order of peak height
 2100 continue
      call sortf(x,no,4)
      nnn = min0(no,npic)
      if (nnn .eq. npic) go to 2200
c     insufficient peaks found - lower scan level and try again
      level = level - 100
      if(level.ge.(-200)) go to 1100
      npic=no
 2200 continue
c     analize special position to fix the correct number
c     of peaks to consider in interpretation
      fnatm=float(natm)
      fnatm=amax1(anat,fnatm)
      focct=0.2*anat+anat
      tot=0.0
      itot=0
      iactn=1
      non=1
      nbad=0
      do 2250 i=1,no
      xo(1)=x(1,i)
      xo(2)=x(2,i)
      xo(3)=x(3,i)
      iser=i
      iactn=1
      khead=0
      ksp=kspecb(newvet,xo,xn,key,itype,iser,khead,iactn)
      occ=1.0/float(key(10))
      if (occ.gt.focct) then
                          x(4,i)=-999999
                          nbad=nbad+1
                        endif
 2250 continue
      if (nbad.gt.0) then
                       call sortf(x,no,4)
                       no=no-nbad
                     endif
      do 2300 i=1,no
      xo(1)=x(1,i)
      xo(2)=x(2,i)
      xo(3)=x(3,i)
      hei =x(4,i)
      iser=i
      iactn=1    ! da modificare 
      khead=0
      ksp=kspecb(newvet,xo,xn,key,itype,iser,khead,iactn)
      occ=1.0/float(key(10))
      x(5,i) = occ
c     write(6,'(i3,1h),6x,5f8.5)') i,(x(iii,i),iii=1,5)
      tot=tot+occ
      icvet(i)=0
      if (x(4,i).gt.0.001) non=i
      if (tot.gt.fnatm) go to 2300
      itot=i
 2300 continue
c     write(6,*) no,non
c--NEW--
      no=non
c--NEW--
c
      if (jpatt.ne.0) then
                       nats=itot
                     else
                       if (npc.le.0) then
                               nats =  min0((11*itot+13)/9, kuser2-20)
                               npic =  min0((3*itot+1)/2  , kuser2-20)
                                     endif
c
c--NEW--
      if (no.lt.5) then
                     nats=no
                   else
                     if (nats.lt.5) nats=5
                   endif
      if (itot.eq.0) itot=nats
c--NEW--
c     write(6,*) no,itot,npic,nats
      npic=min0(npic,no)
      nats=min0(nats,no)
c
      if (npic.gt.nats) nats=npic
c     write(6,*) no,itot,npic,nats
      if (jrest.ne.0) nemap(3)=itot
      if(jrecyc.eq.0) then
                        nemap(2)=nats
                      else
      if(krecy.ne.0) then
                       nemap(2)=nemap(3)+(nats-nemap(3))*erre**0.5
                       if(nemap(2).gt.nats) nemap(2)=nats
                       nats=nemap(2)
                     else
                       nemap(2)=nemap(3)+(nats-nemap(3))*erre**0.2
                       if(nemap(2).gt.nats) nemap(2)=nats
                       nats=nemap(2)
                     endif
                      endif
      nemap(4)=0
      nemap(1)=nats
      nemap(3)=itot
                     endif
c-- create list 15 ( E-map peaks )
c     write(6,*) no,itot,npic,nats
c
c-- move coordinates of first peak 
c-- if it is in special position
*     if (x(5,1).lt.0.95) then
*         xo(1)=x(1,1)
*         xo(2)=x(2,1)
*         xo(3)=x(3,1)
*         iser=1
*         iactn=2    ! da modificare 
*         khead=0
*         ksp=kspecb(newvet,xo,xn,key,itype,iser,khead,iactn)
*         x(1,1)=xn(1)
*         x(2,1)=xn(2)
*         x(3,1)=xn(3)
*       endif
      interp=0
      call frm15(nats,numset,interp)
      return
      end
c-----------------------------------------------------------------------
      subroutine inptf(npseud,numb)
c--
c-- input subroutine
c--
      common /atoms/ xyz(5,200),icvet(200),idumx(21)
      common /refl/ ih(100),g(2,100)
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common /kuse/ kuser1,kuser2,kuser3
      common /tran/ scale,mh(3),level,it4,xlim(3)
      common /tape/ cell(6),neqv,icent,lat,natm,ts(3,24),is(2,3,24),nsym
     *             ,dumb(3)
      common /sdir/ dm,npc,nproj,nojoin
c
      common/ureq/ ihx(3),ksigma,knw,jpart,jtran,fosog,nonos,iprin,iflag
      common /ureq1/ jpatt,jpunt(501),ksacc,jseteq,jumpp,jmpsie,nsec
      common/rc/p(6),cx(9),nref,nb,rhomax,mm,en,mz,er,th,rhomin
      common/c/flgw(30),flgd(30),avr(30),dcv(50),slope,flgk,bt,sc,del,ks
      common /erl/ kmat(48,3,3),tmat(48,3),nt(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/sym/isn(2,3,24),tsn(3,24),nnsym,pts,ksys,ncent,latt,s3s2,
     *          emme,s3s2p
      common /misc/ t(3,3),dxmax(3),mconx,iwt,fom(11),ptsnew
      common /dd/ a2,b2,c2,ab,ac,bc,bterm,wscale
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,nat,f(9),nalf(8)
      dimension abc(3),ang(3)
c
      call yfl01
      if (jpatt.eq.0) then
      call yfl02
                endif
      do 10 i=1,24
      do 10 j=1,3
      ts(j,i)=tsn(j,i)
      do 10 k=1,2
      is(k,j,i)=isn(k,j,i)
   10 continue
      call yfl03
      call ysfl07(nref,mm,idum1,npseud,idum3)
      if (jpatt.eq.0) then
      numb=mm
      else 
      numb=nref
      endif
      do 20 i=1,3
         abc(i)=cx(i)
         cell(i)=cx(i)
         ang(i)=cx(i+3)*pi/180.0
         cell(i+3)=cx(i+3)
         mh(i)=ihx(i)
   20 continue
      a2=abc(1)*abc(1)
      b2=abc(2)*abc(2)
      c2=abc(3)*abc(3)
      ab=2.0*abc(1)*abc(2)*cos(ang(3))
      ac=2.0*abc(1)*abc(3)*cos(ang(2))
      bc=2.0*abc(2)*abc(3)*cos(ang(1))
      bterm=bt
      wscale=sc
      ptsnew=pts
      neqv = nnsym
      icent=ncent
      lat=latt
      anat=float(nat)/(pts*float((icent+1)*nnsym))
      natm=int(anat+0.5)
c
      nsym2=neqv
      if (icent.eq.1) then
c--
c-- generation of matricies deriving from -1
c--
                        nsym2=2*neqv
                        do 30 k=1,neqv
                           do 30 i=1,3
                              tmat(k+neqv,i)=tmat(k,i)
                              do 30 j=1,3
                                 kmat(k+neqv,i,j)=-kmat(k,i,j)
   30                         continue
                      endif
      return
      end
c--------------------------------------------------------------------
      subroutine dirfou(jpfile,ier)
      character line*80,dire*80,diret*80,buff*2,filet*80
      character blank,digit*12,card(100)*80,ffile*80
      common /comdir/ icomq(200,2),maxcom,ipcom,ipdir,icomat
      common /chara/ blank,digit,card,ffile
      common /tran/ scale,mh(3),level,it4,xlim(3)
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common /impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
      common/ureq/ ihx(3),ksigma,knw,jpart,jtran,fosog,nonos,iprin,iflag
      common /ureq1/ jpatt,jpunt(501),ksacc,jseteq,jumpp,jmpsie,nsec
      common /sdir/ dm,npc,nproj,nojoin
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common /misc/ t(3,3),dxmax(3),mconx,iwt,fom(11),pts
      common/inpcl/ntype,ttype(10,5),nprojx,nbond,dmaxi,radnew(8)
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,nat,f(9),nalf(8)
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,bfac(200),lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      common/spec/ soper(3,4,24),centrt(7,12),aaa(6),noper,ncentr,icentx
     *        ,kpol,jsys,latx,indv(32),mpv(64),jspini,ddmin,ncawu,ncwu
      dimension vet(40),ivet(40)
      dimension ltype(10,5)
      equivalence (ltype(1,1),ttype(1,1))
c-- set default values
c
      jspini = -1
      do 10 i=1,nk
   10 radnew(i)=-1.0
      fomin=-1.0
      tsigma=-1.0
      nsec=1
      jrecyc=-100
      dmaxi=0.0
      jpfile=0
      ntype=0
      do 20 i=1,5
      do 20 j=1,10
   20 ttype(j,i)=0
      jmpsie= 0
      iprin = 0
      ibl   = 0
      nproj = 0
      nbond = 1
      npc   = 0
      nojoin= 0
      it4   = 0
      numset= 0
      factr= 1.0/3.0
      level = 100
      xlim(1)=1.0
      xlim(2)=1.0
      xlim(3)=1.0
      ks    = 1
      ic=0
      icmax=icomq(icomat,2)
c
  100 continue
      ic=ic+1
      if (ic.gt.icmax) go to 8000
      ipdir=ipdir+1
      line=card(ipdir)
      diret=line
      call cutst(line,lenp,dire,lend)
      call lcase(dire)
      if (dire(1:4).eq.'layy') then
          nsec=1
          go to 100
          endif
      if (dire(1:4).eq.'layx') then
          nsec=2
          go to 100
          endif
      if (dire(1:4).eq.'layz') then
          nsec=3
          go to 100
          endif
C     if (dire(1:4).eq.'plot') then
c
c 1-st card : keys for following coordinates
c             6 = atomic specie
c             7 = serial number
c             5 = peak intensity
c         1-2-3 = x-y-z
c             4 = occupancy factor
c             8 = dummy
c
C         jpfile=kform
C         read(line,'(a)') filet
C         nlen=80
C         istat=2
C         iform=1
C         if (jopen(jpfile,filet,nlen,istat,iform,ier).ne.0) go to 9100
C         go to 100
C         endif
      if (dire(1:4).eq.'frag') then
          jpfile=kform
          read(line,'(a)') filet
          nlen=80
          istat=2
          iform=1
          if (jopen(jpfile,filet,nlen,istat,iform,ier).ne.0) go to 9100
          jpfile=-jpfile
          go to 100
          endif
c     if (dire(1:4).eq.'form') then
c         write(7,*) lenp,line
c         if (lenp.le.0) go to  9000
c         pfmt=line
c         go to 100
c         endif
      if (dire(1:4).eq.'radi') then
          call cutst(line,lenp,dire,lend)
          if (lend.le.0) go to 9000
          call lcase(dire(1:2))
          read(dire(1:2),'(a2)') irad
          j=0
          do 150 i=1,nk
          if (nalf(i).eq.irad) j=i
  150     continue
          if (j.eq.0) then
                        write(lo,8030) irad
                        go to 9000
                      endif
          iopt=0
          call getnum(line,vet,ivet,iv,iopt)
          if (iv.ne.1) go to 9000
          radnew(j)=vet(1)
          go to 100
          endif
      if (dire(1:4).eq.'coor') then
          ntype=ntype+1
          call cutst(line,lenp,dire,lend)
          if (lend.le.0) go to 9000
          call lcase(dire(1:2))
          read(dire(1:2),'(a2)') ttype(ntype,1)
          iopt=0
          call getnum(line,vet,ivet,iv,iopt)
          if ((vet(2)-vet(1)).gt.0.0001) then
                                           ttype(ntype,2)=vet(1)
                                           ttype(ntype,3)=vet(2)
                                         else
                             write(lo,6000) diret,ttype(ntype,1)
                                           ntype=ntype-1
                                         endif
 6000 format(' *** warning ***  minimum and maximum are zero or wrong',
     *     /,'                  in directive ',a80,
     *     /,'                  default values',
     *       ' for element ',a2,' will be used')
          if (iv.le.2) go to 100
          itype=ivet(3)
          if (itype.ge.0.and.itype.le.3) then
                                           ltype(ntype,4)=itype
                                         else
                                           write(lo,7000) itype
                                           go to 9000
                                         endif
 7000 format(' coordination type = ',i5,'  not expected')
          go to 100
          endif
c-- directives with numeric parameters
      iopt=0
      call getnum(line,vet,ivet,iv,iopt)
      if (iopt.eq.-1) go to 9000
      if (dire(1:4).eq.'fomi') then
          if (iv.ne.1) go to 9000
          fomin=vet(1)
          go to 100
          endif
      if (dire(1:4).eq.'sigm') then
          if (iv.ne.1) go to 9000
          tsigma=vet(1)
          go to 100
          endif
      if (dire(1:2).eq.'ls') then
          if (iv.ne.1) go to 9000
          lsx=ivet(1)
          go to 100
          endif
      if (dire(1:4).eq.'peak') then
          if (iv.ne.1) go to 9000
          npc=ivet(1)
          go to 100
          endif
      if (dire(1:4).eq.'prin') then
          if (iv.ne.1) go to 9000
          iprin = ivet(1)
          go to 100
          endif
      if (dire(1:4).eq.'dmax') then
          if (iv.ne.1) go to 9000
          dmaxi=vet(1)
          go to 100
          endif
      if (dire(1:4).eq.'proj') then
          if (iv.ne.1) go to 9000
          nproj=ivet(1)
          go to 100
          endif
      if (dire(1:4).eq.'noin') then
          if (iv.ne.0) go to 9000
          nojoin=1
          go to 100
          endif
      if (dire(1:4).eq.'psej') then
          if (iv.ne.0) go to 9000
          jmpsie= 1
          go to 100
          endif
      if (dire(1:3).eq.'set' ) then
          if (iv.ne.1) go to 9000
          numset=ivet(1)
          go to 100
          endif
      if (dire(1:3).eq.'tan' ) then
          if (iv.ne.0) go to 9000
          numset=1001
          go to 100
          endif
      if (dire(1:3).eq.'kno' ) then
          if (iv.ne.0) go to 9000
          numset=1000
          go to 100
          endif
      if (dire(1:3).eq.'rec' ) then
          if (iv.eq.1) jrecyc=-ivet(1)
          go to 100
          endif
      if (dire(1:4).eq.'leve') then
          if (iv.ne.1) go to 9000
          level=ivet(1)
          go to 100
          endif
      if (dire(1:4).eq.'grid') then
          if (iv.ne.1) go to 9000
          factr=vet(1)
          go to 100
          endif
      if (dire(1:4).eq.'limi') then
          if (iv.ne.3) go to 9000
          do 7500 i=1,3
 7500     xlim(i)=amin1(vet(i),1.0)
          go to 100
          endif
      if (dire(1:3).eq.'map' ) then
          if (iv.ne.0) go to 9000
          it4=lo
          go to 100
          endif
      write(lo,6500) diret
 6500 format(' wrong directive on following line:',/a)
      ier=-1
      return
 8000 continue
      if (tsigma.gt.0.0.and.ksigma.eq.0) then
                                           write(lo,8005)
                                           tsigma=-1.0
                                         endif
 8005 format(' *** warning ***  no suitable sigma(F) in data',/,
     *       '                  SIGMA directive ignored')
      nprojj=nproj
      if (ntype.gt.0) then
                        do 8020 i=1,ntype
                        write(buff,'(a2)') ttype(i,1)
                        read (buff,'(a2)') itype
                        do 8010 j=1,nk
                           if (itype.ne.nalf(j)) go to 8010
                           go to 8020
 8010                   continue
                        write(lo,8030) ttype(i,1)
                        go to 9000
 8020                   continue
                      endif
 8030 format(' Element ',a2,' not present in the declared content')
      return
 9000 continue
      ier=-1
      write(lo,'(22h error in directive : ,a80)') diret
      return
 9100 continue
      write(lo,9110) ier,filet
 9110 format(' *** error ***  open error - code =',i5,
     *'.  Fragment file name is ',a)
      ier=-1
      return
      end
c-----------------------------------------------------------------------
c     get peaks to plot
      subroutine getplt(jpfile,ier)
      character*2 diret
      character*80  line,dire
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common /atoms/ x(5,200),nz(200),idumx(21)
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,nat,f(9),nalf(8)
      common/spec/ soper(3,4,24),centrt(7,12),aaa(6),noper,ncentr,icent,
     *         kpol,jsys,lat,indv(32),mpv(64),jspini,ddmin,ncawu,ncwu
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,bfac(200),lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      common /temp/ conn(9800)
      dimension itype(80),i(20),vi(40),vet(40) ,lini(40),iv(40)
      dimension ix(5,200)
      dimension xo(11),xn(11),key(10),newvet(48,3)
      equivalence (ix,x)
c
c--parameter   x y z occ int ty serial
c--code number 1 2 3  5   4  6	 7
c
c
      conn(1)=-1
      if (jpfile.gt.0) then
                         kfrag= jpfile
                       else
                         kfrag=-jpfile
                       endif
      nats=0
      do 1 j=1,40
    1 lini(j)=0
      do 2 j=1,200
      do 2 ij=1,5
2     x(ij,j)=0
      if (jpfile.gt.0) then
                         read(kfrag,'(a)',end=300)line
                         iopt=0
                         call shift(line,nn)
                         call getnum(line,vet,lini,in,iopt)
                         if (iopt.eq.-1) go to 650
                       else
                         in=4
                         lini(1)=6
                         lini(2)=1
                         lini(3)=2
                         lini(4)=3
                       endif
      do 5 j=1,in
      i(j)=0
      nn=j
      i(j)=lini(j)
      if(lini(j).gt.0.and.lini(j).le.7) go to 5
      nn=j-1
    5 continue
      jtype=0
      if (i(1).eq.6) then
                       jtype=1
                       do 10 j=1,nn-1
   10                  i(j)=i(j+1)
                       i(nn)=0
                       nn=nn-1
                     endif
  100 nats=nats+1
      izz=6
      read(kfrag,'(a)',end=300)line
      call shift(line,kk)
      if (jtype.eq.1) then
                        call cutst(line,lenp,dire,lend)
                        call lcase(dire)
                        if (lend.gt.2) go to 106
                        do 105 j=1,nk
                        write(diret,'(a2)')nalf(j)
                        if (dire.eq.diret) then
                                             izz=no(j)
                                             go  to 106
                                           endif
  105                   continue
                        go to 650
  106                   continue
                      endif
      nz(nats)=izz*100+1
      iopt=0
      call getnum(line,vi,iv,in,iopt)
      do 110 j=1,nn
      if (i(j).eq.0) go to 110
      if (i(j).lt.6) x(i(j),nats)=vi(j)
  110 continue
      go to 100
  300 nats=nats-1
      close(kfrag)
      call xspinb
      if (jpfile.lt.0) then
                         iactn=1
                         do 400 j=1,nats
                         izz=nz(j)/100
                         do 350 k=1,nk
                         if (izz.eq.no(k)) then
                                             nz(j)=k*100+1
                                             x(4,j)=izz*100+k
                                           endif
  350                    continue
                         xo(1)=x(1,j)
                         xo(2)=x(2,j)
                         xo(3)=x(3,j)
                         iser=j
                         iactn=1
                         khead=0
             ksp=kspecb(newvet,xo,xn,key,itype,iser,khead,iactn)
                         x(5,j) = 1.0/float(key(10))
  400                    continue
                       endif
      call sortf(x,nats,4)
      do 430 j=1,nats
      k=x(4,j)
      k=mod(k,100)
      nz(j)=k*100+1
  430 continue
      numset=1
      interp=0
      call frm15(nats,numset,interp)
      call inptf(npseud,numb)
      nemap(4)=jpfile
c
      if (jpfile.lt.0) jpfile=-jpfile
c
      pop=ncentr*(float((icent+1)*noper))
      write(lo,450) nats,pop
  450 format(//,
     * 25x,30hFragment : known positions for,i5,
     1 29h  atoms having multiplicity =,f5.1,//,
     2 28x,'type',12x,'x',14x,'y',14x,'z',12x,'occ',/)
      do 600 j=1,nats
      k=nz(j)/100
      write(diret,'(a2)') nalf(k)
      call ucase(diret(1:1))
      write(lo,550) diret,(x(jj,j),jj=1,3),x(5,j)
  550 format(1h ,28x,a2,4f15.4)
  600 continue
      return
  650 continue
      write(lo,700)
  700 format(//,' *** error ***  check coordinate file ',/)
      ier=-1
      return
      end
c-----------------------------------------------------------------------
      subroutine pp1 (x, nsize, nx, ny, nz,ier)
      real x(nsize)
      integer  p1, p2, r, skip, recs,  d(5)
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common /kuse/ kuser1,kuser2,kuser3
      common /tran/ scale,mh(3),level,it4,xlim(3)
      common /tape/ cell(6),neqv,icent,lat,natm,ts(3,24),is(2,3,24),nsym
     *             ,dumb(3)
      common /pollo/ nuva(800),numr
      common /new/ ntime
c
      do 10 i=1,800
   10 nuva(i)=0
      p1 = nsize/(2*ny*(mh(3) + 1))
      p2 = nsize/(nx*nz)
      if (p1 .le. 0 .or. p2 .le. 0) go to 300
c
c     pass one. transform on k and write intermediate results on ifour
c
      rewind ifour
      numr=0
      r = -mh(1)
  100 if (r + p1 .gt. mh(1)) p1 = mh(1) + 1 - r
      call read kln(x, ny, mh(3)+1, p1, r)
      d(1) = 2*(ny*p1*(mh(3)+1))
      d(2) = 2
      d(3) = d(1)
      d(4) = d(1)
      d(5) = 2*ny
      call cmplftn(x(1), x(2), nsize, ny, d,ier)
      if (ier.lt.0) return
      call write yn(x, ny, mh(3)+1, p1, p2)
      r = r + p1
      if (r .le. mh(1)) go to 100
c
c     end of pass 1.  pass 2 reads back the intermediate results,
c     calculates the transforms on h and l, and writes out the final
c     y sections.
c
      rewind jrel
      write(jrel) itle,numset,cell,neqv,icent,lat,natm,ts,is
      write(jrel) nx,nz,ny
c
      rewind ifour
      numr=0
      skip = 0
      r = 0
      p1 = nsize/(2*ny*(mh(3) + 1))
      recs = (ny - 1)/p2
      ntime=0
  200 if (r + p2 .gt. ny) p2 = ny - r
      call read hln(x, nx, nz/2, p2, mh(1), mh(3), p1, skip, recs)
      if (r + p2 .lt. ny) rewind ifour
      if(r + p2 .lt. ny) numr=0
      skip = skip + 1
c
c     x now contains intermediate results stored with l down the
c     columns and h across the rows.
c
      d(1) = nx*nz*p2
      d(2) = nz
      d(3) = nz*nx
      d(4) = 2*(mh(3) + 1)
      d(5) = 2
      call cmplftn(x(1), x(2), nsize, nx, d,ier)
      if (ier.lt.0) return
      d(2) = 2
      d(3) = d(1)
      d(4) = d(1)
      d(5) = nz
      call hermftn(x(1), x(2), nsize, nz/2, d,ier)
      if (ier.lt.0) return
      call outpufn(x, nz, nx, p2, r, ny)
      ntime =ntime+1
      r = r + p2
      if (r .lt. ny) go to 200
c
c     end of job
c
      return
c
  300 p1 = 2*ny*(mh(3)+1)
      p2 = nx * nz
      write(lo,350) nsize, p1, p2
  350 format(/,8x,37hrequest too large. space available is,i10,
     1 33h and space requested is larger of,i10,4h and,i10)
      ier=-1
      return
      end
c     ------------------------------------------------------------------
      subroutine cmplftn(x, y, nsize, n, d,ier)
      real x(nsize), y(nsize)
      integer d(5),pmax,psym,twogrp,factor(15),sym(15),unsym(15)
c
c     complex finite discrete fourier transform
c     transforms one dimension of multi-dimensional data
c     modified by l. f. ten eyck from a one-dimensional version written
c     by g. t. sande, 1969.
c
c     this program calculates the transform
c               (x(t) + i*y(t))*(cos(2*pi*t/n) - i*sin(2*pi*t/n))
c
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      p max = 5
      two grp = 4
c
      call s r fpn(n, p max, two grp, factor, sym, p sym, un sym,ier)
      if (ier.lt.0) return
      call mdftkdn(n, factor, d, x, y, nsize)
      call diprpn(n, sym, p sym, un sym, d, x, y, nsize)
      return
      end
c     ------------------------------------------------------------------
      subroutine s r fpn(pts,pmax,two grp,factor,sym,p sym,un sym,ier)
c     symmetrized reordering factoring program
c
      integer pts,pmax,two grp,p sym, factor (10), sym (10), un sym (10)
      integer pp(14), qq (7), f,p,p two,q,r
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
c
      nest=14
c
      n=pts
      p sym=1
      f=2
      p=0
      q=0
  100 if (n.le.1) go to 500
      do 200 j=f,pmax
      if (n.eq.(n/j)*j) go to 300
  200 continue
      ier=-1
      return
  300 f=j
      n=n/f
      if (n.eq.(n/f)*f) go to 400
      q=q+1
      qq(q)=f
      go to 100
  400 n=n/f
      p=p+1
      pp(p)=f
      p sym=p sym*f
      go to 100
c
  500 r=1
      if (q.eq.0) r=0
      if (p.lt.1) go to 700
      do 600 j=1,p
      jj=p+1-j
      sym(j)=pp(jj)
      factor(j)=pp(jj)
      jj=p+q+j
      factor(jj)=pp(j)
      jj=p+r+j
      sym(jj)=pp(j)
  600 continue
  700 if (q.lt.1) go to 900
      do 800 j=1,q
      jj=p+j
      un sym(j)=qq(j)
      factor(jj)=qq(j)
  800 continue
      sym(p+1)=pts/p sym**2
  900 jj=2*p+q
      factor(jj+1)=0
      p two=1
      j=0
 1000 j=j+1
      if (factor(j).eq.0) go to 1200
      if (factor(j).ne.2) go to 1000
      p two=p two*2
      factor(j)=1
      if (p two.ge.two grp) go to 1100
      if (factor(j+1).eq.2) go to 1000
 1100 factor(j)=p two
      p two=1
      go to 1000
 1200 if (p.eq.0) r=0
      jj=2*p+r
      sym(jj+1)=0
      if (q.le.1) q=0
      un sym(q+1)=0
      return
      end
c     ------------------------------------------------------------------
      subroutine diprpn(pts, sym, p sym, un sym, dim, x, y, nsize)
c     double in place reordering program
c
      real x(nsize), y(nsize)
      integer sym(10), un sym(10), dim(5), pts, psym, dk, p un sym, test
      logical one mod
      integer sep, delta, p, p0, p1, p2, p3, p4, p5, size
      integer v(14), modulo(14), s(14), u(14)
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
c
      nest=14
c
      nt = dim(1)
      sep = dim(2)
      p2 = dim(3)
      size = dim(4) - 1
      p4 = dim(5)
      if (sym(1).eq.0) go to 500
      do 100 j=1,nest
      u(j)=1
      s(j)=1
  100 continue
      n=pts
      do 200 j=1,nest
      if (sym(j).eq.0) go to 300
      jj=nest+1-j
      u(jj)=n
      n=n/sym(j)
      s(jj)=n
  200 continue
  300 jj=0
      l=1
      v(1)=1
  310 l=l+1
      v(l)=v(l-1)
  320 if(l.lt.nest) go to 310
      n=v(nest)
      jj=jj+1
      if (jj.ge.n) go to 400
      delta = (n-jj)*sep
      p1 = (jj-1)*sep + 1
      do 350 p0 = p1, nt, p2
      p3 = p0 + size
      do 350 p = p0, p3, p4
      p5 = p + delta
      t = x(p)
      x(p) = x(p5)
      x(p5) = t
      t = y(p)
      y(p) = y(p5)
      y(p5) = t
  350 continue
  400 v(l)=v(l)+s(l)
      if(v(l).le.u(l)) go to 320
      l=l-1
      if(l.ne.0) go to 400
c
  500 if (un sym(1).eq.0) go to 1900
      p un sym=pts/p sym**2
      mult=p un sym/un sym(1)
      test=(un sym(1)*un sym(2)-1)*mult*p sym
      lk=mult
      dk=mult
      do 600 k=2,nest
      if (un sym(k).eq.0) go to 700
      lk=lk*un sym(k-1)
      dk=dk/un sym(k)
      u(k)=(lk-dk)*p sym
      mods=k
  600 continue
  700 one mod=mods.lt.3
      if (one mod) go to 900
      do 800 j=3,mods
      jj=mods+3-j
      modulo(jj)=u(j)
  800 continue
  900 modulo(2)=u(2)
      jl=(p un sym-3)*p sym
      ms=p un sym*p sym
c
      do 1800 j=p sym,jl,p sym
      k=j
c
 1000 k=k*mult
      if (one mod) go to 1200
      do 1100 i=3,mods
      k=k-(k/modulo(i))*modulo(i)
 1100 continue
 1200 if (k.ge.test) go to 1300
      k=k-(k/modulo(2))*modulo(2)
      go to 1400
 1300 k=k-(k/modulo(2))*modulo(2)+modulo(2)
 1400 if (k.lt.j) go to 1000
c
      if (k.eq.j) go to 1800
      delta = (k-j)*sep
      do 1600 l=1,p sym
      do 1500 m=l,pts,ms
      p1 = (m+j-1)*sep + 1
      do 1500 p0 = p1, nt, p2
      p3 = p0 + size
      do 1500 jj = p0, p3, p4
      kk = jj + delta
      t=x(jj)
      x(jj)=x(kk)
      x(kk)=t
      t=y(jj)
      y(jj)=y(kk)
      y(kk)=t
 1500 continue
 1600 continue
 1800 continue
 1900 return
      end
c     ------------------------------------------------------------------
      subroutine mdftkdn(n, factor, dim, x, y, nsize)
c     multi-dimensional complex fourier transform kernel driver
c
      integer factor(10), dim(5), f, p, r, s
      real x(nsize), y(nsize)
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
c
      s = dim(2)
      f = 0
      m = n
  100 f = f + 1
      p = factor(f)
      if (p.eq.0) return
      m = m/p
      r = m*s
      go to (100, 200, 300, 400, 500), p
c
  200 call r2cftkn(n,m,x(1),y(1),x(r+1),y(r+1),dim,nsize)
      go to 100
c
  300 continue
      call r3 cftkn(n, m, x(1), y(1), x(r+1), y(r+1), x(2*r+1), y(2*r+1)
     ., dim ,nsize )
      go to 100
c
  400 call r4 cftkn(n, m, x(1), y(1), x(r+1), y(r+1), x(2*r+1), y(2*r+1)
     ., x(3*r+1), y(3*r+1), dim, nsize)
      go to 100
c
  500 call r5 cftkn(n, m, x(1), y(1), x(r+1), y(r+1), x(2*r+1), y(2*r+1)
     ., x(3*r+1), y(3*r+1), x(4*r+1), y(4*r+1), dim, nsize)
      go to 100
c
      end
c     ------------------------------------------------------------------
      subroutine r2 cftkn(n, m, x0, y0, x1, y1, dim, ms)
c     radix 2 multi-dimensional complex fourier transform kernel
c
      integer dim(5), size, sep
      real x0(ms), y0(ms), x1(ms), y1(ms), is, iu
      logical fold,zero
      common/trig/sint(450),pi,twopi,dtor,rtod
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common /kuse/ kuser1,kuser2,kuser3
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
c
      nt = dim(1)
      sep = dim(2)
      l1 = dim(3)
      size = dim(4) - 1
      k2 = dim(5)
      ns = n*sep
      m2=m*2
      fm2 = float(m2)
      m over 2=m/2+1
      mm2 = sep*m2
c
      fjm1 = -1.0
      do 600 j=1,m over 2
      fold=j.gt.1 .and. 2*j.lt.m+2
      k0 = (j-1)*sep + 1
      fjm1 = fjm1 + 1.0
      angle = two pi*fjm1/fm2
      zero=angle.eq.0.0
      if (zero) go to 200
      c=cos(angle)
      s=sin(angle)
      go to 200
  100 fold=.false.
      k0 = (m+1-j)*sep + 1
      c=-c
  200 do 500 kk = k0, ns, mm2
      do 440 l = kk, nt, l1
      k1 = l + size
      do 420 k = l, k1, k2
      rs=x0(k)+x1(k)
      is=y0(k)+y1(k)
      ru=x0(k)-x1(k)
      iu=y0(k)-y1(k)
      x0(k)=rs
      y0(k)=is
      if (zero) go to 300
      x1(k)=ru*c+iu*s
      y1(k)=iu*c-ru*s
      go to 420
  300 x1(k)=ru
      y1(k)=iu
  420 continue
  440 continue
  500 continue
      if (fold) go to 100
  600 continue
      return
      end
c     ------------------------------------------------------------------
      subroutine r3 cftkn(n, m, x0, y0, x1, y1, x2, y2, dim, ms)
c     radix 3 multi-dimensional complex fourier transform kernel
c
      integer dim(5), size, sep
      real x0(ms),y0(ms),x1(ms),y1(ms),x2(ms),y2(ms), i0,i1,i2,ia,ib,is
      logical fold,zero
      common/trig/sint(450),pi,twopi,dtor,rtod
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common /kuse/ kuser1,kuser2,kuser3
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      data a/-0.5/, b/0.86602540/
c
      nt = dim(1)
      sep = dim(2)
      l1 = dim(3)
      size = dim(4) - 1
      k2 = dim(5)
      ns = n*sep
      m3=m*3
      fm3 = float(m3)
      mm3 = sep*m3
      m over 2=m/2+1
c
      fjm1 = -1.0
      do 600 j=1,m over 2
      fold=j.gt.1 .and. 2*j.lt.m+2
      k0 = (j-1)*sep + 1
      fjm1 = fjm1 + 1.0
      angle = two pi*fjm1/fm3
      zero=angle.eq.0.0
      if (zero) go to 200
      c1=cos(angle)
      s1=sin(angle)
      c2=c1*c1-s1*s1
      s2=s1*c1+c1*s1
      go to 200
  100 fold=.false.
      k0 = (m+1-j)*sep + 1
      t=c1*a+s1*b
      s1=c1*b-s1*a
      c1=t
      t=c2*a-s2*b
      s2=-c2*b-s2*a
      c2=t
  200 do 500 kk = k0, ns, mm3
      do 440 l = kk, nt, l1
      k1 = l + size
      do 420 k = l, k1, k2
      r0=x0(k)
      i0=y0(k)
      rs=x1(k)+x2(k)
      is=y1(k)+y2(k)
      x0(k)=r0+rs
      y0(k)=i0+is
      ra=r0+rs*a
      ia=i0+is*a
      rb=(x1(k)-x2(k))*b
      ib=(y1(k)-y2(k))*b
      if (zero) go to 300
      r1=ra+ib
      i1=ia-rb
      r2=ra-ib
      i2=ia+rb
      x1(k)=r1*c1+i1*s1
      y1(k)=i1*c1-r1*s1
      x2(k)=r2*c2+i2*s2
      y2(k)=i2*c2-r2*s2
      go to 420
  300 x1(k)=ra+ib
      y1(k)=ia-rb
      x2(k)=ra-ib
      y2(k)=ia+rb
  420 continue
  440 continue
  500 continue
      if (fold) go to 100
  600 continue
      return
      end
c     ------------------------------------------------------------------
      subroutine r4 cftkn(n, m, x0, y0, x1, y1, x2, y2, x3, y3, dim,ms)
c     radix 4 multi-dimensional complex fourier transform kernel
c
      integer dim(5), size, sep
      real x0(ms),y0(ms),x1(ms),y1(ms),x2(ms),y2(ms),x3(ms),y3(ms)
      logical fold,zero
      real i1,i2,i3,is0,is1,iu0,iu1
      common/trig/sint(450),pi,twopi,dtor,rtod
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common /kuse/ kuser1,kuser2,kuser3
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
c
      nt = dim(1)
      sep = dim(2)
      l1 = dim(3)
      size = dim(4) - 1
      k2 = dim(5)
      ns = n*sep
      m4=m*4
      fm4 = float(m4)
      mm4 = sep*m4
      m over 2=m/2+1
c
      fjm1 = -1.0
      do 600 j=1,m over 2
      fold=j.gt.1 .and. 2*j.lt.m+2
      k0 = (j-1)*sep + 1
      fjm1 = fjm1 + 1.0
      angle = two pi*fjm1/fm4
      zero=angle.eq.0.0
      if (zero) go to 200
      c1=cos(angle)
      s1=sin(angle)
      c2=c1*c1-s1*s1
      s2=s1*c1+c1*s1
      c3=c2*c1-s2*s1
      s3=s2*c1+c2*s1
      go to 200
  100 fold=.false.
      k0 = (m+1-j)*sep + 1
      t=c1
      c1=s1
      s1=t
      c2=-c2
      t=c3
      c3=-s3
      s3=-t
  200 do 500 kk = k0, ns, mm4
      do 440 l = kk, nt, l1
      k1 = l + size
      do 420 k = l, k1, k2
      rs0=x0(k)+x2(k)
      is0=y0(k)+y2(k)
      ru0=x0(k)-x2(k)
      iu0=y0(k)-y2(k)
      rs1=x1(k)+x3(k)
      is1=y1(k)+y3(k)
      ru1=x1(k)-x3(k)
      iu1=y1(k)-y3(k)
      x0(k)=rs0+rs1
      y0(k)=is0+is1
      if (zero) go to 300
      r1=ru0+iu1
      i1=iu0-ru1
      r2=rs0-rs1
      i2=is0-is1
      r3=ru0-iu1
      i3=iu0+ru1
      x2(k)=r1*c1+i1*s1
      y2(k)=i1*c1-r1*s1
      x1(k)=r2*c2+i2*s2
      y1(k)=i2*c2-r2*s2
      x3(k)=r3*c3+i3*s3
      y3(k)=i3*c3-r3*s3
      go to 420
  300 x2(k)=ru0+iu1
      y2(k)=iu0-ru1
      x1(k)=rs0-rs1
      y1(k)=is0-is1
      x3(k)=ru0-iu1
      y3(k)=iu0+ru1
  420 continue
  440 continue
  500 continue
      if (fold) go to 100
  600 continue
      return
      end
c     ------------------------------------------------------------------
      subroutine r5 cftkn(n,m,x0,y0,x1,y1,x2,y2,x3,y3,x4,y4,dim,ms)
c     radix 5 multi-dimensional complex fourier transform kernel
c
      integer dim(5), size, sep
      real x0(ms),y0(ms),x1(ms),y1(ms),x2(ms),y2(ms),x3(ms),y3(ms),
     1 x4(ms),y4(ms),i0,i1,i2,i3,i4,ia1,ia2,ib1,ib2,is1,is2,iu1,iu2
      logical fold,zero
      common/trig/sint(450),pi,twopi,dtor,rtod
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common /kuse/ kuser1,kuser2,kuser3
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      data a1/0.30901699/,b1/0.95105652/,a2/-0.80901699/,b2/0.58778525/
c
      nt = dim(1)
      sep = dim(2)
      l1 = dim(3)
      size = dim(4) - 1
      k2 = dim(5)
      ns = n*sep
      m5=m*5
      fm5 = float(m5)
      mm5 = sep*m5
      m over 2=m/2+1
c
      fjm1 = -1.0
      do 600 j=1,m over 2
      fold=j.gt.1 .and. 2*j.lt.m+2
      k0 = (j-1)*sep + 1
      fjm1 = fjm1 + 1.0
      angle = two pi*fjm1/fm5
      zero=angle.eq.0.0
      if (zero) go to 200
      c1=cos(angle)
      s1=sin(angle)
      c2=c1*c1-s1*s1
      s2=s1*c1+c1*s1
      c3=c2*c1-s2*s1
      s3=s2*c1+c2*s1
      c4=c2*c2-s2*s2
      s4=s2*c2+c2*s2
      go to 200
  100 fold=.false.
      k0 = (m+1-j)*sep + 1
      t=c1*a1+s1*b1
      s1=c1*b1-s1*a1
      c1=t
      t=c2*a2+s2*b2
      s2=c2*b2-s2*a2
      c2=t
      t=c3*a2-s3*b2
      s3=-c3*b2-s3*a2
      c3=t
      t=c4*a1-s4*b1
      s4=-c4*b1-s4*a1
      c4=t
  200 do 500 kk = k0, ns, mm5
      do 440 l = kk, nt, l1
      k1 = l + size
      do 420 k = l, k1, k2
      r0=x0(k)
      i0=y0(k)
      rs1=x1(k)+x4(k)
      is1=y1(k)+y4(k)
      ru1=x1(k)-x4(k)
      iu1=y1(k)-y4(k)
      rs2=x2(k)+x3(k)
      is2=y2(k)+y3(k)
      ru2=x2(k)-x3(k)
      iu2=y2(k)-y3(k)
      x0(k)=r0+rs1+rs2
      y0(k)=i0+is1+is2
      ra1=r0+rs1*a1+rs2*a2
      ia1=i0+is1*a1+is2*a2
      ra2=r0+rs1*a2+rs2*a1
      ia2=i0+is1*a2+is2*a1
      rb1=ru1*b1+ru2*b2
      ib1=iu1*b1+iu2*b2
      rb2=ru1*b2-ru2*b1
      ib2=iu1*b2-iu2*b1
      if (zero) go to 300
      r1=ra1+ib1
      i1=ia1-rb1
      r2=ra2+ib2
      i2=ia2-rb2
      r3=ra2-ib2
      i3=ia2+rb2
      r4=ra1-ib1
      i4=ia1+rb1
      x1(k)=r1*c1+i1*s1
      y1(k)=i1*c1-r1*s1
      x2(k)=r2*c2+i2*s2
      y2(k)=i2*c2-r2*s2
      x3(k)=r3*c3+i3*s3
      y3(k)=i3*c3-r3*s3
      x4(k)=r4*c4+i4*s4
      y4(k)=i4*c4-r4*s4
      go to 420
  300 x1(k)=ra1+ib1
      y1(k)=ia1-rb1
      x2(k)=ra2+ib2
      y2(k)=ia2-rb2
      x3(k)=ra2-ib2
      y3(k)=ia2+rb2
      x4(k)=ra1-ib1
      y4(k)=ia1+rb1
  420 continue
  440 continue
  500 continue
      if (fold) go to 100
  600 continue
      return
      end
c     ------------------------------------------------------------------
      subroutine hermftn(x, y, nsize, n, dim,ier)
      real x(nsize), y(nsize)
      integer dim(5), d2, d3, d4, d5
c
c     hermitian symmetric fourier transform
c
      common/trig/sint(450),pi,twopi,dtor,rtod
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common /kuse/ kuser1,kuser2,kuser3
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
c
      two n = float(2*n)
      nt = dim(1)
      d2 = dim(2)
      d3 = dim(3)
      d4 = dim(4) - 1
      d5 = dim(5)
c
      do 100 i0 = 1, nt, d3
      i1 = i0 + d4
      do 100 i = i0, i1, d5
      a = x(i)
      b = y(i)
      x(i) = a + b
      y(i) = a - b
  100 continue
c
      n over 2 = n/2 + 1
      if (n over 2 .lt. 2) go to 500
      do 400 i0 = 2, n over 2
      angle = two pi*float(i0-1)/two n
      co = cos(angle)
      si = sin(angle)
      k = (n + 2 - 2*i0)*d2
      k1 = (i0 - 1)*d2 + 1
      do 300 i1 = k1, nt, d3
      i2 = i1 + d4
      do 200 i = i1, i2, d5
      j = i + k
      a = x(i) + x(j)
      b = x(i) - x(j)
      c = y(i) + y(j)
      d = y(i) - y(j)
      e = b*co + c*si
      f = b*si - c*co
      x(i) = a + f
      x(j) = a - f
      y(i) = e + d
      y(j) = e - d
  200 continue
  300 continue
  400 continue
c
      call cmplftn(x, y, nsize, n, dim,ier)
c
  500 return
      end
c     ------------------------------------------------------------------
      subroutine read kln(x, ny, nz, nx, hs)
      integer hs, h, hm, hl
      complex x(ny,nz,nx)
      common /refl/ ih(100), g(2,100)
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common /kuse/ kuser1,kuser2,kuser3
c
      rewind jrel
      nblock = nex/100+1
      hm=262144*(hs+nx-1+256)+(512+1)*(2*256-1)
      hl=262144*(hs+256)
      do 100 h = 1, nx
      do 100 l = 1, nz
      do 100 k = 1, ny
      x(k,l,h) = cmplx(0.0,0.0)
  100 continue
c
      m=100
      do 500 ib=1,nblock
      if(ib.eq.nblock) m=mod(nex,100)
      if(m.eq.0) go to 500
      read(jrel) ih,g
      do 300 j = 1, m
      ihj=ih(j)
      if(ihj.gt.hm.or.ihj.lt.hl) go to 300
      h=ihj/262144-256
      l=ihj-262144*(h+256)
      k=l/512-256
      l=l-512*(k+256)-256
      noko = 0
      if (h.eq.0.and.l.eq.0.and.k.ne.0) noko = ny-k+1
      h = h - hs + 1
      if(k.lt.0)k=ny+k
      k = k + 1
      l = l + 1
      x(k,l,h) = cmplx(g(1,j),g(2,j))
      if (noko.ne.0) x(noko,l,h) = conjg(x(k,l,h))
  300 continue
  500 continue
      return
      end
c     ------------------------------------------------------------------
      subroutine write yn(x, ny, nz, nx, size)
      integer size, h, p, q, r
      complex x(ny,nz,nx)
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common /pollo/ nuva(800),numr
c
      p = size
      q = 0
  100 r = q + 1
      if (q + p .gt. ny) p = ny - q
      q = q + p
      write (ifour) (((x(k,l,h), h = 1, nx), k = r, q), l = 1, nz)
      nuvar=nx*(q-r+1)*nz
      numr=numr+1
      nuva(numr)=nuvar
      if (q .lt. ny) go to 100
      return
      end
c     ------------------------------------------------------------------
      subroutine read hln(x, nx, nz, ny, hmax, lmax, size, skip, recs)
      integer hmax, size, skip ,recs, h, hl, hu, p, q
      complex x(nz,nx,ny)
c
c     reads in intermediate results for all h and l for a block of k.
c     the input is stored with l down the columns and h on the rows.
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
c
      common /pollo/ nuva(800),numr
      common /xdata/ duma(160000),vet(42000)
      complex vet
c
      lm = lmax + 1
      p = size
      hu = nx - hmax
      if (skip .le. 0) go to 200
      do 100 q = 1, skip
      numr=numr+1
      nuvar=nuva(numr)
Corig read (ifour)(vet(i),i=1,nuvar)
      read (ifour)(vet(1),i=1,nuvar)
  100 continue
c
c     read data for negative h
c
  200 if (hu + p .gt. nx) go to 400
      hl = hu + 1
      hu = hu + p
      read (ifour) (((x(l,h,k), h = hl, hu), k = 1, ny), l = 1, lm)
      numr=numr+1
      if (recs .le. 0) go to 200
      do 300 q = 1, recs
      numr=numr+1
      nuvar=nuva(numr)
      read (ifour)(vet(i),i=1,nuvar)
  300 continue
      go to 200
c
c     go pick up record which spans h = 0 if necessary
c
  400 if (hu .ne. nx) go to 700
      hu = 0
c
c     read records for positive h
c
  500 if (hu + p .gt. hmax + 1) p = hmax + 1 - hu
      hl = hu + 1
      hu = hu + p
      read (ifour) (((x(l,h,k), h = hl, hu), k = 1, ny), l = 1, lm)
      numr=numr+1
  550 if (hu .eq. hmax + 1) go to 800
      if (recs .le. 0) go to 500
      do 600 q = 1, recs
      numr=numr+1
      nuvar=nuva(numr)
      read (ifour)(vet(i),i=1,nuvar)
  600 continue
      go to 500
c
c     section to read a record spanning h = 0
c
  700 hl = hu + 1
      hu = hu + p - nx
      if (hu .gt. hmax + 1) hu = hmax + 1
      read (ifour) (((x(l,h,k), h = hl, nx), (x(l,h,k), h = 1, hu),
     .   k = 1, ny), l = 1, lm)
      numr=numr+1
      go to 550
c
c     pad the array with zero where there are no data, and fill in the
c     -h k 0 results by symmetry.
c
  800 do 900 h = 2, hu
      hl = nx + 2 - h
      do 900 k = 1, ny
      x(1,hl,k) = conjg(x(1,h,k))
  900 continue
      hl = hmax + 2
      hu = nx - hmax
      if (hu .lt. hl) go to 920
      do 910 l = 1, lm
      do 910 k = 1, ny
      do 910 h = hl, hu
      x(l,h,k) = cmplx(0.0,0.0)
  910 continue
c
  920 if (lm .ge. nz) go to 940
      p = lm + 1
      do 930 k = 1, ny
      do 930 l = p, nz
      do 930 h = 1, nx
      x(l,h,k) = cmplx(0.0,0.0)
  930 continue
c
c     end of input
c
  940 return
      end
c     ------------------------------------------------------------------
      subroutine outpufn(x, nz, nx, ny, y, nyt)
      real x(nz,nx,ny)
      integer star,blank,y,sec,xl,xu
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common /tran/ scale,mh(3),level,it4,xlim(3)
      common /tape/ inut(180),line(50)
      common / ureq1/ jpatt,jpunt(501),ksacc,jseteq,jumpp,jmpsie,nsec
      common /new/ ntime
      dimension ndx(200),ndz(200),nxyz(200,200),ndy(200)
      data star/2h**/,blank/4h    /,ncol/36/
c
c     put out scaled y-sections or x-sections or z-sections
c
c in the following file a section of the map is written if the directive
c 'map' is given in input
      if(it4.eq.0) go to 250
      nxm=min0(nx,int(xlim(1)*float(nx))+1)
      nym=min0(nyt,int(xlim(2)*float(nyt))+1)
      if(ny.le.nyt.and.nsec.ne.1)nym=min0(ny,int(xlim(2)*float(ny))+1)
      nzm=min0(nz,int(xlim(3)*float(nz))+1)
      asc=1000.0/float(nx)
c
  250 continue
c  put  out scaled y-sections
      if (nsec.eq.1) then
                       nn1=ny
                       nn2=nz
                       nn3=nx
                       nnm1=nxm
                       nnm2=nym
                       nnm3=nzm
                     end if
c  put  out scaled x-sections
      if (nsec.eq.2) then
                       nn1=nx
                       nn2=nz
                       nn3=ny
                       nnm1=nym
                       nnm2=nxm
                       nnm3=nzm
                     end if
c  put  out scaled z-sections
      if (nsec.eq.3) then
                       nn1=nz
                       nn2=nx
                       nn3=ny
                       nnm1=nym
                       nnm2=nzm
                       nnm3=nxm
                     end if
      do 100 k = 1, ny
      isum1=0
      do 150 j=1,nz
      do 130 i=1,nx
      xx=x(j,i,k)*scale
      inut(i)=0
      if(xx.ne.0.0) inut(i)=xx+sign(0.5,xx)
      isum1=isum1+inut(i)
  130 continue
      write(jrel)(inut(i),i=1,nx)
  150 continue
c     write(6,*) 'Section #',k,'  sum=',isum1
  100 continue
      asc=1000.0/float(nn3)
      do 900 k = 1, nn1
      sec = y + k - 1
      do 350 j=1,nn2
      do 330 i=1,nn3
           if (nsec.eq.1) then
                            xx=x(j,i,k)*scale
                            x(j,i,k)=xx
      else if (nsec.eq.2) then
                            xx=x(j,k,i)*scale
                            x(j,k,i)=xx
      else if (nsec.eq.3) then
                            xx=x(k,j,i)*scale
                            x(k,j,i)=xx
                          end if
  330 continue
  350 continue
      if (it4 .eq. 0) go to 900
      if (ntime .gt. 1) go to 900
      nec=1000.*(float(sec))/(float(nn1))+0.5
c     if(nec.le.470.or.nec.ge.510) go to 900
c     if(nec.ne.500) go to 900
      ntime=1
      do 351 i=1,200
      do 352 j=1,200
      ndx(i)=0
      ndz(i)=0
      nxyz(i,j)=0
  352 continue
  351 continue
      xu = 0
  450 xl = xu + 1
      xu = xu + ncol
      if(xu.gt.nnm1) xu=nnm1
      do 460 l=xl,xu
      inut(l)=float((l-1))*asc+0.5
      ndx(l)=inut(l)
  460 continue
      ndy(k)=nec
      ndyk=ndy(k)
      if(nsec.eq.1) write (it4,480) itle,nec
      if(nsec.eq.2) write (it4,481) itle,nec
      if(nsec.eq.3) write (it4,482) itle,nec
  480 format(1h1,7x,20a4,8x,12hsection  y =,i4/)
  481 format(1h1,7x,20a4,8x,12hsection  x =,i4/)
  482 format(1h1,7x,20a4,8x,12hsection  z =,i4/)
      if(nsec.eq.1) write (it4,500) (inut(nn),nn=xl,xu,2)
      if(nsec.eq.2) write (it4,501) (inut(nn),nn=xl,xu,2)
      if(nsec.eq.3) write (it4,502) (inut(nn),nn=xl,xu,2)
  500 format(8x,3hx =,i4,17i6)
  501 format(8x,3hy =,i4,17i6)
  502 format(8x,3hy =,i4,17i6)
      ilim = xl + 1
      write (it4,520) (inut(nn),nn=ilim,xu,2)
  520 format(12x,18i6)
      write(it4,530)
  530 format(/)
      do 700 i = 1,nnm3
      line(1)=float((i-1))*1000./float(nn2)+0.5
      ndz(i)=line(1)
      l = 1
      do 600 j = xl, xu
      l = l + 1
      inut(l)=blank
      if(nsec.eq.1) xx=x(i,j,k)
      if(nsec.eq.2) xx=x(i,k,j)
      if(nsec.eq.3) xx=x(k,i,j)
      line(l)=0
      if(xx.ne.0.0) line(l)=int(0.1*xx+sign(0.5,xx))
      if (iabs(line(l)) .gt. 99) line(l) = isign(99,line(l))
      nxyz(i,j)=line(l)
      if (10 * line(l) .gt. level) inut(l) = star
  600 continue
      if(nsec.eq.1) write (it4,630) (line(j), j = 1, l)
      if(nsec.eq.2) write (it4,631) (line(j), j = 1, l)
      if(nsec.eq.3) write (it4,632) (line(j), j = 1, l)
  630 format(4h z =,i4,4h *  ,36i3)
  631 format(4h z =,i4,4h *  ,36i3)
  632 format(4h x =,i4,4h *  ,36i3)
      write(it4,660) (inut(j),j=2,l)
  660 format(12x,36(1x,a2))
  700 continue
      if(xu.lt.nnm1) go to 450
      if(sec.ge.nnm2) it4=0
  900 continue
      return
      end
c-----------------------------------------------------------------------
c        special position library flow diagram
c
c --->-----+---------------------------+--------------->----
c        xspinb(*)                  kspecb
c        xflori       +-----------+----+-----+----------+
c                  xnuova       xelles      xtherm    xprint
c            +--------+---------+
c          xequi    xdist     xdepa
c                             xcmat
c
c   also available xwrifl to print information about float. origin
c                  xcmprp      to compress a string
c
c   (*) this subroutine is the only package-specific one
c
c**********************************************************************
c-----------------------------------------------------
      subroutine xspinb
c--
c-- initialization subroutine for special positions
c--
c-- soper  symmetry operators matrix
c-- centrt translation matrix for non primitive lattice
c-- aaa    constants to compute atoms distances
c-- noper  number of symmetri operators
c-- ncentr number of translation matricies
c-- icent  = 0  noncentrosymmetric space group
c--        = 1  centrosymmetric space group
c-- kpol   = 0  no floating origin
c--        > 0  floating origin (see subr. florig)
c-- jsys   crystal family
c-- lat    =  1   2   3   4   5   6   7   (erlangen)
c--           p   a   b   c   f   i   r
c-- lat    =  p   a   b   c   i   f   r   (multan)
c--           *** warning ***  multan notation is used
c-- indv,mpv  utility array
c-- jspini = +1 common /spec/ already filled  (crystals)
c-- jspini = +2 common /spec/ already filled  (sir)
c--        = -1 common /spec/ actually not initialized
c--        =  0  sir environment - do not mind about initialization
c-- ddmin  minimun distance to define a peak
c--        being in general position
      dimension kcentr(7),abc(3),ang(3)
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common/spec/ soper(3,4,24),centrt(7,12),aaa(6),noper,ncentr,icent,
     *         kpol,jsys,lat,indv(32),mpv(64),jspini,ddmin,ncawu,ncwu
      common /erl/ kmat(48,3,3),tmat(48,3),nt(16),jsysx,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/sym/is(2,3,24),ts(3,24),nsym,pts,ksys,icentx,latx,s3s2,emme
     *          ,s3s2p
      common/rc/p(6),cx(9),dumm(9)
      dimension latxv(7)
Corig data latxv/1,2,3,4,6,5,7/
      data latxv/1,2,3,4,5,6,7/
c
      if (jspini.gt.0) return
c
c-- initialize output channels
c
      ncawu=lo
      ncwu =lo
c
c-- cell parameters, cent and lattice code needed
c
      lat=latxv(latx)
      icent=icentx
      jsys=jsysx
      do 10 i=2,6
   10 kcentr(i)=2
      kcentr(1)=1
Corig kcentr(5)=4
      kcentr(6)=4
      kcentr(7)=3
      do 20 i=1,3
         abc(i)=cx(i)
         ang(i)=cx(i+3)
   20 continue
      aaa(1)=abc(1)*abc(1)
      aaa(2)=abc(2)*abc(2)
      aaa(3)=abc(3)*abc(3)
      aaa(4)=2.0*abc(1)*abc(2)*cos(ang(3)*dtor)
      aaa(5)=2.0*abc(1)*abc(3)*cos(ang(2)*dtor)
      aaa(6)=2.0*abc(2)*abc(3)*cos(ang(1)*dtor)
c
      ncentr=kcentr(lat)
c
c-- at this point i need matricies to fill 'soper'
c
      noper=nsym
      do 15 k=1,nsym
      do 15 i=1,3
      soper(i,4,k)=tmat(k,i)
      do 15 j=1,3
      soper(i,j,k)=kmat(k,i,j)
   15 continue
c-- compute floating origin code
      call xflori
      jspini=2
      return
      end
code for xcmprp
c------------------------------------------------------------------
      subroutine xcmprp(string,lstri)
c
      character*(*) string
      character ib,string1*120
c
      ib=' '
      string1=ib
      k=len(string)
      j=1
      do 10 i=1,k
      if (string(i:i).ne.ib) then
                               string1(j:j)=string(i:i)
                               j=j+1
                             endif
   10 continue
      lstri=j-1
      string(1:lstri)=string1(1:lstri)
      if (j.le.k) then
                    do 20 i=j,k
   20               string(i:i)=ib
                  endif
      return
      end
c----------------------------------------------------------------------
      block data utiblk
c
c--utility tables initialization
c
      common/spec/ soper(3,4,24),centrt(7,12),aaa(6),noper,ncentr,icent,
     *         kpol,jsys,lat,indv(32),mpv(64),jspini,ddmin,ncawu,ncwu
      data centrt/
     * .0000,.0000,.0000,.0000,.0000,.0000,.0000,.0000,.0000,.0000,.0000
     *,.0000,.0000,.0000,.0000,.0000,.0000,.0000,.0000,.0000,.0000,.0000
     *,.0000,.5000,.5000,.5000,.5000,.6666,.0000,.5000,.0000,.5000,.5000
     *,.5000,.3333,.0000,.5000,.5000,.0000,.5000,.0000,.3333,.0000,.0000
     *,.0000,.0000,.0000,.0000,.3333,.0000,.0000,.0000,.0000,.0000,.5000
     *,.6666,.0000,.0000,.0000,.0000,.0000,.5000,.6666,.0000,.0000,.0000
     *,.0000,.0000,.5000,.0000,.0000,.0000,.0000,.0000,.0000,.0000,.0000
     *,.0000,.0000,.0000,.0000,.0000,.5000,.0000/
      data mpv/
     *        273,139537,140563, 65697, 16545,131857,135961,  2132,
     *      32852,  8977,  9498,  4875,  1290,  4362,  1291,  4378,
     *     131338,136458,   673,  8276, 43092, 82593,   140,    98,
     *      33890,  6284, 17506, 69772, 49250, 67724,139545,131859,
     *     140049,   785,   787, 17057, 66209,  8465,  8473, 41044,
     *      10324,131345,135450,132363,135434,132362,135947,140570,
     *       5386,   266, 82081, 34900,    84,   161, 71820, 50274,
     *      16482, 65676, 32866,  2188,  1122,  4236,  4889,  9491/
 
      data indv/1,2,2,4,4,2,2,4,4,2,3,3,4,4,6,6,
     *          2,2,2,2,2,2,3,3,3,3,3,3,3,3,2,2/
      data jspini,ddmin /-1 , 0.6 /
      end
code for xflori
c-----------------------------------------------------------------------
      subroutine xflori
c
c-- floating origin subroutine
c
c-- kpol code is computed to take
c-- into account floating origin.
c-- if kpol.eq.0 then no floating origin
c-- if kpol.ne.0 then the floating direction
c--                   corresponds to 1's in the code
c                     e.g.   kpol=001 float. origin along z
c                            kpol=100 float. origin along x
c
      dimension jfl(3)
      common/spec/ soper(3,4,24),centrt(7,12),aaa(6),noper,ncentr,icent,
     *         kpol,jsys,lat,indv(32),mpv(64),jspini,ddmin,ncawu,ncwu
      if (icent.eq.1) then
                        kpol=0
                      else
                        do 60 k=1,3
                          jfl(k)=0
                          do 50 i=1,noper
                            do 40 j=1,3
                              jfl(k)=jfl(k)+soper(j,k,i)
   40                       continue
   50                     continue
                          if (jfl(k).ne.noper) then
c--  non - floating direction
                                                 jfl(k)=0
                                               else
c--  floating direction
                                                 jfl(k)=1
                                               endif
   60                   continue
                        mult=100
                        kpol=0
                        do 70 i=1,3
                        kpol=kpol+jfl(i)*mult
                        mult=mult/10
   70                   continue
                      endif
      return
      end
code for kspecb
c----------------------------------------------------------------------
      function kspecb(newvet,xo,xn,key,itype,iser,khead,iactn)
c
c-- function to handle atoms in special position
c
c   return value
c          kspecb = +1 atom in general position
c                 = -1 atom in special position
c-- meaning of parameters
c     xo    = array containing original values for x,y,z,occ,u's,c-occ
c     xn    = array containing modified values for x,y,z,occ,u's,c-occ
c    key    = array containing conditions for      x,y,z,    u's,c-occ
c  itype    = type of atom
c   iser    = serial number
c  khead    =  0  heading for special position to be print
c           =  1  heading not to be printed
c     iactn =     action to be taken :
c           =  1  compute crystallographic occupation
c           =  2  generate key array and update x's and u's
c           =  3  print information
c    newvet = matrix containing information about 
c             the symmetry operators involved
      common/spec/ soper(3,4,24),centrt(7,12),aaa(6),noper,ncentr,icent,
     *         kpol,jsys,lat,indv(32),mpv(64),jspini,ddmin,ncawu,ncwu
      dimension xo(11),xn(11),key(10),newvet(48,3)
c
      do 10 i=1,9
   10 key(i)=i
      key(10)=1
      call xnuova(xo,xn,key,n,newvet,iser)
      kspecb=1
      if (key(10).gt.1) then
         kspecb=-1
         if (iactn.gt.1) then
            if (key(10).ne.1) then
                                call xelles(newvet,n,key)
                                call xtherm(newvet,n,key)
                              endif
             if (iactn.gt.2) call xprint(key,itype,iser,xn,khead)
                         endif
                        endif
c
      return
      end
code for xnuova
c------------------------------------------------------------------
      subroutine xnuova(xo,xn,key,nr,newvet,iser)
c--
c-- subroutines to recognize if a peak is in a special position.
c-- if it is very close to it, the peak is "moved" in it.
c--
c-- check if atoms are in special position
c-- computing the distance between an atom
c-- and its symmetry equivalents
c--
      dimension xo(11),xn(11),key(10),vet(2)
      dimension xeq(3),m(3,3),s(3),xb1(3),xb2(3),newvet(48,3)
      common/spec/ soper(3,4,24),centrt(7,12),aaa(6),noper,ncentr,icent,
     *         kpol,jsys,lat,indv(32),mpv(64),jspini,ddmin,ncawu,ncwu
c
      vet(1)= 1.0
      vet(2)=-1.0
      do 20 i=1,11
   20 xn(i)=xo(i)
      do 30 i=1,3
      xb1(i)=xo(i)
   30 xb2(i)=xo(i)
      ifin=icent+1
      nr=0
      do 50 kt=1,ncentr
        do 50 ifi=1,ifin
          coef=vet(ifi)
          do 50 k=1,noper
            if (k.eq.1.and.ifi.eq.1.and.kt.eq.1) go to 50
            call xequi(xb2,k,coef,xeq,kt)
            call xdist(xb2,xeq,d,s)
            if (d.le.ddmin) then
                              nr=nr+1
                              newvet(nr,3)=k*coef
                              do 40 j=1,3
                                xb1(j)=xb1(j)+xb2(j)+s(j)
   40                         continue
                            endif
   50 continue
      if (nr.ne.0) then
                do 70 l=1,nr
                   k=newvet(l,3)
                   coef=1.0
                   if (k.lt.0) then
                                 k=-k
                                 coef=-1.0
                               endif
                   do 60 ii=1,3
                      do 60 j=1,3
                         m(ii,j)=coef*soper(ii,j,k)
   60              continue
                   call xdepac(m,ind,inew)
                   newvet(l,1)=inew
                   newvet(l,2)=ind
   70           continue
                do 80 j=1,3
                   xb1(j)=xb1(j)/float(nr+1)
   80           continue
                else
                do 90 j=1,3
                   newvet(1,j)=1
   90           continue
                endif
c
      kcond=nr+1
      do 100 i=1,3
  100 xn(i)=xb1(i)
      xn(11)=1.0/float(kcond)
      key(10)=kcond
      return
      end
code for xequi
c--------------------------------------------------------------------
      subroutine xequi(xb2,k,coef,xeq,kt)
c--
c-- computes the symmetry equivalent of an atom
c--
      common/spec/ soper(3,4,24),centrt(7,12),aaa(6),noper,ncentr,icent,
     *         kpol,jsys,lat,indv(32),mpv(64),jspini,ddmin,ncawu,ncwu
      dimension xb2(3),xeq(3)
c
      do 10 l=1,3
      ktl=(kt-1)*3+l
      xeq(l)=soper(l,4,k)+centrt(lat,ktl)
      do 10 j=1,3
   10 xeq(l)=xeq(l)+xb2(j)*coef*soper(l,j,k)
      return
      end
code for xdist
c----------------------------------------------------------------------
      subroutine xdist(xb2,xeq,d,s)
c--
c-- subroutine used to compute the distance between
c-- an atom and its equivalent
c--
      common/spec/ soper(3,4,24),centrt(7,12),aaa(6),noper,ncentr,icent,
     *         kpol,jsys,lat,indv(32),mpv(64),jspini,ddmin,ncawu,ncwu
      dimension xeq(3),xb2(3),delta(8,3),dp(3),ds(3),s(3)
c
      do 20 i=1,3
         d=xeq(i)-xb2(i)
         dp(i)=d-int(d)
         if (dp(i).le.0.0) then
                           ds(i)=dp(i)+1.0
                           else
                           ds(i)=dp(i)-1.0
                           endif
   20 continue
      delta(1,1)=dp(1)
      delta(1,2)=dp(2)
      delta(1,3)=dp(3)
      delta(2,1)=dp(1)
      delta(2,2)=dp(2)
      delta(2,3)=ds(3)
      delta(3,1)=dp(1)
      delta(3,2)=ds(2)
      delta(3,3)=dp(3)
      delta(4,1)=dp(1)
      delta(4,2)=ds(2)
      delta(4,3)=ds(3)
      delta(5,1)=ds(1)
      delta(5,2)=dp(2)
      delta(5,3)=dp(3)
      delta(6,1)=ds(1)
      delta(6,2)=dp(2)
      delta(6,3)=ds(3)
      delta(7,1)=ds(1)
      delta(7,2)=ds(2)
      delta(7,3)=dp(3)
      delta(8,1)=ds(1)
      delta(8,2)=ds(2)
      delta(8,3)=ds(3)
      dimi=99999.9
      do 40 i=1,8
         d2=delta(i,1)*delta(i,1)*aaa(1)
     &     +delta(i,2)*delta(i,2)*aaa(2)
     &     +delta(i,3)*delta(i,3)*aaa(3)
     &     +delta(i,1)*delta(i,2)*aaa(4)
     &     +delta(i,1)*delta(i,3)*aaa(5)
     &     +delta(i,2)*delta(i,3)*aaa(6)
         d=sqrt(d2)
         if (d.lt.dimi) then
                        dimi=d
                        do 30 j=1,3
                           s(j)=delta(i,j)
   30                   continue
                        endif
   40 continue
      d=dimi
      return
      end
code for xdepac
c-----------------------------------------------------------------------
      subroutine xdepac(m,ind,inew)
c--
c-- using a code associated to the matrix in use
c-- finds out which kind of symmetry operator
c-- is involved
c--
      common/spec/ soper(3,4,24),centrt(7,12),aaa(6),noper,ncentr,icent,
     *         kpol,jsys,lat,indv(32),mpv(64),jspini,ddmin,ncawu,ncwu
      dimension m(3,3)
c
      call xcmat(m,mp)
c
      in=0
      do 10 i=1,64
         if (mp.eq.mpv(i)) in=i
   10 continue
c
      if (in.eq.0) then
                      write(ncwu,*) 'stop speclib - xdepac '
                      write(ncwu,'(3i4)') ((m(i,j),j=1,3),i=1,3)
                      write(ncwu,'(i10)')      mp
                      stop 'speclib - xdepac '
                    endif
c
      ind=in
      inw=1
      if (in.gt.32) then
                      inw=-1
                      in=in-32
                     endif
      inew=inw*indv(in)
      return
      end
code for xcmat
c------------------------------------------------------------------
      subroutine xcmat(m,mp)
c--
c-- this subroutine is used to transform a rotational
c-- matrix in a unique number to use like a pointer
c-- to recognize which kind of operator is involved
c-- ( mirror , 2-fold axis etc. )
c--
      dimension m(3,3)
c
      mp=0
      iexp=-1
      do 10 i=1,3
         do 10 j=1,3
            iexp=iexp+1
            if (m(i,j).ge.0) then
                               mp=mp+m(i,j)*2**iexp
                             else
                               mp=mp+2**iexp+2**(iexp+9)
                             endif
   10 continue
      return
      end
code for xwrifl
c----------------------------------------------------------------------
      subroutine xwrifl
c
c-- write information about freely floating origin
c
      character*3 xyz,xyzfr
      common/spec/ soper(3,4,24),centrt(7,12),aaa(6),noper,ncentr,icent,
     *         kpol,jsys,lat,indv(32),mpv(64),jspini,ddmin,ncawu,ncwu
c
      kdummy=kpol
      xyz='xyz'
      do 10 i=1,3
      j=4-i
      ipr=mod(kdummy,10)
      kdummy=kdummy/10
      xyzfr(j:j)=' '
      if (ipr.eq.1) xyzfr(j:j)=xyz(j:j)
   10 continue
      if (kpol.ne.0) write(ncwu,30) xyzfr
   30 format(/' *** warning *** freely floating origin along ',a3,/)
      return
      end
code for xelles
c------------------------------------------------------------------
      subroutine xelles(newvet,n,key)
c
c-- this subroutine computes the
c-- conditions for least squares shifts
c
      common/spec/ soper(3,4,24),centrt(7,12),aaa(6),noper,ncentr,icent,
     *         kpol,jsys,lat,indv(32),mpv(64),jspini,ddmin,ncawu,ncwu
 
      integer xeq(3),xyz(3),xyo(3),iflc(3),key(10)
      integer mult(3),newvet(48,3)
c
      nn=n+1
      mult(1)=-1
      mult(2)= 1
      mult(3)= 2
      xyo(1)=3
      xyo(2)=11
      xyo(3)=13
      do 10 i=1,3
         xyz(i)=xyo(i)
   10 continue
      do 30 m=1,n
         coef=1.0
         k=newvet(m,3)
         if (k.lt.0) then
                       k=-k
                       coef=-1
                     endif
         do 20 l=1,3
            xeq(l)=0
            do 20 j=1,3
   20          xeq(l)=xeq(l)+xyo(j)*soper(l,j,k)*coef
         do 25 j=1,3
            if (xyz(j).ne.0) then
                               xyz(j)=xyz(j)+xeq(j)
                             endif
   25 continue
   30 continue
      ifl=0
      do 35 i=1,3
      if (xyz(i).ne.0) then
                         if (mod(xyz(i),nn).ne.0) ifl=1
                       endif
   35 continue
      if (ifl.eq.0) then
                      do 38 i=1,3
   38                 xyz(i)=xyz(i)/nn
                    endif
c
      do 40 i=1,3
         iflc(i)=0
   40 continue
      k=0
      do 60 i=1,3
      if (xyz(i).ne.0) then
      if (k.eq.0) then
                    k=1
                    if (xyz(i).lt.0) then
                                       do 50 j=1,3
                                          xyz(j)=-xyz(j)
   50                                  continue
                                     endif
                  endif
                  endif
   60 continue
      do 110 i=1,2
         if (iflc(i).eq.0) then
            if (xyz(i).ne.0) then
               k=1
               ifl2=0
               do 80 j=i+1,3
                  ifl1=0
                  do 70 l=1,3
                     if (xyz(i)*mult(l).eq.xyz(j)) then
                                                     iflc(j)=mult(l)
                                                     iflc(i)=1
                                                     ifl1=1
                                                   endif
                     if (ifl1.eq.0) then
                     if (xyz(i).eq.xyz(j)*mult(l)) then
                                                     iflc(i)=mult(l)
                                                     iflc(j)=1
                                                     ifl1=1
                                                   endif
                                    endif
   70             continue
               ifl2=ifl2+ifl1
   80          continue
                  if (ifl2.ne.0) then
                                  l=0
                                  do 90 j=1,3
                                     if (iflc(j).ne.0) then
                                                         if (l.eq.0) l=j
                                                       endif
   90                             continue
                                  do 100 j=1,3
                           if (iflc(j).ne.0) xyz(j)=xyo(l)*iflc(j)
  100                             continue
                                 endif
                             endif
                       endif
  110 continue
      do 130 i=1,3
         ifl=0
         if (xyz(i).ne.0) then
                          do 120 j=1,3
                             do 120 k=1,3
                                if (xyz(i).eq.xyo(j)*mult(k)) ifl=1
  120                     continue
                          if (ifl.eq.0) xyz(i)=xyo(i)
                          endif
  130 continue
      do 150 j=1,3
         if (xyz(j).ne.0) then
            do 140 k=1,3
                    if (xyz(j).eq.xyo(k))   then
                                              xyz(j)=k
               else if (xyz(j).eq.2*xyo(k)) then
                                              xyz(j)=20+k
               else if (xyz(j).eq.-xyo(k))  then
                                              xyz(j)=-k
                                             endif
  140       continue
         endif
  150 continue
      do 155 i=1,3
        ix=xyz(i)
        ifl=0
        if (ix.lt.0) then
                       do 153 j=1,3
                          if (xyz(j).eq.-ix) ifl=1
  153                  continue
                       if (ifl.eq.0) xyz(i)=-xyz(i)
                     endif
  155 continue
      do 160 i=1,3
  160 key(i)=xyz(i)
      if (key(3).eq.23.or.key(3).eq.-3) key(3)=3
      return
      end
code for xprint
c----------------------------------------------------------------------
      subroutine xprint(key,itype,iser,xn,khead)
c
c-- print symmetry restrictions on atomic parametrs
c
c--   key  array containing symmetry restrictions
c   itype  atom type (hollerith*4)
c    iser  serial
c      xn  array containing values for atomic parameters
c
      character line*42,keyc(9)*2
      common/spec/ soper(3,4,24),centrt(7,12),aaa(6),noper,ncentr,icent,
     *         kpol,jsys,lat,indv(32),mpv(64),jspini,ddmin,ncawu,ncwu
      character cbuff*124
      common /atpos/ cbuff
      dimension key(10),xn(11)
      data keyc/' x',' y',' z','11','22','33','23','13','12'/
c
      k=1
      mm=5
      do 80 j=1,9
      if (j.le.4) then
                    mm=4
                  else
                    mm=5
                  endif
       kj=key(j)
       l=k+5
       if (kj.ge.0) then
            if (kj.eq.0) then
                           write(line(k:l),'(5h  0  )')
       else if (kj.le.j) then
                           write(line(k:l),'(1h ,a2,3h   )') keyc(kj)
       else if (kj.gt.9) then
            if (kj.gt.20) then
                          kj=kj-20
                          write(line(k:l),'(a2,3h*2 )') keyc(kj)
                          else
                          kj=kj-10
                          write(line(k:l),'(a2,3h/2 )') keyc(kj)
                          endif
       else if (kj.lt.j) then
                           write(line(k:l),'(1h ,a2,2h  )') keyc(kj)
                         endif
                    else
                      kj=-kj
                      if (j.le.3) then
                          write(line(k:l),'(2h -,a1,2h  )')keyc(kj)(2:2)
                                  else
                          write(line(k:l),'(1h-,a2,2h  )') keyc(kj)
                                  endif
                    endif
       k=k+mm
   80 continue
c
      if (jspini.eq.1) then
c
c-- crystals output 
c
         if (khead.eq.0) then
                           write(ncwu,100)
                           khead=1
  100 format(
     *' type serial    symmetry restrictions on atomic parameters')
                         endif
         write(ncwu,200) itype,iser,line
  200 format(2x,a4,i4,4x,a42)
                       else
c
c-- sir output
c
         write(cbuff(47:124),300) (xn(i),i=1,3),xn(11),line
c 300 format(1h+,45x,3f7.3,f8.4,1x,a42)
  300 format(3f7.3,f8.4,1x,a42)
                       endif
      return
      end
code for xtherm
c-----------------------------------------------------------------------
      subroutine xtherm(newvet,nr,key)
c
c-- this subroutine computes the conditions for
c-- thermal parameters according to:
c
c           w.j.a.m. peterse and j.h. palme
c           acta cryst. (1966). 20, 147
c
      common/spec/ soper(3,4,24),centrt(7,12),aaa(6),noper,ncentr,icent,
     *         kpol,jsys,lat,indv(32),mpv(64),jspini,ddmin,ncawu,ncwu
 
      integer newvet(48,3),ivet(48),s,q(3,3),binv(9,6),ijt(6,2),itt(6)
      integer q12,q13,q23,vterm(6),bin1(6,6),key(10)
c
      do 10 i=1,6
         vterm(i)=99
   10 continue
      itt(1)=1
      itt(2)=5
      itt(3)=9
      itt(4)=6
      itt(5)=3
      itt(6)=2
      do 18 k=1,6
      ict=0
      do 15 i=1,3
      do 15 j=1,3
      ict=ict+1
      if (ict.eq.itt(k)) then
                           ijt(k,1)=i
                           ijt(k,2)=j
                         endif
   15 continue
   18 continue
      ivet(1)=1
      do 20 i=1,nr
         ivet(i+1)=newvet(i,3)
   20 continue
      n=nr+1
      kk=0
      do 50 i=1,3
         do 50 j=1,3
            do 30 k=1,3
               do 30 l=1,3
                  q(k,l)=0
                  do 30 js=1,n
                     coef=1.0
                     s=ivet(js)
                     if (s.lt.0) then
                                   s=-s
                                   coef=-1
                                 endif
                     q(k,l)=q(k,l)+soper(i,k,s)*soper(j,l,s)
   30             continue
         q12=q(1,2)+q(2,1)
         q13=q(1,3)+q(3,1)
         q23=q(2,3)+q(3,2)
         kk=kk+1
         do 40 k=1,3
            binv(kk,k)=q(k,k)
   40    continue
         binv(kk,4)=q12
         binv(kk,5)=q13
         binv(kk,6)=q23
   50 continue
      do 60 k=1,6
         isk=0
         i=ijt(k,1)
         j=ijt(k,2)
         kk=itt(k)
         do 60 l=1,6
            bin1(k,l)=binv(kk,l)
   60 continue
      if (jsys.eq.5) then
                       do 70 i=4,6
                          do 70 l=1,6
                             bin1(i,l)=2*bin1(i,l)
   70                  continue
                     endif
      do 90 i=1,6
         ki=ijt(i,1)
         kj=ijt(i,2)
         ifl=0
         do 80 j=1,6
            if (bin1(i,j).ne.0) ifl=1
   80    continue
         if (ifl.eq.0) vterm(i)=0
   90 continue
      kk=1
      do 120 i=1,5
         ich=0
         if (vterm(i).eq.99) then
                               do 110 k=i+1,6
                                     do 110 is=-1,1,2
                                      do 110 js=0,1
                                        jsc=mod(js+1,2)
                                        do 110 ls=0,1
                                        lsc=mod(ls+1,2)
                                        mi=ls*2**js+lsc
                                        mk=ls*2**jsc+lsc
                                        ifls=0
                                        do 100 j=1,6
                                           ibi=bin1(i,j)*mi
                                           ibk=bin1(k,j)*is*mk
                                           if (ibi.ne.ibk) ifls=1
  100                                   continue
                                        if (ifls.eq.0) then
                                            if (ich.eq.0) kk=kk+1
                                            ich=1
                                            vterm(i)=kk*mk
                                            vterm(k)=kk*is*mi
                                            endif
  110                          continue
                               if (vterm(i).eq.99) vterm(i)=1
                             endif
  120 continue
      if (vterm(6).eq.99) vterm(6)=1
      jpreva=0
      jprevb=0
      do 150 i=1,6
         vterm(i)=6-vterm(i)
               if (vterm(i).eq.0) then
                                    if (jprevb.eq.0) then
                                                 vterm(i)=20+i
                                                 jprevb=i
                                                else
                                                  vterm(i)=20+jprevb
                                                endif
          else if (vterm(i).eq.3) then
                                    if (jprevb.eq.0) then
                                                  vterm(i)=i
                                                  jprevb=i
                                                else
                                                  vterm(i)=jprevb
                                                endif
          else if (vterm(i).eq.4) then
                                    if (jpreva.eq.0) then
                                                  vterm(i)=i
                                                  jpreva=i
                                                else
                                                  vterm(i)=jpreva
                                                endif
          else if (vterm(i).eq.5) then
                                    vterm(i)=i
          else if (vterm(i).eq.6) then
                                    vterm(i)=0
          else if (vterm(i).eq.9) then
                                    if (jprevb.eq.0) then
                                                  vterm(i)=-i
                                                  jprevb=i
                                                else
                                                  vterm(i)=-jprevb
                                                endif
                                  endif
  150 continue
      do 170 j=4,9
      i=j-3
      jv=vterm(i)
      if (jv.ne.0) then
         if (jv.le.9) then
                        jv=jv+3*isign(1,jv)
                      else
                        jv=(mod(jv,20)+3)+20
                      endif
                   endif
  170 key(j)=jv
      if (key(9).le.6.and.key(9).ge.4) key(9)=key(9)+10
      return
      end
c----------------------------------------------------------------------
      block data utabli
c
c--utility tables initialization
c
      character lsqt(28)*6,itrt(30)*12,sitin(85)*6
      integer jsiti(194),cvet(194),vcoll(25,2),mpv(64),ksiti(64)
      common /tab1/ jsiti,vcoll,cvet,ksiti,mpv
      common /tab2/ sitin,lsqt,itrt
      common /tab3/ ijt(6,2),iit(6),numpr(29),ktlsq(28)
      common /tab4/ lsqv(28),ktlsn(28)  
      data ijt/1,2,3,1,1,2,1,2,3,2,3,3/
      data iit/1,5,9,2,3,6/
      data numpr/   555656,555566,555665,555666,445566,445533,445539,
     *445666,544665,544335,544935,544666,545456,545466,545430,445466,
     *444666,444333,555555,455403,455465,455466,444393,444339,444399,
     *454359,454353,454666,454656/
      data ktlsq/535050,506150,505063,506163,535063,536150,505050,
     *           535350,534750,535363,534763,536163,535650,565350,
     *           535663,565363,506161,506139,535053,535047,536139,
     *           536161,536153,536147,535353,535347,534753,534747/
      data ksiti/1219,103,115,112,112,201,220,228,228,302,316,316,308,
     *308,316,316,807,906,1711,1926,2027,1810,2518,2518,2824,2824,2723,
     *2723,2625,2625,1421,1313,719,403,1515,712,712,501,1620,728,728,
     *602,716,716,708,708,716,716,1107,1006,2111,2426,2327,2210,718,718,
     *724,724,723,723,725,725,421,513/
      data mpv/
     *        273,139537,140563, 65697, 16545,131857,135961,  2132,
     *      32852,  8977,  9498,  4875,  1290,  4362,  1291,  4378,
     *     131338,136458,   673,  8276, 43092, 82593,   140,    98,
     *      33890,  6284, 17506, 69772, 49250, 67724,139545,131859,
     *     140049,   785,   787, 17057, 66209,  8465,  8473, 41044,
     *      10324,131345,135450,132363,135434,132362,135947,140570,
     *       5386,   266, 82081, 34900,    84,   161, 71820, 50274,
     *      16482, 65676, 32866,  2188,  1122,  4236,  4889,  9491/
      data jsiti/0,11417,16666,16906,17170,17434,17674,17938,20826,21074
     *,21458,21722,21850,22098,22490,22738,34570,34578,34586,16667,16907
     *,17171,17435,17675,17939,33059,33315,33571,34571,34579,34587,34595
     *,67363,-16668,-16908,17172,17436,17676,17940,18492,18740,18996
     *,19260,33316,33572,33580,33604,34580,34596,34604,34612,34620,34628
     *,34860,35116,66372,67364,67372,-67396,67404,132932,16765,17061
     *,17173,17581,17773,17941,18493,18741,18997,19261,19821,20141,20349
     *,20645,25477,33141,33461,33581,33653,33717,34581,34605,34613,34621
     *,34669,34677,34685,34725,34733,34741,34861,35117,36213,36533
     *,-50053,-51077,67445,99205,-100229,198533,16670,16910,18494,18742
     *,20830,21078,21462,21726,31126,31438,31678,31942,33102,33518,34590
     *,34598,34606,34638,34790,-34798,34862,35118,37198,37454,37870
     *,38126,-51094,-51134,-51142,-51150,55702,56014,56254,56518,65894
     *,66278,66374,-67398,67406,-67430,-67558,67566,-100238,100246
     *,100286,100294,100302,132934,132966,133094,-198542,395150,16767
     *,17063,18495,25479,-51079,18329,17678,17438,17942,33062,33318
     *,33574,33126,33510,33606,18998,19262,22102,22494,22742,17174,67509
     *,67373,67366,34574,34582,67374,34588,34572,33582,34662,34630,19263
     *,20351,34623,34687,34727,50055,100231,20647,21854/
c
      data lsqt/' x 0 0',' 0 y 0',' 0 0 z',' 0 y z',' x 0 z',
     *          ' x y 0',' 0 0 0',' x x 0',' x-x 0',' x x z',
     *          ' x-x z',' x y z',' x2x 0','2x x 0',' x2x z',
     *          '2x x z',' 0 y y',' 0 y-y',' x 0 x',' x 0-x',
     *          ' x y-y',' x y y',' x y x',' x y-x',' x x x',
     *          ' x x-x',' x-x x',' x-x-x'/
      data itrt/
     *' - - - 0 - 0' , ' - - - - 0 0' , ' - - - 0 0 -' , ' - - - 0 0 0',
     *' a a - - 0 0' , ' a a - - b b' , ' a a - - b-b' , ' a a - 0 0 0',
     *' - a a 0 0 -' , ' - a a b b -' , ' - a a-b b -' , ' - a a 0 0 0',
     *' - a - a - 0' , ' - a - a 0 0' , ' - a - a b2b' , ' a a - a 0 0',
     *' a a a 0 0 0' , ' a a a b b b' , ' - - - - - -' , ' a - - a2b b',
     *' a - - a 0 -' , ' a - - a 0 0' , ' a a a b-b b' , ' a a a b b-b',
     *' a a a b-b-b' , ' a - a b --b' , ' a - a b - b' , ' a - a 0 0 0',
     *' a - a 0 - 0' , ' ? ? ? ? ? ?'/
c
      data sitin/        'h.y.s.'
     *,'1     ','-1    ','2..   ','.2.   ','..2   ','..2   ','..2   '    8
     *,'..2   ','..2   ','m 011 ','m 101 ','m -101','m 01-1','m..   '   15
     *,'.m.   ','..m   ','2/m.. ','.2/m. ','..2/m ','222   ','222.  '   22
     *,'222.. ','2mm   ','m2m   ','mm2   ','mmm   ','2.mm  ','2.22  '   29
     *,'m.2m  ','m.m2  ','m.mm  ','4..   ','-4..  ','422   ','42.2  '   36
     *,'4m2   ','-42m  ','-4m2  ','4m.m  ','-42.m ','-4m.2 ','4/m.. '   43
     *,'4/mmm ','4/mm.m','3..   ','-3..  ','.3.   ','32.   ','3.2   '   50
     *,'.32   ','3m.   ','.3m   ','.-3m  ','-3m.  ','-3.m  ','.-3m  '   57
     *,'m-3.  ','m-3m  ','6..   ','-6..  ','6mm   ','-6m2  ','6/m.. '   63
     *,'622   ','6/mmm ','23.   ','-43m  ','432   ','mmm.  ','2mm.  '   71
     *,'m2m.  ','.-3.  ','32    ','3.    ','.2    ','4mm   ','3.m   '   78
     *,'-3m   ','3m    ','mm2.. ','mmm.. ','.m    ','.2/m  ','-3.   '/
      data cvet/1, 2, 4, 5, 6,15,16,17, 7,10, 8, 9,11,14,13,12,19,20,18,
     * 4, 5, 6,15,16,17,24,25,26,19,20,18,21,27, 5, 5, 4,16,16,15, 6, 6,
     *17,17,72,71,28,33,18,22,29,20,20,34,30,30,77,70,32,38,32,44, 5, 5,
     * 4,17,17,15, 5, 6,17,16, 6, 6,16,16,46,25,25,24,24,24,18,21,20,19,
     *20,21,19,19,20,21,25,26,26,26,49,50,27,62,55,66, 4, 4, 6, 6, 6, 6,
     * 6, 6,48,48,48,48,28,28,18,23,29,29,34,29,31,31,31,31,31,31,51,51,
     *73,51,53,53,53,53,40,40,40,43,32,41,41,32,54,54,54,54,54,45,45,45,
     *68,59,76,76,76,75,74, 3,15,15,15,81,81,81,33,33,33,17,17,17,17,17,
     * 4,27,27,82,18,18,32,19,19,28,34,34,83,83,84,84,84,80,79,83,17/
c
      data vcoll/64208,56006,56106,44208,-53312,53306,53006,63012,-53006
     *,44008,42002,62004,-63324,-44108,64024,-63006,-64108,63006,64008,
     *56412,56012,-56112,64624,-73006,73006,42,60,61,39,79,80,74,67,47,
     *35,5,29,58,43,69,73,43,51,36,63,65,64,68,85,74/
      data lsqv/    111010,101210,101013,101213,111013,111210,101010,
     *111110,110910,111113,110913,111213,113110,311110,113113,311113,
     *101212,101208,111011,111009,111208,111212,111211,111209,111111,
     *111109,110911,110909/
      data ktlsn/0144,0414,0441,0411,0141,0114,0444,
     *           1224,1204,1221,1201,0111,1234,1324,
     *           1231,1321,2422,2420,1242,1240,2120,
     *           2122,1212,1210,1222,1220,1202,1200/
      end
c-----------------------------------------------------------------------
      subroutine gpsie(numb,error,dalfa,nexp)
c
c++ sostituito nreft con npse in sflxx
c++ spostato nexp=.. dopo 4060
c
c-- subroutine to determine phases of not so strong
c-- reflections
      common /xdata/ ihkl(31000),e(31000),iphaz(31000),iphb(31000)
     *              ,wt(31000),duma(5000),dummpc(84000)
      common/ureq/ ihx(3),ksigma,knw,jpart,jtran,fosog,nonos,iprin,iflag
      common/trig/sint(450),pi,twopi,dtor,rtod
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common/xfour/ jtype,iprint,numero,iw,ilx ,imx ,iv  ,ix
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      dimension mat(3,8000),vet(12),ivet(12),iphi(300),itype(300)
Corig dimension cost(400)
      dimension cost(360)
      equivalence (sint(91),cost(1))
      equivalence (vet(1),ivet(1))
c
c     cutoff=5.0
      cutoff=0.0
      iprea=0
      if (iprin.gt.2) then
                        write(lo,26)
                        write(lo,28)(i,wt(i),i=1,numb)
                      endif
 26   format(//10x,'tabella pesi'/)
 28   format(7(3x,i5,f9.2))
      call srlin (24,lsn,lfw,llw,lpb,ll)
c-- check if list 24 exists
      if(lfw) 4500,4500,4002
 4002 if (iprin.gt.2) write(lo,4005)
 4005 format(//,'  lettura  relazioni psi-e       ',/)
c**** call sub. lettura lista 24:  relazioni psi-e
      call sflxx(iprea,24,ntot,ntrp,npse,nxxe,iccd,mat)
      if(ntrp.eq.0) goto 4500
      numb0=numb
c**** call sub. lettura preambolo lista 7
      call ysfl07(nrifl,mmm,mmmz,npseud,iy)
      if (iprin.gt.2) write(lo,150)nrifl,mmm,mmmz
  150 format(/,10x,' num. rif. tot. ',i5,5x,' num. rif. forti ',i5,5x,
     * ' num. rif. deboli ',i5,/)
      if (iprin.gt.2) write(lo,4010) ntot,npse
 4010 format('   n. relazioni psi-e  = ',i6,' formate da',i4,' riflessi'
     * ,' con e<e(min)')
      ifin=numb+npse
      do 160 i=numb+1,ifin
  160 iphaz(i)=0
      ic=0
      do 190 i=1,ifin
c**** call sub. lettura lista 7  per riflessi psi-e
      call snr07(vet)
      if(i.le.numb) go to 190
      ih=ivet(1)
      ik=ivet(2)
      il=ivet(3)
      e(i)=vet(4)
      ihkl(i)=262144*ih +512*ik +il +131328
      wt(i)=0.0
      iph=mod(ivet(8),2**15)
      ic=ic+1
      itype(ic)=mod(iph,32)
      iph=iph/32
      iphi(ic)=iph
  190 continue
      wgt=0.0
      snum=0.0
      sden=0.0
      snu=0.0
      sde=0.0
      alfmed=0.0
      var=0.0
      nctr=0
      tom=0.0
      error=0.0
      dalfa=0.0
      numb1=0
      if (iprin.gt.2) write(lo,200)
200   format(////10x,'lista riflessi psi-e con fasi determinate',//
     * '    num  kode  ( h  k  l )     e       w     ',
     * ' type  phi(p) phi(t)   diff  ncontr   alpha  alf(g)  alf(w)'/)
      ntr1=ntrp+1
      do 4050 i=1,ntr1
      if(i.eq.ntr1) then
                    kod1=9999
                    go to 4035
          endif
      call unpak3(mat(1,i),lod1,lod2,ifaz)
      call unpak3(mat(2,i),lod3,ig,ifaz)
      call unpak3(mat(3,i),kod,igg,idum)
      kod1=iabs(lod1)
      kod2=iabs(lod2)
      kod3=iabs(lod3)
c  kod1,kod2,kod3 = serial number of reflections
c  ig,ifaz = g*100,phase shift
      g=abs(float(ig)*0.01)
      if (i.eq.1) kod1o=kod1
4035  if (kod1.ne.kod1o) then
c  parte relativa ai riflessi speciali
      ic=kod1o-numb0
      if(itype(ic).eq.1) go to 4045
      idv = 15*mod(iabs(itype(ic))-1,12) + 1
      ssn=sint(idv)
      ccs=cost(idv)
      t2 = snum*ssn + sden*ccs
      snum = t2*ssn
      sden = t2*ccs
      t2 = snu*ssn + sde*ccs
      snu = t2*ssn
      sde = t2*ccs
 4045 continue
                         alfw=snum*snum+sden*sden
                         alfg=snu*snu+sde*sde
                         if (alfw.lt.0.0001) then
                         if (iprin.gt.2) 
     *                   write(lo,4046)kod1o,kod2,wt(kod2),kod3,wt(kod3)
 4046 format(5x,'reflection ',i5,' has no sign. contributors,   k2 ='
     * ,i5,'  wt(k2)=',f10.3,'  k3=',i5,'  wt(k3)=',f10.3/)
                             go to 3090
                           endif
                         pha=atan2(snum,sden)*rtod
                         aiu=sqrt(alfg)
                         aiu1=sqrt(alfw)
                         if(nctr.lt.4) go to 3080
                         if (var.lt.0.001) go to 3080
                         if(aiu.le.alfmed) go to 3080
                         d3=(aiu-alfmed)*(aiu-alfmed)
                         d2=d3/var
                         wh=exp(-d2)**(1./3.)
                         if(wh.lt.0.2) wh=0.2
                         d2=alfmed*wh
                         alfw=d2*d2




 3080                    alf=sqrt(alfw)





c3080                    alf=sqrt(alfg)



                         wgt=bes(alf)
                         wgt=wgt*wgt
                         if (aiu.lt.cutoff) wgt=0.0
                         ip=pha+sign(0.5,pha)
                         ip=mod(ip+3600,360)
                         if(ip.eq.0) ip=360
                         iphaz(kod1o)=ip
                 ih=ihkl(kod1o)/262144
                 ik=mod(ihkl(kod1o),262144)
                 il=mod(ik,512)-256
                 ik=ik/512-256
c                   tom=tom+alf
                    tom=tom+wgt
                    icb=iabs(ip-iphi(ic))
                    icb=min0(icb,360-icb)
                    t2=icb
                    error=error+t2
c                   dalfa=dalfa+t2*alf
                    dalfa=dalfa+t2*wgt
                    numb1=numb1+1
      if (iprin.gt.2) write(lo,185) numb1,kod1o,ih,ik,il,e(kod1o),
     *              wgt,itype(ic),
     *              iphi(ic),ip,icb,nctr,alf,aiu,aiu1,alfmed
  185 format(2i6,'*  (',3i3,')',2f8.2,5i8,4f8.2)
 3090                    snum=0.0
                         wt(kod1o)=wgt
c                        wt(kod1o)=wgt**2
                         if(kod1.gt.9000) go to 4060
                         sden=0.0
                         snu=0.0
                         sde=0.0
                         alfmed=0.0
                         var=0.0
                         kod1o=kod1
                         nctr=0
                         wgt=0.0
                         endif
          a1=bes(g)
          aa1=wt(kod2)*wt(kod3)*a1
          weig=besinv(aa1)
          idv=-iphaz(kod2)*isign(1,lod2) -
     *         iphaz(kod3)*isign(1,lod3) - 15*ifaz
          idv = mod(idv+36000,360) + 1
          snum=snum+weig*sint(idv)
          sden=sden+weig*cost(idv)
          snu=snu+g*sint(idv)
          sde=sde+g*cost(idv)
          alfmed=alfmed+g*a1
          d2=1.0-(2.0/g)*a1
          d3=1+d2-2.0*a1*a1
          var=var+g*g*d3
          nctr=nctr+1
 4050 continue
 4060 nexp=numb1
      if(numb1.gt.0) error=error/float(numb1)
      if(tom.gt.0.0001) dalfa=dalfa/tom
      numb1=numb+1
      do 4200 i=numb1,ifin
      e(i)=e(i)*wt(i)
 4200 continue
      numb=ifin
      nexp=ifin-numb1+1
c4500 stop
 4500 return
      end
c-----------------------------------------------------------------------
c     output peak heights, peak coordinates and cluster numbers
c     and special positions information
      subroutine outpea(host,izpk,kaction)
      character host*80,specie*2,cbuff*124
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),nno(8),nk,nat,f(9),nalf(8)
      common /atoms/ x(5,200),nz(200),idumx(21)
      common /atomo/ xyzo(5,200),nzo(200),dold(400)
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common /impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
      common /sdir/ dm,npc,nproj,nojoin
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common/ureq/ ihx(3),ksigma,knw,jpart,jtran,fosog,nonos,iprin,iflag
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,bfac(200),lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      common /atpos/ cbuff
      dimension xo(11),xn(11),keyx(10),newvet(48,3),izpk(500)
c
c-- label and interpret peaks
c
      if (jrecyc.eq.0) iprin=3
c
              if (krecy.eq.0) then
                                do 600 i=1,nats
  600                           izpk(i)=0
                                call maincl(izpk,kaction,iprin)
                                if (izpk(1).eq.-99999) izpk(1)=100
      else if (krecy.eq.1000) then
                                kaction=3
                                do 650 i=1,nats
  650                           izpk(i)=0
                                call maincl(izpk,kaction,iprin)
      else if (kaction.eq.5) then
                                kaction=5
      else if (krecy.ne.2000) then
                                jlig=nk
                                if (nno(1).eq.1) jlig=nk-1
                                jlig=jlig*100+1
                                do 800 i=1,nats
  800                           izpk(i)=jlig
                              endif
C     if (jrest.ne.1) then
C                       if (jrecyc.eq.100) then
C                                            errem=erreo
C                                            erre =erreo
C                                          else
C                                            errem=erre
C                                            erreo=erre
C                                          endif
C                       rfac=erreo*100.0
C                     else
C                       errem=erre
C                       rfac=erre*100.0
C                     endif
           if (jrest.eq.0) then
                        if (jrecyc.eq.100) then
                                             errem=erreo
                                             erre =erreo
                                           else
                                             errem=erre
                                             erreo=erre
                                           endif
      else if (jrest.eq.1) then
                             errem=erre
      else if (jrest.eq.2) then
                             erre=erreo
                             errem=erre
                           endif
      if (iprin.le.1) go to 915
      write(lo,810) itle
  810 format(//,1h , 79('+'),//,26x,
     1 '***   Output section  ***',//,2x,20a4,//)
      rfac=erre*100.0
      if (rfac.gt.0.0) write(lo,820) maxcyc,rfac
  820 format(/,' After ',i2,'  cycles final residual value ='
     *       ,f7.2,'% ',4i4,///)
      call xwrifl
      khead=0
      iactn=2
      ifspec=0
      do 840 i=1,nats
      do 830 k=1,3
  830 xo(k)=x(k,i)
      iser=i
      k=kspecb(newvet,xo,xn,keyx,itype,iser,khead,iactn)
      if (keyx(10).gt.1) ifspec=1
  840 continue
      if (ifspec.eq.0) then
                         write(lo,910)
                       else
                         write(lo,912)
                       endif
  910 format(/,' Atom  Height',5x,1hx,6x,1hy,6x,1hz,2x,'  B(iso) Frag',
     *        /)
  912 format(
     *  49x,1hi,18(1h-),'   special positions information   ',
     *  18(1h-),1hi,//,
     *  16x,'i--- found  in ---i',14x,'i--- moved  to ---i',
     4   9x,'i---------  restrictions  on  ---------i',/,
     1  ' Atom  Height',5x,1hx,6x,1hy,6x,1hz,2x,'  B(iso) Frag',
     3  2x,1hx,6x,1hy,6x,1hz,6x,'Occ.',5x,
     4  ' L.Sq. shifts & thermal parameters    Site',/)
  915 continue
      khead=0
      if (iprin.gt.1) then
                        iactn=3
                      else
                        iactn=2
                      endif
      do 950 i=1,nats
      izpki=izpk(i)
      is=1
      if (izpk(i).lt.0) then
                          is=-1
                          kfrag=0
                          izpki=iabs(izpki)
                          if (izpki/100.gt.nk) then
                                                 izpki=0
                                                 is=0
                                               endif
                        else
                          kfrag=mod(izpki,100)
                        endif
      izpki=izpki/100
      kk=nk-izpki+1
      izpk(i)=kk*is
      nz(i)=is*(kk*100+kfrag)
      k=x(4,i)+0.5
      if (iprin.gt.1) then
      do 918 j=1,124
  918 cbuff(j:j)=' '
      if (kk.le.nk) then
          write(specie,'(a2)') nalf(kk)
          call ucase(specie(1:1))
          write(cbuff,920) specie,i,k,(x(j,i),j=1,3),bfac(i),kfrag
        else
          write(cbuff,922)        i,k,(x(j,i),j=1,3)
        endif
                      endif
  920 format(1h ,  a2,i3,i6,2x,3f7.3,f7.2,i4)
  922 format(1h ,'Q ',i3,i6,2x,3f7.3,  7x,4h    )
      iser=i
      do 930 k=1,3
  930 xo(k)=x(k,i)
      do 940 k=4,11
  940 xo(k)=0.0
      k=kspecb(newvet,xo,xn,keyx,itype,iser,khead,iactn)
      if (keyx(10).gt.1) then
                           if (iprin.gt.1) then
                                             jump=1
                                           else
                                             jump=0
                                           endif
                           call site(newvet,keyx,jump,k)
                           do 945 k=1,3
  945                      x(k,i)=xn(k)
                         endif
      if (iprin.gt.1) then
          if (ifspec.eq.0) then
                             write(lo,'(a)') cbuff(1:50)
                           else
                             write(lo,'(a)') cbuff
                           endif
                      endif
  950 continue
      return
      end
c-----------------------------------------------------------------------
      subroutine site(newvet,key,jump,k)
c
      character*80 buff
      character*124 cbuff
c
      dimension newvet(48,3),key(10),lsqv(28),lterm(2,30)
      character         string*6
      character lsqt(28)*6,itrt(30)*12,sitin(85)*6
      integer jsiti(194),cvet(194),vcoll(25,2),mpv(64),ksiti(64)
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common /tab1/ jsiti,vcoll,cvet,ksiti,mpv
      common /tab2/ sitin,lsqt,itrt
      common /tab4/ lsqvx(28),ktlsn(28)
      common /tape/ cell(6),neqv,icent,lat,natm,ts(3,24),is(2,3,24),nsym
     *             ,dumb(3)
      common /erl/ kmat(48,3,3),tmat(48,3),nt(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common /atpos/ cbuff
c
c
c--   lsq shifts  code           therm. param. restr.  code
c--
c--
c--      x 0 0      110000             - - - 0 - 0      1
c--      0 y 0      001200             - - - - 0 0      2
c--      0 0 z      000013             - - - 0 0 -      3
c--      0 y z      001213             - - - 0 0 0      4
c--      x 0 z      110013             a a - - 0 0      5
c--      x y 0      111200             a a - - b b      6
c--      0 0 0      000000             a a - - b-b      7
c--      x x 0      111100             a a - 0 0 0      8
c--      x-x 0      110900             - a a 0 0 -      9
c--      x x z      111113             - a a b b -     10
c--      x-x z      110913             - a a-b b -     11
c--      x y z      111213             - a a 0 0 0     12
c--      x2x 0      113100             - a - a - 0     13
c--     2x x 0      311100             - a - a 0 0     14
c--      x2x z      113113             - a - a b2b     15
c--     2x x z      311113             a a - a 0 0     16
c--      0 y y      001212             a a a 0 0 0     17
c--      0 y-y      001208             a a a b b b     18
c--      x 0 x      110011             - - - - - -     19
c--      x 0-x      110009             a - - a2b b     20
c--      x y-y      111208             a - - a 0 -     21
c--      x y y      111212             a - - a 0 0     22
c--      x y x      111211             a a a b-b b     23
c--      x y-x      111209             a a a b b-b     24
c--      x x x      111111             a a a b-b-b     25
c--      x x-x      111109             a - a b --b     26
c--      x-x x      110911             a - a b - b     27
c--      x-x-x      110909             a - a 0 0 0     28
c--
      data lsqv/    111010,101210,101013,101213,111013,111210,101010,
     *111110,110910,111113,110913,111213,113110,311110,113113,311113,
     *101212,101208,111011,111009,111208,111212,111211,111209,111111,
     *111109,110911,110909/
      data lterm/141516,101810,141516,101019,141516,171010,141516,101010
     *          ,141416,101019,141416,171719,141416,170319,141416,101010
     *          ,141515,171010,141515,171818,141515,171802,141515,101010
     *          ,141516,101825,141516,101025,141516,371725,141416,101024
     *          ,141414,101010,141414,171717,141516,171819,141516,173724
     *          ,141516,171024,141516,101024,141414,170317,141414,170303
     *          ,141414,171703,141514,171803,141514,171817,141514,101010
     *          ,141514,101810,101010,101010/
c 
      mult=10000
      ilsq=0
      do 10 i=1,3
      ilsq=ilsq+(key(i)+10)*mult
   10 mult=mult/100
      k=0
      do 20 i=1,28
      lsqvx(i)=lsqv(i)
      if (ilsq.eq.lsqv(i)) k=i
   20 continue
      mult=10000
      it1=0
      it2=0
      do 30 i=1,3
      i1=i+3
      i2=i+6
      it1=it1+(key(i1)+10)*mult
      it2=it2+(key(i2)+10)*mult
   30 mult=mult/100
      kk=0
      do 40 i=1,30
      if (it1.eq.lterm(1,i).and.it2.eq.lterm(2,i)) kk=i
   40 continue
      ibuff=0
      if (k.eq.0.or.kk.eq.0) then
                               ibuff=1
                               write(buff,2000) key,ilsq,it1,it2,k,kk
                             endif
 2000 format(' errore ',10i3,3i8,5x,2i4)
      ilsqs=k
      iterm=kk
      nm=key(10)
      k=nm*10000+ilsqs*100+iterm
      ifin=194
      msys=jsys
      if (lat.eq.7) msys=7
      kkk=msys*1000000+k
      kcoll=0
      icont=0
      ks=1
      jj=msys
      if (k.eq.11219.or.k.eq.20719) jj=1
      num=nm*8192+ilsqs*256+iterm*8+jj
      do 50 i=2,ifin
         if (num.eq.iabs(jsiti(i))) then
                             icont=icont+1
                             ks=i
                                    endif
   50 continue
      if (jsiti(ks).ge.0) then
                            kkss=cvet(ks)
                            string=sitin(kkss)
                          else
          maxo =0
          meno1=1
          mm   =0
c -- look for the maximum order operator, for -1 and for mirrors
          do 60 i=1,nm-1
             if (iabs(newvet(i,1)).gt.maxo) maxo=iabs(newvet(i,1))
             if (newvet(i,1).eq.-1) meno1=-1
             if (newvet(i,1).eq.-2) mm=mm+1
   60     continue
          kcoll=meno1*(msys*10000+maxo*1000+mm*100+nm)
          kkss=1
          do 70 i=1,25
             if (vcoll(i,1).eq.kcoll) kkss=vcoll(i,2)
   70     continue
          string=sitin(kkss)
      endif
      if (jump.ne.0) then
          write(cbuff(119:124),'(a6)') string
          if (ibuff.eq.1) then
                            write(lo,'(a)') buff
                            write(lo,'(1h )')
                          endif
                      endif
c  90 format(1h+,117x,a6)
      if (kkss.eq.1) k=-1
      return
      end
