      SUBROUTINE MOLPLO(iPlT)
C
C                --------     MOLPLO    ----------
C
      IMPLICIT REAL *4 (M)
      CHARACTER *1 Lett
      CHARACTER *5 Lab
      CHARACTER *80 Titolo
C
      COMMON /Crt/ iBarre(62, 4),Lett(72),NumBar(70), iCheBarre(70, 6)
     2     , Rmin1, Rmin2, RMAX1, RMAX2, XMax, YMax, DDX, DDY, NPX, NPY
     3     , Lim1,Lim2,Lim3,Lim4,PI,Xmin,Ymin,LegCol,nlp, nMaxLeg
     5     , NumLeg, iPlotType , RK(4), VV(10,3), LE(800,2), RI(3)
      COMMON /Leg1/ LE1(800,2),nLegInd
      COMMON /atomi/ xyz(3,800),NAT, RR(800), iCol(800), iOrd(800),nv,
     *               MLU(800), Lab(800), RS(800), ipix(3,800),iEqui(800)
      COMMON /work/ rm(3,3), eval(3), evec(3,3), ainer(3,3)
      COMMON /Contr/ NF,iFirstTime,Titolo,Ratio,IfCont,IfEdge,IfScale,
     *               kplty,radii(8), IfScaleB
      common /screen/ kscreen,iy,ivd,kscrx,kscry,jscreen,kprog,ifMouse
      common /temp/ conn(9800)
      DIMENSION B(3, 3)
c
      call xspinb
c
      loop=0
      kcont=0
      CheScale = 1
      LegCol = 2
      NF=0
      iFirstTime = 1
      PI = 4 * ATAN(1.)
      iPlType=iPlT
      if (iPlType.eq.3) then
         iPlType=2
         iFirstTime = 0
      endif
      if (mod(kprog,10).eq.2) iPlType=2
      kplty=iPlType
c
c     il punto (Lim1,Lim2) e' il punto in alto a sinistra del viewport grafico
c     mentre (Lim3,Lim4) e' quello in basso a destra
c     i valori attuali sono per una VGA
c
      Lim1 = 0
Corig Lim2 = 40
      Lim2 = 0
      Lim3 = kscrx
      Lim4 = kscry
      Ratio = float(Lim3 - 80) / float(Lim4 - 20)
      NPX = Lim3 - Lim1
      NPY = Lim4 - Lim2
c
    8 Call Orto
      ind=8
      call defswi
c
      IfLeg = conn(1)
c
      if (IfLeg .eq.-1) then
         call BuildBonds(1)
      else
         call GetBonds(1)
      end if
c
   15 continue
      Rmin1 = 99999.
      Rmin2 = 99999.
      RMAX1 = -99999.
      RMAX2 = -99999.
c
      if (loop.eq.0) then
         iPlotType = iPlType
      else
         iPlotType = kplty
      endif
      CALL FindOr(B)
      CALL NewPage
      CALL MMenu(B,loop)
      if (loop.eq.1) go to 15
      if (loop.eq.2) go to 8
c
      return
      END
C ---------------------------------------------------------------------
      SUBROUTINE GetBonds(iAction)
 
      IMPLICIT REAL *4 (M)
      CHARACTER *1 Lett
      CHARACTER *5 Lab
      COMMON /Crt/ iBarre(62, 4),Lett(72),NumBar(70), iCheBarre(70, 6)
     2     , Rmin1, Rmin2, RMAX1, RMAX2, XMax, YMax, DDX, DDY, NPX, NPY
     3     , Lim1,Lim2,Lim3,Lim4,PI,Xmin,Ymin,LegCol,nlp, nMaxLeg
     5     , NumLeg, iPlotType , RK(4), VV(10,3), LE(800,2), RI(3)
      COMMON /Leg1/ LE1(800,2),nLegInd
      COMMON /atomi/ xyz(3,800),NAT, RR(800), iCol(800), iOrd(800),nv,
     *               MLU(800), Lab(800), RS(800), ipix(3,800),iEqui(800)
      COMMON /work/ rm(3,3), eval(3), evec(3,3), ainer(3,3)
      common /atoms/ x(5,200),nz(200),ngp,ninf(10),nag(10)
      common /temp/ conn(9800)
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
 
      lsq = 1
      VMod  = evec(1,lsq)**2 + evec(2,lsq)**2
      V1Mod = sqrt(VMod + evec(3,lsq)**2)
      VMod  = sqrt(VMod) / V1Mod
      if ( VMod .gt.  1.0 ) VMod = 1.0
      if ( VMod .lt. -1.0 ) VMod =-1.0
      Ang   = asin(VMod) * 180./ PI
c     Ang   = Ang + 0.5
      Ang   = SIGN(Ang, evec(3,lsq))
      RK(1) = Ang
      RK(2) = 4
      RK(3) = 1
      VV(1, 1) = evec(2,lsq)
      VV(1, 2) = -evec(1,lsq)
      VV(1, 3) = 0
      MaxLu = 2.05
      iColDef = 4
      Radius = .22
      DO 10 i = 1 , NAT + nv
         iOrd(i) = i
         if (iCol(i) .eq. 0) iCol(i) = iColDef
         if (abs(RS(i)) .lt. 0.00001) RS(i) = Radius
   10 CONTINUE
c
      if (iAction .eq.2) return
c
c ----  costruisci la tabella dei legami
c
      NumLeg = conn(1)
      j = 0
      DO 40 i = 1 , NumLeg
         i1 = i * 2
         i2 = i * 2 + 1
         n1 = conn(i1)
         n2 = conn(i2)
         if (nz(n1).ne.0.and.nz(n2).ne.0) then
             j = j + 1
             LE(j, 1) = conn(i1)
             LE(j, 2) = conn(i2)
         endif
         if (j .eq. nMaxLeg - nlp) goto 50
   40 CONTINUE
   50 NumLeg = j
c
      do 60 i = nMaxLeg - nlp + 1, nMaxLeg
         NumLeg = NumLeg + 1
         LE(NumLeg, 1) = LE(i, 1)
         LE(NumLeg, 2) = LE(i, 2)
   60 continue
c
      do 70 i = 1, NumLeg
         LE1(i, 1) = LE(i, 1)
         LE1(i, 2) = LE(i, 2)
   70 continue
      nLegInd = NumLeg
c
      return
      end
C ---------------------------------------------------------------------
      SUBROUTINE BuildBonds(iAction)
 
      IMPLICIT REAL *4 (M)
      REAL *4  LuLe,LuLeg
      CHARACTER *1 Lett
      CHARACTER *5 Lab
      COMMON /Crt/ iBarre(62, 4),Lett(72),NumBar(70), iCheBarre(70, 6)
     2     , Rmin1, Rmin2, RMAX1, RMAX2, XMax, YMax, DDX, DDY, NPX, NPY
     3     , Lim1,Lim2,Lim3,Lim4,PI,Xmin,Ymin,LegCol,nlp, nMaxLeg
     5     , NumLeg, iPlotType , RK(4), VV(10,3), LE(800,2), RI(3)
      COMMON /Leg1/ LE1(800,2),nLegInd
      COMMON /atomi/ xyz(3,800),NAT, RR(800), iCol(800), iOrd(800),nv,
     *               MLU(800), Lab(800), RS(800), ipix(3,800),iEqui(800)
      COMMON /work/ rm(3,3), eval(3), evec(3,3), ainer(3,3)
      common /temp/ conn(9800)
 
      lsq = 1
      VMod  = evec(1,lsq)**2 + evec(2,lsq)**2
      V1Mod = sqrt(VMod + evec(3,lsq)**2)
      VMod  = sqrt(VMod) / V1Mod
      if ( VMod .gt.  1.0 ) VMod = 1.0
      if ( VMod .lt. -1.0 ) VMod =-1.0
      Ang   = asin(VMod) * 180./ PI
c     Ang   = Ang + 0.5
      Ang   = SIGN(Ang, evec(3,lsq))
      RK(1) = Ang
      RK(2) = 4
      RK(3) = 1
      VV(1, 1) = evec(2,lsq)
      VV(1, 2) = -evec(1,lsq)
      VV(1, 3) = 0
      MaxLu = 2.05
      iColDef = 4
      Radius = .22
      DO 10 i = 1 , NAT + nv
         iOrd(i) = i
         if (iCol(i) .eq. 0) iCol(i) = iColDef
         if (abs(RS(i)) .lt. 0.00001) RS(i) = Radius
   10 CONTINUE
c
c ----  costruisci la tabella dei legami
c
      NumLeg = 0
      DO 40 i = 1 , NAT - 1
         if (Lab(i)(1:1).eq.'Q') go to 40
         iP1 = i + 1
         DO 30 j = iP1 , NAT
            if (Lab(j)(1:1).eq.'Q') go to 30
            IF (MLU(i) .lt. 0.00001) THEN
               LuLeg = MaxLu
            ELSE
               LuLeg = MLU(i)
            END IF
            DIS = 0
            DO 20 K = 1 , 3
               RAI = xyz(K,i)
               RAJ = xyz(K,j)
               DIS = DIS + (RAI - RAJ) ** 2
   20       CONTINUE
            DIS = SQRT(DIS)
            IF (MLU(j) .lt. 0.00001) THEN
               LuLe = MaxLu
            ELSE
               LuLe = MLU(j)
            END IF
            IF (LuLeg.LT.LuLe) LuLeg = LuLe
            IF (DIS.LE.LuLeg) THEN
               NumLeg = NumLeg + 1
               LE(NumLeg, 1) = i
               LE(NumLeg, 2) = j
            END IF
            IF (NumLeg .EQ. nMaxLeg - nlp) return
   30    CONTINUE
   40 CONTINUE
c
      do 60 i = nMaxLeg - nlp + 1, nMaxLeg
         NumLeg = NumLeg + 1
         LE(NumLeg, 1) = LE(i, 1)
         LE(NumLeg, 2) = LE(i, 2)
   60 continue
c
      if (iAction .eq. 1) then
         do 70 i = 1, NumLeg
            LE1(i, 1) = LE(i, 1)
            LE1(i, 2) = LE(i, 2)
   70    continue
         nLegInd = NumLeg
      end if
c
      return
      end
C ---------------------------------------------------------------------
      BLOCK DATA
      IMPLICIT REAL *4 (M)
      CHARACTER *1 Lett
      CHARACTER *5 Lab
c
      COMMON /atomi/ xyz(3,800),NAT, RR(800), iCol(800), iOrd(800),nv,
     *               MLU(800), Lab(800), RS(800), ipix(3,800),iEqui(800)
      COMMON /Crt/ iBarre(62, 4),Lett(72),NumBar(70), iCheBarre(70, 6)
     2     , Rmin1, Rmin2, RMAX1, RMAX2, XMax, YMax, DDX, DDY, NPX, NPY
     3     , Lim1,Lim2,Lim3,Lim4,PI,Xmin,Ymin,LegCol,nlp, nMaxLeg
     5     , NumLeg, iPlotType , RK(4), VV(10,3), LE(800,2), RI(3)
c
Caratteri
      DATA ((iBarre(i,j),j=1, 4),i=1, 62)
     */ 0,4,4,4,  0,2,4,2,  0,0,4,0,  0,4,0,2,  4,4,4,2,
     *  0,2,0,0,  4,2,4,0,  0,4,0,0,  4,4,4,0,  2,4,2,0,
     *  0,4,2,0,  2,0,4,4,  0,4,4,0,  0,0,4,4,  2,2,4,0,
     *  0,4,5,4,  3,4,3,0,  5,4,5,0,  0,2,4,4,  0,3,4,0,
     *  0,4,2,2,  2,2,4,4,  0,0,0,2,  0,4,2,4,  2,4,4,2,
     *  3,4,3,2,  0,0,2,0,  2,0,4,2,  2,2,4,0,
     *  0,4,2,4,  0,3,2,3,  0,2,2,2,  0,1,2,1,  0,0,2,0,
     *  0,4,0,0,  2,4,2,0,  0,4,0,2,  0,2,0,0,  2,4,2,2,
     *  2,2,2,0,  0,3,0,0,  2,3,2,0,  0,4,0,1,  2,4,2,1,
     *  2,3,2,2,  0,1,0,0,  0,3,1,0,  1,0,2,3,  2,2,0,0,
     *  0,2,2,0,  0,3,0,1,  2,3,2,-2, 0,-2,2,-2,  0,2,1,2,
     *  4,3,4,0,  2,3,4,3,  0,3,0,-2, 0,0,0,0,  0,4,0,4,
     *  1,0,3,0,  1,3,2,4,  1,4,2,4/
c
      DATA Lett
     */' ','A','B','C','D','E','F','G','H','I','J','K','L','M',
     * 'N','O','P','Q','R','S','T','U','V','W','X','Y','Z',
     * 'a','b','c','d','e','f','g','h','i','j','k','l','m',
     * 'n','o','p','q','r','s','t','u','v','w','x','y','z','/',
     * '''','-','+','.',':','?',
     * '0','1','2','3','4','5','6','7','8','9',' ',' '/
c
      DATA (NumBar(i),(iCheBarre(i,j),j = 1 , 6),i = 1, 36)
     */0, 0, 0, 0, 0, 0, 0,  4, 1, 2, 8, 9, 0, 0,  6, 8, 2, 7, 3,24,26,
     * 3, 1, 8, 3, 0, 0, 0,  5, 8, 3,24,25, 7, 0,  4, 8, 1, 2, 3, 0, 0,
     * 3, 8, 1, 2, 0, 0, 0,  4, 1, 8, 3, 7, 0, 0,  3, 8, 2, 9, 0, 0, 0,
     * 1, 8, 0, 0, 0, 0, 0,  3, 9, 3,23, 0, 0, 0,  3, 8,19,20, 0, 0, 0,
     * 2, 8, 3, 0, 0, 0, 0,  4, 8,21,22, 9, 0, 0,  3, 8,13, 9, 0, 0, 0,
     * 4, 1, 8, 3, 9, 0, 0,  4, 8, 1, 2, 5, 0, 0,  6, 8, 1, 5,27,28,29,
     * 5, 8, 1, 2, 5,15, 0,  5, 1, 2, 3, 4, 7, 0,  2, 1,10, 0, 0, 0, 0,
     * 3, 8, 3, 9, 0, 0, 0,  2,11,12, 0, 0, 0, 0,  4, 8,10, 9, 3, 0, 0,
     * 2,13,14, 0, 0, 0, 0,  4, 4, 2, 9, 3, 0, 0,  3, 1,14, 3, 0, 0, 0,
     * 5,31,42,33,46,34, 0,  4,35,32,40,34, 0, 0,  3,31,41,34, 0, 0, 0,
     * 4,32,38,34,36, 0, 0,  5,31,41,32,45,34, 0,  3,30,35,54, 0, 0, 0,
     * 5,31,34,51,52,53, 0,  3,35,32,40, 0, 0, 0,  2,38,59, 0, 0, 0, 0/
      DATA (NumBar(i),(iCheBarre(i,j),j = 1 , 6),i = 37, 70)
     */2,52,53, 0, 0, 0, 0,  3,35,49,50, 0, 0, 0,  3,10,60,62, 0, 0, 0,
     * 5,31,56,41,42,55, 0,  3,31,41,42, 0, 0, 0,  4,31,41,34,42, 0, 0,
     * 4,57,31,42,34, 0, 0,  4,31,34,41,52, 0, 0,  2,31,41, 0, 0, 0, 0,
     * 5,30,37,32,40,34, 0,  3,35,31,34, 0, 0, 0,  3,41,34,42, 0, 0, 0,
     * 2,47,48, 0, 0, 0, 0,  4,41,42,55, 3, 0, 0,  2,49,50, 0, 0, 0, 0,
     * 4,41,34,52,53, 0, 0,  3,31,49,34, 0, 0, 0,  1,14, 0, 0, 0, 0, 0,
     * 1, 4, 0, 0, 0, 0, 0,  1, 2, 0, 0, 0, 0, 0,  2, 2,10, 0, 0, 0, 0,
     * 1,58, 0, 0, 0, 0, 0,  2,58,59, 0, 0, 0, 0,  4,30,39,32,38, 0, 0,
     * 4, 1, 3, 8, 9, 0, 0,  3,10,60,61, 0, 0, 0,  5, 1, 5, 2, 6, 3, 0,
     * 4, 1, 2, 3, 9, 0, 0,  3, 4, 2, 9, 0, 0, 0,  5, 1, 4, 2, 7, 3, 0,
     * 5, 1, 8, 3, 7, 2, 0,  2, 1, 9, 0, 0, 0, 0,  5, 1, 2, 3, 8, 9, 0,
     * 5, 1, 2, 3, 4, 9, 0/
c
      END
c ---------------------------------------------------------------
      SUBROUTINE Orto
      REAL *4 MLu
      CHARACTER *80 Titolo
      CHARACTER*5 Lab
      COMMON /atomi/ xyz(3,800),NAT, RR(800), iCol(800), iOrd(800),nv,
     *               MLU(800), Lab(800), RS(800), ipix(3,800),iEqui(800)
      common/work/rm(3,3), eval(3), evec(3,3), ainer(3,3)
      COMMON /Contr/ NF,iFirstTime,Titolo,Ratio,IfCont,IfEdge,IfScale,
     *               kplty,radii(8), IfScaleB
      dimension asta(3)
c
      pi=4*datan(1.d0)
      call tomolplo1(a,b,c,alf,bet,gam)
      alf=pi/180*alf
      bet=pi/180*bet
      gam=pi/180*gam
c ---------
c ---------  sgs =  coseno di gamma star
c ---------
      sgs=(cos(alf)*cos(bet)-cos(gam))/(sin(alf)*sin(bet))
c ---------
c ---------  gams =  gamma star
c ---------
 
      if ( sgs .gt.  1.0 ) sgs = 1.0
      if ( sgs .lt. -1.0 ) sgs =-1.0
      gams=acos(sgs)
      v=a*b*c
      v=v*sqrt(sin(alf)**2+sin(bet)**2+sin(gam)**2-2+
     *    2*cos(alf)*cos(bet)*cos(gam))
      astar=b*c*sin(alf)/v
      bstar=a*c*sin(bet)/v
      cstar=a*b*sin(gam)/v
      asta(1)=astar
      asta(2)=bstar
      asta(3)=cstar
      rm(1,1)=a*sin(bet)
      rm(1,2)=-b*sin(alf)*cos(gams)
      rm(1,3)=0
      rm(2,1)=0
      rm(2,2)=b*sin(alf)*sin(gams)
      rm(2,3)=0
      rm(3,1)=a*cos(bet)
      rm(3,2)=b*cos(alf)
      rm(3,3)=c
c     read(ic,*) NAT
      call tomolplo2
*      do 90 i = 1, NAT
*c                                                 max
*c                                                lung di  raggio  1-7
*c                                    label  xyz  legame  palla  colore
*         read(ic,'(a3,1x,5f10.0,i4)') Lab(i), x, MLu(i), RS(i), iCol(i)
*         call molt1(rm,x,r)
*         xyz(1,i) = r(1)
*         xyz(2,i) = r(2)
*         xyz(3,i) = r(3)
*90    continue
c
      call LsPlane(NATV)
c
      return
      end
c ---------------------------------------------------------------
      SUBROUTINE LsPlane(NATV)
c
c--main routine for l.s. plane calculation
c
      common/work/rm(3,3), eval(3), evec(3,3), ainer(3,3)
      dimension xbar(3)
c
c---- set normal equations matrix for the best plane
c
      call fillmatr(ainer, xbar, NATV)
c
      if (NATV.eq.0) then
          return
      end if
c
c--search for the eigenvalues and eigenvectors
c
      call autov(ainer,eval,evec,icod)
c
      do 50 i=1 , 2
         do 30 j= i+1 , 3
            if (eval(i) .gt. eval(j)) then
               Dum = eval(i)
               eval(i) = eval(j)
               eval(j) = Dum
               do 10 k=1 , 3
                  Dum = evec(k,i)
                  evec(k,i) = evec(k,j)
                  evec(k,j) = Dum
   10          continue
            endif
   30    continue
   50 continue
c
      return
      end
c ---------------------------------------------------------------
      SUBROUTINE fillmatr(tmab, bard, NATV)
      REAL *4 MLU
      CHARACTER *5 Lab
      COMMON /atomi/ xyz(3,800),NAT, RR(800), iCol(800), iOrd(800),nv,
     *               MLU(800), Lab(800), RS(800), ipix(3,800),iEqui(800)
      dimension tmab(3,3),bard(3),xd(3)
c
      do 130 i = 1 , 3
           bard(i) = 0.0
           do 100 j=1,3
               tmab(i,j) = 0.0
  100      continue
  130 continue
c ----
c ----   trova il baricentro deli atomi visibili
c ----
      NATV = 0
      do 150 i = 1 , NAT
          if (RS(i).gt.0) then
              NATV = NATV + 1
              bard(1) = bard(1) + xyz(1,i)
              bard(2) = bard(2) + xyz(2,i)
              bard(3) = bard(3) + xyz(3,i)
          end if
  150 continue
c
      if (NATV.eq.0) then
          return
      end if
      bard(1) = bard(1) / NATV
      bard(2) = bard(2) / NATV
      bard(3) = bard(3) / NATV
c ----
c ----    shift degli atomi per avere l'origine sul baricentro
c ----
      do 200 i = 1 , NAT + nv
          xyz(1,i) = xyz(1,i) - bard(1)
          xyz(2,i) = xyz(2,i) - bard(2)
          xyz(3,i) = xyz(3,i) - bard(3)
  200 continue
      do 500 i=1,NAT
          if (RS(i).gt.0) then
              xd(1) = xyz(1,i)
              xd(2) = xyz(2,i)
              xd(3) = xyz(3,i)
              do 400 k=1,3
                  do 300 l=1,3
                      tmab(k,l) =tmab(k,l)+xd(k)*xd(l)
  300             continue
  400         continue
          end if
  500 continue
c
      return
      end
c ------------------------------------------------------------------
      SUBROUTINE autov(a,eigen,t,icod)
      dimension t(3,3),a(3,3),aik(3),eigen(3)
c
      itmax=50
      n=3
      nm1=n-1
      eps1=.1e-10
      eps2=eps1
      eps3=.1e-7
      sigma1=0
      offdsq=0
      do 2 i=1,3
      do 2 j=1,3
    2 t(i,j)=0.
      do 5 i=1,n
      sigma1=sigma1+a(i,i)**2
      t(i,i)=1.0
      ip1=i+1
      if (i.ge.n) go to 6
                    do 5 j=ip1,n
   5                offdsq=offdsq+a(i,j)**2
   6  s=2.*offdsq+sigma1
c
c  inizio iter. jacobi
c
      do 26 iter=1,itmax
      do 20 i=1,nm1
      ip1=i+1
      do 20 j=ip1,n
      q=abs(a(i,i)-a(j,j))
      if(q.le.eps1) goto 9
      if(abs(a(i,j)).le.eps2) goto 20
      p=2.*a(i,j)*q/(a(i,i)-a(j,j))
      spq=sqrt(p*p+q*q)
      csa=sqrt((1.+q/spq)/2.)
      sna=p/(2.*csa*spq)
      goto 10
    9 csa=1./sqrt(2.d0)
      sna=csa
   10 continue
c
      do 11 k=1,n
      holdki=t(k,i)
      t(k,i)=holdki*csa+t(k,j)*sna
   11 t(k,j)=holdki*sna-t(k,j)*csa
c
      do 16 k=i,n
      if(k.gt.j) goto 15
      aik(k)=a(i,k)
      a(i,k)=csa*aik(k)+sna*a(k,j)
      if(k.ne.j) goto 14
      a(j,k)=sna*aik(k)-csa*a(j,k)
   14 goto 16
   15 holdik=a(i,k)
      a(i,k)=csa*holdik+sna*a(j,k)
      a(j,k)=sna*holdik-csa*a(j,k)
   16 continue
c
      aik(j)=sna*aik(i)-csa*aik(j)
c
      do 19 k=1,j
      if (k.le.i) then
                    holdki=a(k,i)
                    a(k,i)=csa*holdki+sna*a(k,j)
                    a(k,j)=sna*holdki-csa*a(k,j)
                  else
                    a(k,j)=sna*aik(k)-csa*a(k,j)
                  endif
   19 continue
   20 a(i,j)=0.0
c
      sigma2=0.0
      do 21 i=1,n
      eigen(i)=a(i,i)
   21 sigma2=sigma2+eigen(i)**2
      if (abs(sigma2).gt.0.00001) then
         if(1.0-sigma1/sigma2.ge.eps3) goto 25
      end if
      icod=1
      return
   25 continue
   26 sigma1=sigma2
      icod=0
c
      return
      end
c ------------------------------------------------------------------
      SUBROUTINE molt1(a,b,c)
      dimension a(3, 3), b(3), c(3)
c
      do 20 i=1,3
         c(i)=0
         do 10 j=1,3
            c(i)=c(i)+a(i,j)*b(j)
   10    continue
   20 continue
c
      return
      end
c --------------------------------------------------------------------
      SUBROUTINE FindOr(B)
      IMPLICIT REAL*4 (M)
      CHARACTER *1 Lett
      CHARACTER *5 Lab
c
      COMMON /atomi/ xyz(3,800),NAT, RR(800), iCol(800), iOrd(800),nv,
     *               MLU(800), Lab(800), RS(800), ipix(3,800),iEqui(800)
      COMMON /Crt/ iBarre(62, 4),Lett(72),NumBar(70), iCheBarre(70, 6)
     2     , Rmin1, Rmin2, RMAX1, RMAX2, XMax, YMax, DDX, DDY, NPX, NPY
     3     , Lim1,Lim2,Lim3,Lim4,PI,Xmin,Ymin,LegCol,nlp, nMaxLeg
     5     , NumLeg, iPlotType , RK(4), VV(10,3), LE(800,2), RI(3)
      DIMENSION B(3, 3), BOpt(3, 3)
c
      DO 20 j = 1 , 3
         DO 10 i = 1 , 3
            B(i, j) = 0
   10    CONTINUE
         B(j, j) = 1
   20 CONTINUE
c
      CALL CombRot(B)
*     CALL RotAtoms(B, 2)
      CALL RotAtoms(B, 1)
      CALL SetScale(4)
      SupMin = abs((RMAX1-Rmin1)/RS(1))
      DO 40 i = 1 , 3
         DO 30 j = 1 , 3
            BOpt(i, j) = 0
            B   (i, j) = 0
*           BOpt(i, j) = B(i, j)
   30    CONTINUE
         BOpt(i, i) = 1
         B   (i, i) = 1
   40 CONTINUE
      RK(1) = 0
      DO 90 NuR = 1 , 18
         RK(1) = RK(1) + 10
         RK(2) = 3
         DO 44 j = 1 , 3
            DO 42 i = 1 , 3
               B(i, j) = 0
   42       CONTINUE
            B(j, j) = 1
   44    CONTINUE
         CALL CombRot(B)
         Rmin1 = 99999.
         Rmin2 = 99999.
         RMAX1 = -99999.
         RMAX2 = -99999.
         CALL RotAtoms(B, 2)
         CALL SetScale(4)
         sca=abs((RMAX1-Rmin1)/RS(1))
         IF (sca .lt. SupMin) then
                                SupMin = sca
                                DO 80 i = 1 , 3
                                   DO 70 j = 1 , 3
                                      BOpt(i, j) = B(i, j)
   70                              CONTINUE
   80                           CONTINUE
                              END IF
   90 CONTINUE
      Rmin1 = 99999.
      Rmin2 = 99999.
      RMAX1 = -99999.
      RMAX2 = -99999.
      CALL RotAtoms(BOpt, 1)
c
      RETURN
      END
C -----------------------------------------------------------------
      SUBROUTINE Balls
      IMPLICIT REAL*4 (M)
      CHARACTER *1 Lett
      CHARACTER *5 Lab
      CHARACTER *80 Titolo
      INTEGER *4 CC,O1,O2,O3,O4,X11,Y11,R
c
      COMMON /atomi/ xyz(3,800),NAT, RR(800), iCol(800), iOrd(800),nv,
     *               MLU(800), Lab(800), RS(800), ipix(3,800),iEqui(800)
      COMMON /Crt/ iBarre(62, 4),Lett(72),NumBar(70), iCheBarre(70, 6)
     2     , Rmin1, Rmin2, RMAX1, RMAX2, XMax, YMax, DDX, DDY, NPX, NPY
     3     , Lim1,Lim2,Lim3,Lim4,PI,Xmin,Ymin,LegCol,nlp, nMaxLeg
     5     , NumLeg, iPlotType , RK(4), VV(10,3), LE(800,2), RI(3)
      COMMON /Contr/ NF,iFirstTime,Titolo,Ratio,IfCont,IfEdge,IfScale,
     *               kplty,radii(8), IfScaleB
      DIMENSION S(3)
c
      DO 20 i = 1 , (NAT + nv) - 1
         DO 10 K = i + 1 , NAT + nv
            O1 = iOrd(i)
            O2 = iOrd(K)
            O3 = xyz(3,O1)
            O4 = xyz(3,O2)
            IF (O3.GT.O4) THEN
               iOrd(i) = O2
               iOrd(K) = O1
            END IF
   10    CONTINUE
   20 CONTINUE
c
      CALL NewPage
c
      DDX = (XMax - Xmin) / NPX
      DDY = (YMax - Ymin) / NPY
      DO 50 III = 1 , NAT + nv
         IJ = iOrd(III)
         if (RS(IJ).LE.0.0) go to 50
c
c        if (IfEdge.eq.1 .OR. IJ.le.NAT) then
c           CALL DisePalle(IJ, X11, Y11, R, CC)
c        end if
c
      X11 = ipix(1,IJ)
      Y11 = ipix(2,IJ)
      RR(IJ) = RS(IJ)
      CC = ICol(IJ)
      R = ipix(3,IJ)
c      R = R+2
         DO 40 NLL = 1 , NumLeg
            N1 = LE(NLL, 1)
            if (IfEdge.eq.0 .AND. N1.gt.NAT) GOTO 40
            N2 = LE(NLL, 2)
            IF (N1.NE.IJ.AND.N2.NE.IJ) GOTO 40
            IF (N1 .LT. 0)  GOTO 40
            IF (RR(N1) .LE. 0 .OR. RR(N2) .LE. 0)  GOTO 40
 
            RAN1 = xyz(3,N1)
            RAN2 = xyz(3,N2)
            IF (RAN1.GT.RAN2) THEN
               NDUM = N1
               N1 = N2
               N2 = NDUM
            END IF
            DO 30 i = 1 , 3
               DU1 = xyz(i,N1)
               DU2 = xyz(i,N2)
               S(i) = DU1 - DU2
   30       CONTINUE
            SS = S(1) ** 2 + S(2) ** 2
            if (SS .LT. 0.001) goto 34
            SSS = SS + S(3) ** 2
            RL = SQRT(SSS)
            RL2 = SQRT(SS)
            RN21 = xyz(1,N2)
            RN22 = xyz(2,N2)
            RN11 = xyz(1,N1)
            RN12 = xyz(2,N1)
            S1 = S(1)
            S2 = S(2)
            RR1 = RR(N1)
            if ( N2 .gt. NAT ) then
                                 RR2 = RR(N2)
                               else
                                 RR2 = RR(N2) - 2 * DDX
                               endif
            p1 = S1 / RL2 * RR2 + RN21
            p2 = S2 / RL2 * RR2 + RN22
            p3 = -S1 / RL * RR1 + RN11
            p4 = -S2 / RL * RR1 + RN12
            P3RN = (p3 - RN21) ** 2
            P4RN = (p4 - RN22) ** 2
            P3P4 = P3RN + P4RN
            P3P4 = SQRT(P3P4)
            IF (P3P4 .LT. RR(N2) .OR. P3P4 .LT. RR(N1))  GOTO 34
            RN13 = xyz(3,N1)
            RN23 = xyz(3,N2)
            DEL = ABS(RN13 - RN23)
            DIS = RL
            RAP = (DIS - DEL) / DIS
            if (IJ.gt.NAT) then
               CALL Linea0(p1, p2, p3, p4, 7)
            else
               CALL DisLegN(p1, p2, p3, p4, RAP)
               Ize = 0
               if (iPlotType .NE. 6) then
                  CALL Cerchio ( X11, Y11, R, CC, Ize, Ize)
               end if
            end if
c
   34       CONTINUE
            LE(NLL, 1) = -LE(NLL, 1)
   40    continue
         if (IJ.le.NAT) then
            CALL DisePalle(IJ, X11, Y11, R, CC)
            if (Lab(IJ)(1:1).eq.'Q' .and. iPlotType.ne.3) then
               IRT = 0.6 * R - 2
               if (IRT .gt. R-2) IRT = R-2
               if (IRT .lt. 1) IRT = 1
c              CCV = CC
c              CC = 0
c              CALL DisePalle(IJ, X11, Y11, IRT, CC)
c              CC = CCV
               IfF = -1
               iCC=0
               Call Cerchio( X11, Y11, IRT, iCC, IfF, iCC)
               if (iPlotType.eq.5) then
                  IfF = 0
                  iCC = CC
                  Call Cerchio( X11, Y11, IRT, iCC, IfF, iCC)
               end if
            end if
         end if
   50 CONTINUE
c
      RETURN
      END
C -----------------------------------------------------------------
      SUBROUTINE CombRot(B)
      IMPLICIT REAL*4 (M)
      CHARACTER *1 Lett
      CHARACTER *5 Lab
c
      COMMON /atomi/ xyz(3,800),NAT, RR(800), iCol(800), iOrd(800),nv,
     *               MLU(800), Lab(800), RS(800), ipix(3,800),iEqui(800)
      COMMON /Crt/ iBarre(62, 4),Lett(72),NumBar(70), iCheBarre(70, 6)
     2     , Rmin1, Rmin2, RMAX1, RMAX2, XMax, YMax, DDX, DDY, NPX, NPY
     3     , Lim1,Lim2,Lim3,Lim4,PI,Xmin,Ymin,LegCol,nlp, nMaxLeg
     5     , NumLeg, iPlotType , RK(4), VV(10,3), LE(800,2), RI(3)
      DIMENSION DU(3, 3), VU(10), W(3, 3), B(3,3)
c
         IF (nint(RK(2)) .EQ. 0) GOTO 80
         DO 20 ISS = 1 , 3
            DO 10 kSSI = 1 , 3
               DU(ISS, kSSI) = 0
   10       CONTINUE
   20    CONTINUE
         T = PI / 180 * RK(1)
         DSINT = SIN(T)
         DCOST = COS(T)
         IF (nint(RK(2)) .EQ. 1) THEN
            DU(1, 1) = 1
            DU(2, 2) = DCOST
            DU(3, 3) = DCOST
            DU(2, 3) = -DSINT
            DU(3, 2) = DSINT
         END IF
         IF (nint(RK(2)) .EQ. 2) THEN
            DU(1, 1) = DCOST
            DU(1, 3) = DSINT
            DU(2, 2) = 1
            DU(3, 1) = -DSINT
            DU(3, 3) = DCOST
         END IF
         IF (nint(RK(2)) .EQ. 3) THEN
            DU(1, 1) = DCOST
            DU(1, 2) = -DSINT
            DU(2, 1) = DSINT
            DU(2, 2) = DCOST
            DU(3, 3) = 1
         END IF
         IF (nint(RK(2)) .EQ. 4) THEN
            NRTO = RK(3)
            PAR = VV(NRTO, 1) ** 2 + VV(NRTO, 2) ** 2
            PAR = PAR + VV(NRTO, 3) ** 2
            DDN = SQRT(PAR)
            DO 30 i = 1 , 3
               VU(i) = VV(NRTO, i) / DDN
   30       CONTINUE
            VU(4) = -VU(2)
            VU(5) = VU(1)
            ANG = RK(1)
            RO = PI / 180 * ANG
            CORO = COS(RO)
            SIRO = SIN(RO)
            UCORO = 1 - CORO
            DO 50 i = 1 , 3
               DO 40 j = i , 3
                  DU(i, j) = VU(i) * VU(j) * UCORO
                  IF (i.EQ.j) THEN
                     DU(i, j) = DU(i, j) + CORO
                  ELSE
                     DU(j, i) = DU(i, j) + VU(i + j) * SIRO
                     DU(i, j) = DU(i, j) - VU(i + j) * SIRO
                  END IF
   40          CONTINUE
   50       CONTINUE
         END IF
 
         CALL Molt2(B, DU, W)
 
         DO 70 i = 1 , 3
            DO 60 j = 1 , 3
               B(i, j) = W(i, j)
   60       CONTINUE
   70    CONTINUE
   80 CONTINUE
c
      RETURN
      END
c ----------------------------------------------------------------------
      SUBROUTINE AggiuSpig
      CHARACTER *5 Lab
      CHARACTER *1 Lett
      COMMON /atomi/ xyz(3,800),NAT, RR(800), iCol(800), iOrd(800),nv,
     *               MLU(800), Lab(800), RS(800), ipix(3,800),iEqui(800)
      COMMON /Crt/ iBarre(62, 4),Lett(72),NumBar(70), iCheBarre(70, 6)
     2     , Rmin1, Rmin2, RMAX1, RMAX2, XMax, YMax, DDX, DDY, NPX, NPY
     3     , Lim1,Lim2,Lim3,Lim4,PI,Xmin,Ymin,LegCol,nlp, nMaxLeg
     5     , NumLeg, iPlotType , RK(4), VV(10,3), LE(800,2), RI(3)
      common/work/rm(3,3), eval(3), evec(3,3), ainer(3,3)
      common /temp/  conn(9800)
      DIMENSION x1(3), r(3), lega(12,2)
c
      nMaxAtm = 800
c
      lega(  1, 1) = 1
      lega(  1, 2) = 4
      lega(  2, 1) = 1
      lega(  2, 2) = 5
      lega(  3, 1) = 1
      lega(  3, 2) = 6
      lega(  4, 1) = 2
      lega(  4, 2) = 4
      lega(  5, 1) = 2
      lega(  5, 2) = 5
      lega(  6, 1) = 2
      lega(  6, 2) = 7
      lega(  7, 1) = 3
      lega(  7, 2) = 4
      lega(  8, 1) = 3
      lega(  8, 2) = 6
      lega(  9, 1) = 3
      lega(  9, 2) = 7
      lega( 10, 1) = 8
      lega( 10, 2) = 5
      lega( 11, 1) = 8
      lega( 11, 2) = 6
      lega( 12, 1) = 8
      lega( 12, 2) = 7
 
      xyz(1, NAT + 1) = 1
      xyz(2, NAT + 1) = 0
      xyz(3, NAT + 1) = 0
      xyz(1, NAT + 2) = 0
      xyz(2, NAT + 2) = 1
      xyz(3, NAT + 2) = 0
      xyz(1, NAT + 3) = 0
      xyz(2, NAT + 3) = 0
      xyz(3, NAT + 3) = 1
      xyz(1, NAT + 4) = 0
      xyz(2, NAT + 4) = 0
      xyz(3, NAT + 4) = 0
      xyz(1, NAT + 5) = 1
      xyz(2, NAT + 5) = 1
      xyz(3, NAT + 5) = 0
      xyz(1, NAT + 6) = 1
      xyz(2, NAT + 6) = 0
      xyz(3, NAT + 6) = 1
      xyz(1, NAT + 7) = 0
      xyz(2, NAT + 7) = 1
      xyz(3, NAT + 7) = 1
      xyz(1, NAT + 8) = 1
      xyz(2, NAT + 8) = 1
      xyz(3, NAT + 8) = 1
      do 200 i = NAT + 1, NAT + 8
         Lab(i) = ' '
         iCol(i) = 7
         RS(i) = 0.01
         do 150 j = 1, 3
            x1(j) = xyz(j, i)
  150    continue
         call molt1(rm,x1,r)
         xyz(1,i) = r(1)
         xyz(2,i) = r(2)
         xyz(3,i) = r(3)
  200 continue
      nv = 9
      nlp = 0
      do 300 i = 1, 12
         j = lega(i,1) + NAT
         k = lega(i,2) + NAT
         x01 = xyz(1,j)
         y1 = xyz(2,j)
         z1 = xyz(3,j)
         x2 = xyz(1,k)
         y2 = xyz(2,k)
         z2 = xyz(3,k)
         dist = sqrt( (x01-x2)**2 + (y1-y2)**2 + (z1-z2)**2 )
         r0 = 2.5 / dist
         r1 = r0
         iu = j
  250    xm = x01 + (x2 - x01) * r1
         ym = y1 + (y2 - y1) * r1
         zm = z1 + (z2 - z1) * r1
         xyz(1, NAT + nv) = xm
         xyz(2, NAT + nv) = ym
         xyz(3, NAT + nv) = zm
         Lab(NAT + nv) = ' '
         iCol(NAT + nv) = 7
         RS(NAT + nv) = 0.01
         LE(nMaxLeg - nlp, 1) = iu
         LE(nMaxLeg - nlp, 2) = NAT + nv
         iu = NAT + nv
         nlp = nlp + 1
         r1 = r1 + r0
         nv = nv +1
         if (NAT + nv .gt. nMaxAtm) goto 400
         if (r1 .lt. 1.) then
             goto 250
         else
             LE(nMaxLeg - nlp, 1) = iu
             LE(nMaxLeg - nlp, 2) = k
             nlp = nlp + 1
         end if
  300 continue
  400 LE(nMaxLeg - nlp, 1) = 0
      LE(nMaxLeg - nlp, 2) = 0
c
      return
      end
C -----------------------------------------------------------------
      SUBROUTINE MMenu(B,loop)
      IMPLICIT REAL*4 (M)
      CHARACTER *1 Lett, nt1
      CHARACTER *5 Lab
      CHARACTER *80 Titolo
      INTEGER *4 Asse, Angolo, AngDef
      COMMON /atomi/ xyz(3,800),NAT, RR(800), iCol(800), iOrd(800),nv,
     *               MLU(800), Lab(800), RS(800), ipix(3,800),iEqui(800)
      COMMON /Crt/ iBarre(62, 4),Lett(72),NumBar(70), iCheBarre(70, 6)
     2     , Rmin1, Rmin2, RMAX1, RMAX2, XMax, YMax, DDX, DDY, NPX, NPY
     3     , Lim1,Lim2,Lim3,Lim4,PI,Xmin,Ymin,LegCol,nlp, nMaxLeg
     5     , NumLeg, iPlotType , RK(4), VV(10,3), LE(800,2), RI(3)
      COMMON /GeneraC/ DePA, DeMA, DePB, DeMB, DePC, DeMC,
     *                 R(3, 3, 48), T(3, 48),
     *                 Shf(3, 3), Tra(3, 20), nsym, NatInd, nt1
      COMMON /Contr/ NF,iFirstTime,Titolo,Ratio,IfCont,IfEdge,IfScale,
     *               kplty,radii(8), IfScaleB
      common /mess/ Message,ifMess,lMess
      common /buffer/ ixv(100),iyv(100),dummr(315)
      common/xwi/ color,xo,yo,khead,Species,NumSpec,iHCopy,ipres,jpres
      common /screen/ kscreen,jy,ivd,kscrx,kscry,jscreen,kprog,ifMouse
      character *80 Message, Species(8)*2
      integer *2 color, xo, yo, khead
      DIMENSION B(3, 3)
c
      nbox=31
      AngDef = 5
c
      Asse = 1
      Angolo = 0
c
c-- flush screen
c
      if (loop.eq.0) then
         call zflush
      end if
c
      goto 50
   10 continue
 
      if (iFirstTime.eq.1) return
c
c-- event handling
c
 1999 continue
      if (ifMess.eq.1) call PrintMess
      iz=0
      call getkey(iz)
c
      if (iz.eq. 0) then
         jrest=0
         if (mod(kprog,10) .lt. 3) Call ModCom(jrest)
         loop=0
         khead = 1
         RETURN
      else if (iz.eq. 1) then
         iPlotType = 1
         Angolo = 0
         Asse = 1
         kplty=iPlotType
         if(IfScale.eq.1) GOTO 20
         GOTO 55
      else if (iz.eq. 2) then
         iPlotType = 2
         Angolo = 0
         Asse = 1
         kplty=iPlotType
         if(IfScale.eq.1) GOTO 20
         GOTO 55
      else if (iz.eq. 3) then
         iPlotType = 3
         Angolo = 0
         Asse = 1
         kplty=iPlotType
         if(IfScale.eq.1) GOTO 20
         GOTO 55
      else if (iz.eq. 4) then
         iPlotType = 4
         Angolo = 0
         Asse = 1
         kplty=iPlotType
         if(IfScale.eq.1) GOTO 20
         GOTO 55
      else if (iz.eq. 5) then
         iPlotType = 5
         Angolo = 0
         Asse = 1
         kplty=iPlotType
         if(IfScale.eq.1) GOTO 20
         GOTO 55
      else if (iz.eq. 6) then
         iPlotType = 6
         Angolo = 0
         Asse = 1
         kplty=iPlotType
         if(IfScale.eq.1) GOTO 20
         GOTO 55
      else if (iz.eq. 7) then
         Angolo = -AngDef
         Asse = 1
      else if (iz.eq. 8) then
         Angolo = AngDef
         Asse = 1
      else if (iz.eq. 9) then
         Angolo = -AngDef
         Asse = 2
      else if (iz.eq.10) then
         Angolo = AngDef
         Asse = 2
      else if (iz.eq.11) then
         Angolo = -AngDef
         Asse = 3
      else if (iz.eq.12) then
         Angolo = AngDef
         Asse = 3
      else if (iz.ge.13.and.iz.le.18) then
         call Traslate(iz)
         Angolo = 0
         Asse = 1
         go to 55
      else if (iz.eq.19) then
         if (IfEdge.eq.0) then
            IfEdge = 1
         else
            IfEdge = 0
         endif
         GOTO 20
      else if (iz.eq.20) then
         if (IfCont.eq.0) then
            IfCont = 1
            NATind = NAT
            call Genera(B)
            iFirstTime = 0
            goto 50
         else
            IfCont = 0
c           NAT = NATind
            call SoloInd(B,NatInd)
            goto 50
         endif
         GOTO 20
      else if (iz.eq.21) then
         if (IfScale.eq.3) then
            IfScale = 1
         else
            IfScale = 3
            goto 10
         endif
         GOTO 20
      else if (iz.eq.22) then
         iPlotType = kplty
         Call DelAt
         if(IfScale.eq.1) GOTO 20
         goto 55
c        loop=1
c        RETURN
      else if (iabs(iz).eq.23 .or. iz.eq.123 .or. iz .eq. 223) then
         iPlotType = kplty
         Call DelHide(iz)
         if(IfScale.eq.1) GOTO 20
         goto 55
c        loop=1
c        RETURN
      else if (iz.ge.nbox+1 .and. iz .le. nbox+3 .or.
     *         iz.ge.nbox+6 .and. iz .le. nbox+8) then
         iPlotType = kplty
         iScelta = iz - nbox
         if (iScelta .gt. 3) iScelta = iScelta - 2
         Call ChePiano (iScelta)
         go to 50
      else if (iz.eq.25) then
         iPlotType = kplty
         Call ReLab(ixv(1),iyv(1),iyv(2))
         go to 55
      else if (iz.eq.26 .and. mod(kprog,10).lt.3) then
         iPlotType = kplty
         jrest=0
         Call ModCom(jrest)
         Call ReGro
         IfCont = 0
c        NAT = NATind
         call SoloInd(B,NatInd)
         IfEdge = 0
         IfScale= 1
         loop=2
         RETURN
      else if (iz.eq.27 .and. mod(kprog,10) .lt.3) then
         iPlotType = kplty
         jrest=1
         Call ModCom(jrest)
         loop=0
         khead = 1
*        ind = 1
*        iz=79
*        call graphs( ixv,iyv,iz,ind,Titolo,icolor)
         RETURN
      else if (iz.eq.28 .and. mod(kprog,10).lt.3) then
         iPlotType = kplty
         jrest=2
         Call ModCom(jrest)
         loop=0
         khead = 1
         RETURN
      else if (iz.eq.29) then
         iPlotType = kplty
         go to 55
      else if (iz.eq.30) then
         go to 50                   ! hard copy richiesta
      else if (iz.eq.-30) then
         Angolo=0                   ! ridisegna dopo hard copy
         Asse=1
         IfScaleB = IfScale
         IfScale = 2
         go to 20
      else if (iz.eq.131) then
         Call Distance
         go to 1999
      else if (iz.eq.231) then
         Call CalcAngle
         go to 1999
      else if (iz.eq.331) then
         Call TorsAngle
         go to 1999
      else if (iz.eq.631 .or. iz.eq.731 ) then
         Call AddDelBonds(iz, NatInd)
         go to 55
      else if (iz.eq.831) then
 2222    Call NumTable(iexit)
         if (iexit .eq. 0) goto 3333
         Call Histogr(iexit)
         if (iexit .eq. 2) goto 2222
 3333    khead = 1
         go to 55
      else
         go to 1999
      endif
c
      IF (Angolo .EQ. 0) GOTO 10
c
   20 RK(1) = Angolo
      RK(2) = Asse
      DO 40 i = 1 , 3
         DO 30 j = 1 , 3
            B(i, j) = 0
   30    CONTINUE
         B(i, i) = 1
   40 CONTINUE
      CALL CombRot(B)
      Rmin1 = 99999
      Rmin2 = 99999
      RMAX1 = -99999
      RMAX2 = -99999
      CALL RotAtoms(B, 1)
   50 CALL SetScale(IfScale)
   55 CALL AngToPix
      if (iPlotType.le.2) then
         CALL SticksOrd
      else
         CALL Balls
         DO 60 i = 1 , NumLeg
            LE(i, 1) = ABS(LE(i, 1))
   60    CONTINUE
         DO 70 i = 1 , NAT + nv
            RR(i) = 0
   70    CONTINUE
      end if
      Angolo = 0
      if (iz.eq.-30) then
          IfScale = IfScaleB
          call display_mouse_cursor
      end if
      GOTO 10
c
      END
C -----------------------------------------------------------------
      SUBROUTINE DisePalle(IJ, X11, Y11, R, CC)
      IMPLICIT REAL*4 (M)
      CHARACTER *1 Lett
      CHARACTER *5 Lab
      COMMON /atomi/ xyz(3,800),NAT, RR(800), iCol(800), iOrd(800),nv,
     *               MLU(800), Lab(800), RS(800), ipix(3,800),iEqui(800)
      COMMON /Crt/ iBarre(62, 4),Lett(72),NumBar(70), iCheBarre(70, 6)
     2     , Rmin1, Rmin2, RMAX1, RMAX2, XMax, YMax, DDX, DDY, NPX, NPY
     3     , Lim1,Lim2,Lim3,Lim4,PI,Xmin,Ymin,LegCol,nlp, nMaxLeg
     5     , NumLeg, iPlotType , RK(4), VV(10,3), LE(800,2), RI(3)
      common /scale/ x11scale(2),x11disp(2),ragmed,deltax,deltay
      common /screen/ kscreen,jy,ivd,kscrx,kscry,jscreen,kprog,ifMouse
      common /buffer/ ixv(100),iyv(100),dummr(315)
      common/xwi/ color,xo,yo,khead,Species,NumSpec,iHCopy,ipres,jpres
      integer *2 color, xo, yo, khead
      INTEGER *4  CC, CR
      DIMENSION EL(3, 3), C(3), RJ(3)
      DIMENSION H(128, 3)
      character*80 string, Species(8)*2
      integer X11, Y11, R
c
      ifQ =0
      if (CC.le.0) ifQ = 1
      CC = iCol(IJ)
      CR = CC + 8
      iCC = 8
c     if (iPlotType .EQ. 6) goto 500
      IfF = -1
      iFC = 0
      Call Cerchio( X11, Y11, R, iCC, IfF, iCC)
      iCC=0
      Call Cerchio( X11, Y11, R + 2, iCC, IfF, iCC)
      if (ifQ .eq. 1 .and. (IPlotType .eq.4.or.IPlotType.eq.6)) goto 5
      iPP = nint(0.2 * R)
      if (iPP .LT. 1) iPP = 1
      if (iPlotType .EQ. 6) goto 500
      IfF = 0
      IF (iPlotType .NE. 4) CC = CR
      Call Cerchio( X11, Y11, R, CC, IfF, iFC)
      if (ifQ .eq. 1) goto 5
      IF (iPlotType .GE. 4) THEN
         IF (iPlotType .NE. 5) then
            IDum = CC
            Call Paint(X11, Y11, IDum, IDum,R)
         endif
         if (iHCopy.ne.0) then
             iCC = 0
         else
             iCC = 15
         end if
         iPieno = 1
         iX11=nint(X11+0.5*R)
         iY11=nint(Y11-0.5*R)
         Call Cerchio( iX11, iY11, iPP, iCC, iPieno, iCC)
      END IF
5     IF (iPlotType .EQ. 3) THEN
         if (ragmed.lt.10) then          !14
            fx = .75
            fy = 1
         else if (ragmed.lt.15) then     !23
            fx = 1.
            fy = 1.5
         else if (ragmed.lt.22) then
            fx = 1.5
            fy = 2.0
         else if (ragmed.lt.30) then
            fx = 2.0
            fy = 2.8
         else
            fx = 3.0
            fy = 4.0
         endif
         iiY = Y11 + 2 * fy
         L = Lung(Lab(IJ))
         IF (L .GT. 0) THEN
            iiX = X11 - fx * 6.0 * L / 2.0
            IColor = 7
            CALL LabelM(Lab(IJ), iiX, iiY, fx , fy , IColor)
         END IF
      END IF
c
      return
c
  500 DTOR= PI / 180.
      N2 = 40
      AngSt = -225. * DTOR
      AngEn = 135. * DTOR
      DeAng= 360. * DTOR / N2
      Ang = AngSt - DeAng
      do 10 i=1, N2
         Ang = Ang + DeAng
         if (iHCopy.eq.0) then
            ixv(i) = nint( X11 + R * COS(Ang) )
         else
            ixv(i) = nint( X11 + 2.* R * COS(Ang) )
         end if
         iyv(i) = nint( Y11 - R * SIN(Ang) )
   10 continue
*     ixv(N2 + 1) = ixv(1)
*     iyv(N2 + 1) = iyv(1)
*     nz = N2 + 1
*     ind = 13
*     iot = 8
*     call graphs(ixv, iyv, nz, ind,string, iot)
      nz = N2
      ind = 14
      iot = CR
      call graphs(ixv, iyv, nz, ind,string, iot)
 
      DO 50 K = 1 , 3
         DO 40 L = 1 , 3
            IF (L.NE.K) THEN
               EL(K, L) = 0
            ELSE
               EL(K, L) = 1. / FLOAT(R * R)
            END IF
   40    CONTINUE
         C(K) = EL(K, 3)
   50 CONTINUE
      RJ(1) = 1
      RJ(2) = -1
      RJ(3) = .7
      CE = 1
      RANA1 = X11
      RANA2 = Y11
C
C  richiamo sub EllPrinc
C
      iColor=0
      N1 = 9
      CALL EllPrinc(RJ, C, EL, N1, H)
      N2M = N2 / 2
      do 60 i=1, N1
         if (iHCopy.eq.0) then
            ixv(N2M + i) = H(i, 1) + X11
         else
            ixv(N2M + i) = 2. * H(i, 1) + X11
         end if
         iyv(N2M + i) = H(i, 2) + Y11
   60 continue
      nz = N2M + N1 - 1
      ixv(nz)=ixv(1)
      iyv(nz)=iyv(1)
      ind = 13
      iot = CC
      call graphs(ixv, iyv, nz, ind,string, iot)
c-- fill !!!
      ind = 14
      call graphs(ixv, iyv, nz, ind,string, iot)
c
         if (iHCopy.eq.0) then
            iCC = 15
         else
            iCC = 0
         end if
         iPieno = 1
         iX11=nint(X11+0.5*R)
         iY11=nint(Y11-0.5*R)
         Call Cerchio( iX11, iY11, iPP, iCC, iPieno, iCC)
c
      RETURN
      END
C -----------------------------------------------------------------
      SUBROUTINE DisLegN (x1, y1, x2, y2, Rap)
      IMPLICIT REAL*4 (M)
      CHARACTER *1 Lett
      CHARACTER *5 Lab
      character *1 string
      COMMON /atomi/ xyz(3,800),NAT, RR(800), iCol(800), iOrd(800),nv,
     *               MLU(800), Lab(800), RS(800), ipix(3,800),iEqui(800)
      COMMON /Crt/ iBarre(62, 4),Lett(72),NumBar(70), iCheBarre(70, 6)
     2     , Rmin1, Rmin2, RMAX1, RMAX2, XMax, YMax, DDX, DDY, NPX, NPY
     3     , Lim1,Lim2,Lim3,Lim4,PI,Xmin,Ymin,LegCol,nlp, nMaxLeg
     5     , NumLeg, iPlotType , RK(4), VV(10,3), LE(800,2), RI(3)
      common /scale/ x11scale(2),x11disp(2),ragmed,deltax,deltay
      common /screen/ kscreen,jy,ivd,kscrx,kscry,jscreen,kprog,ifMouse
      common /buffer/ ixv(100),iyv(100),dummr(315)
      dimension xy(8)
 
      DOUBLE PRECISION m8, m9
 
      Rap = .2 + .8 * Rap
      DLeg = .08
      IF (ABS(x1 - x2) .LT. .00001) THEN
         x11 = x1 - DLeg
         y11 = y1
         x12 = x1 + DLeg
         y12 = y1
         x21 = x2 - DLeg
         y21 = y2
         x22 = x2 + DLeg
         y22 = y2
         GOTO 100
      ELSE
         m8 = (y2 - y1) / (x2 - x1)
      END IF
      IF (ABS(m8) .GT. .00001) THEN
         m9 = -1. / m8
      ELSE
         x11 = x1
         y11 = y1 - DLeg * Rap
         x12 = x1
         y12 = y1 + DLeg * Rap
         x21 = x2
         y21 = y2 - DLeg * Rap
         x22 = x2
         y22 = y2 + DLeg * Rap
         GOTO 100
      END IF
      DFK1 = (DLeg  * m8) / SQRT(m8 * m8 + 1.)
      x11 = x1 + DFK1
      y11 = m9 * x11 + x1 / m8 + y1
      x12 = x1 - DFK1
      y12 = m9 * x12 + x1 / m8 + y1
      DFK2 = (DLeg * Rap * m8) / SQRT(m8 * m8 + 1)
      x21 = x2 + DFK2
      y21 = m9 * x21 + x2 / m8 + y2
      x22 = x2 - DFK2
      y22 = m9 * x22 + x2 / m8 + y2
 
  100 BondLu = SQRT((x1 - x2) ** 2 + (y1 - y2) ** 2)
Ccc   IF (BondLu .GT. 5 * DDX) THEN
         xy(1) = x11
         xy(2) = y11
         xy(3) = x12
         xy(4) = y12
         xy(5) = x22
         xy(6) = y22
         xy(7) = x21
         xy(8) = y21
         do 200 i=1,4
         a = ( xy(i*2-1) + x11disp(1) ) * x11scale(1)
         b = ( xy(i*2  ) + x11disp(2) ) * x11scale(2)
         ixv(i)=nint(a)
         iyv(i)=(kscry - deltay) - nint(b)
  200    continue
         iz=4
         ind = 14
         icolor = 0
         call graphs(ixv,iyv,iz,ind,string,icolor)
         ixv(5)=ixv(1)
         iyv(5)=iyv(1)
         iz=5
         ind = 13
         call graphs(ixv,iyv,iz,ind,string,LegCol)
Ccc   END IF
c
      RETURN
      END
C -----------------------------------------------------------------
      SUBROUTINE EllPrinc(RJ, C, EL, N1, H)
      IMPLICIT REAL*4 (M)
      CHARACTER *1 Lett
      CHARACTER *5 Lab
      COMMON /atomi/ xyz(3,800),NAT, RR(800), iCol(800), iOrd(800),nv,
     *               MLU(800), Lab(800), RS(800), ipix(3,800),iEqui(800)
      COMMON /Crt/ iBarre(62, 4),Lett(72),NumBar(70), iCheBarre(70, 6)
     2     , Rmin1, Rmin2, RMAX1, RMAX2, XMax, YMax, DDX, DDY, NPX, NPY
     3     , Lim1,Lim2,Lim3,Lim4,PI,Xmin,Ymin,LegCol,nlp, nMaxLeg
     5     , NumLeg, iPlotType , RK(4), VV(10,3), LE(800,2), RI(3)
      DIMENSION S(3), G(3), E(3), H(128, 3), RJ(3), EL(3,3), C(3)
c
      S(1) = C(2) * RJ(3) - C(3) * RJ(2)
      S(2) = C(3) * RJ(1) - C(1) * RJ(3)
      S(3) = C(1) * RJ(2) - C(2) * RJ(1)
      CALL NormVett(S, EL, Q)
      DO 10 i = 1 , 3
         G(i) = Q * RI(i)
   10 CONTINUE
      DO 30 i = 1 , 3
         EI = 0
         DO 20 j = 1 , 3
            EI = EI + EL(i, j) * G(j)
   20    CONTINUE
         E(i) = EI
   30 CONTINUE
      S(1) = RJ(2) * E(3) - RJ(3) * E(2)
      S(2) = RJ(3) * E(1) - RJ(1) * E(3)
      S(3) = RJ(1) * E(2) - RJ(2) * E(1)
      CALL NormVett(S, EL, Q)
      DO 40 i = 1 , 3
         E(i) = Q * RI(i)
   40 CONTINUE
      IF (E(3) .LE. 0) THEN
                         E(1) = -E(1)
                         E(2) = -E(2)
                         E(3) = -E(3)
                       END IF
      N1 = 9
      N2 = 2
      N = 4
      nP1 = N + 1
      N2P1 = N * 2 + 1
      DO 50 j = 1 , 3
         H(1, j) = 1. * G(j)
         H(nP1, j) = E(j)
         H(N2P1, j) = -1. * G(j)
   50 CONTINUE
      DO 90 M = 1 , N2
         N1N = N1 - N
         DO 80 JU = 1 , N1N , N
            K = JU + N
            DO 60 L = 1 , 3
               S(L) = H(JU, L) + H(K, L)
   60       CONTINUE
            CALL NormVett(S, EL, Q)
            DO 70 i = 1 , 3
               E(i) = Q * RI(i)
   70       CONTINUE
            JJ = JU + N / 2
            H(JJ, 1) = E(1)
            H(JJ, 2) = E(2)
            H(JJ, 3) = E(3)
   80    CONTINUE
         N = N / 2
   90 CONTINUE
c     XX = H(1, 1) + RANA1
c     YY = H(1, 2) + RANA2
c     DO 100 j = 2 , N1
c        XXX = H(j, 1) + RANA1
c        YYY = H(j, 2) + RANA2
c        CALL Linea (XX, YY, XXX, YYY, 14)
c        XX = XXX
c        YY = YYY
c 100 CONTINUE
c
      RETURN
      END
C -----------------------------------------------------------------
      SUBROUTINE LabelM (Label, X, Y, Dx, Dy, iColor)
      IMPLICIT REAL*4 (M)
      integer Carattere
      CHARACTER *1 Lett
      CHARACTER *5 Label, Lab
      COMMON /atomi/ xyz(3,800),NAT, RR(800), iCol(800), iOrd(800),nv,
     *               MLU(800), Lab(800), RS(800), ipix(3,800),iEqui(800)
      COMMON /Crt/ iBarre(62, 4),Lett(72),NumBar(70), iCheBarre(70, 6)
     2     , Rmin1, Rmin2, RMAX1, RMAX2, XMax, YMax, DDX, DDY, NPX, NPY
     3     , Lim1,Lim2,Lim3,Lim4,PI,Xmin,Ymin,LegCol,nlp, nMaxLeg
     5     , NumLeg, iPlotType , RK(4), VV(10,3), LE(800,2), RI(3)
      integer X, Y, X1, Y1
c
      X1 = X
      Y1 = Y
      L = Lung (Label)
      DO 40 i = 1 , L
         IF (Label(i:i) .NE. ' ') THEN
            DO 10 K = 1 , 70
               IF (Label(i:i) .EQ. Lett(K)) THEN
                  Carattere = K
                  GOTO 20
               END IF
   10       CONTINUE
            Carattere = 1
   20       NBar = NumBar(Carattere)
            DO 30 K = 1 , NBar
               iBarra = iCheBarre(Carattere, K)
               iB1 = X1 + Dx * iBarre(iBarra, 1)
               iB2 = Y1 - Dy * iBarre(iBarra, 2)
               iB3 = X1 + Dx * iBarre(iBarra, 3)
               iB4 = Y1 - Dy * iBarre(iBarra, 4)
               CALL Linea (iB1, iB2, iB3, iB4, iColor)
   30       CONTINUE
            X1 = X1 + 7 * Dx
         END IF
   40 CONTINUE
c
      RETURN
      END
C -----------------------------------------------------------------
      SUBROUTINE Molt2(B, DU, W)
      DIMENSION B(3,3), DU(3,3), W(3,3)
c
      DO 30 i = 1 , 3
         DO 20 j = 1 , 3
            dum = 0
            DO 10 K = 1 , 3
               dum = dum + B(i, K) * DU(K, j)
   10       CONTINUE
            W(i, j) = dum
   20    CONTINUE
   30 CONTINUE
c
      RETURN
      END
C -----------------------------------------------------------------
      SUBROUTINE NormVett(S, EL, Q)
      IMPLICIT REAL*4 (M)
      CHARACTER *1 Lett
      CHARACTER *5 Lab
      COMMON /atomi/ xyz(3,800),NAT, RR(800), iCol(800), iOrd(800),nv,
     *               MLU(800), Lab(800), RS(800), ipix(3,800),iEqui(800)
      COMMON /Crt/ iBarre(62, 4),Lett(72),NumBar(70), iCheBarre(70, 6)
     2     , Rmin1, Rmin2, RMAX1, RMAX2, XMax, YMax, DDX, DDY, NPX, NPY
     3     , Lim1,Lim2,Lim3,Lim4,PI,Xmin,Ymin,LegCol,nlp, nMaxLeg
     5     , NumLeg, iPlotType , RK(4), VV(10,3), LE(800,2), RI(3)
      DIMENSION S(3), EL(3, 3)
c
      RL = SQRT(S(1) * S(1) + S(2) * S(2) + S(3) * S(3))
      IF (RL .lt. 0.0001) RL = .0001
      DO 10 K = 1 , 3
         RI(K) = S(K) / RL
   10 CONTINUE
      d = 0
      DO 30 j = 1 , 3
         DD = 0
         DO 20 K = 1 , 3
            DD = DD + RI(K) * EL(K, j)
   20    CONTINUE
         d = d + DD * RI(j)
   30 CONTINUE
      IF (d .lt. 0.0001)  d = .0001
      Q = SQRT(1 / ABS(d))
c
      RETURN
      END
C -----------------------------------------------------------------
      SUBROUTINE RotAtoms(B, iAction)
      IMPLICIT REAL*4 (M)
      integer O1,O2
      CHARACTER *1 Lett
      CHARACTER *5 Lab
      CHARACTER *80 Titolo
      COMMON /atomi/ xyz(3,800),NAT, RR(800), iCol(800), iOrd(800),nv,
     *               MLU(800), Lab(800), RS(800), ipix(3,800),iEqui(800)
      COMMON /Contr/ NF,iFirstTime,Titolo,Ratio,IfCont,IfEdge,IfScale,
     *               kplty,radii(8), IfScaleB
      COMMON /Crt/ iBarre(62, 4),Lett(72),NumBar(70), iCheBarre(70, 6)
     2     , Rmin1, Rmin2, RMAX1, RMAX2, XMax, YMax, DDX, DDY, NPX, NPY
     3     , Lim1,Lim2,Lim3,Lim4,PI,Xmin,Ymin,LegCol,nlp, nMaxLeg
     5     , NumLeg, iPlotType , RK(4), VV(10,3), LE(800,2), RI(3)
      DIMENSION M(3), P(3), B(3, 3)
c
      DO 30 JAT = 1 , NAT + nv
         if (RS(JAT) .LT. -10.0) go to 30
         M(1) = xyz(1,JAT)
         M(2) = xyz(2,JAT)
         M(3) = xyz(3,JAT)
         DO 20 i = 1 , 3
            P(i) = 0
            DO 10 j = 1 , 3
               P(i) = P(i) + B(i, j) * M(j)
   10       CONTINUE
   20    CONTINUE
         IF (iAction.eq.1) then
            xyz(1,JAT) = P(1)
            xyz(2,JAT) = P(2)
            xyz(3,JAT) = P(3)
         END IF
         if (RS(JAT) .LT. 0.0) go to 30
         if (JAT.le.NAT .OR. IfEdge.gt.0) then
            IF (P(1)-RS(JAT) .LT. Rmin1)  Rmin1 = P(1)-RS(JAT)
            IF (P(1)+RS(JAT) .GT. RMAX1)  RMAX1 = P(1)+RS(JAT)
            IF (P(2)-RS(JAT) .LT. Rmin2)  Rmin2 = P(2)-RS(JAT)
            IF (P(2)+RS(JAT) .GT. RMAX2)  RMAX2 = P(2)+RS(JAT)
         end if
   30 CONTINUE
 
      IF (iAction .eq. 1) THEN
         DO 50 i = 1 , (NAT + nv) - 1
            if (RS(i) .LT. 0.0) go to 50
            DO 40 K = i + 1 , NAT + nv
               if (RS(K) .LT. 0.0) go to 40
               O1 = iOrd(i)
               O2 = iOrd(K)
               O3 = xyz(3,O1)
               O4 = xyz(3,O2)
               IF (O3.GT.O4) THEN
                  iOrd(i) = O2
                  iOrd(K) = O1
               END IF
   40       CONTINUE
   50    CONTINUE
      END IF
c
      RETURN
      END
C -----------------------------------------------------------------
      SUBROUTINE SetScale(Azione)
      IMPLICIT REAL*4 (M)
      CHARACTER *1 Lett
      CHARACTER *5 Lab
      CHARACTER *80 Titolo
      INTEGER *4 Azione
      COMMON /atomi/ xyz(3,800),NAT, RR(800), iCol(800), iOrd(800),nv,
     *               MLU(800), Lab(800), RS(800), ipix(3,800),iEqui(800)
      COMMON /Crt/ iBarre(62, 4),Lett(72),NumBar(70), iCheBarre(70, 6)
     2     , Rmin1, Rmin2, RMAX1, RMAX2, XMax, YMax, DDX, DDY, NPX, NPY
     3     , Lim1,Lim2,Lim3,Lim4,PI,Xmin,Ymin,LegCol,nlp, nMaxLeg
     5     , NumLeg, iPlotType , RK(4), VV(10,3), LE(800,2), RI(3)
      COMMON /Contr/ NF,iFirstTime,Titolo,Ratio,IfCont,IfEdge,IfScale,
     *               kplty,radii(8), IfScaleB
c
      IF (Azione .EQ. 2)  GOTO 2630
      IF (Azione .EQ. 3)  GOTO 2690
      D1 = (RMAX1 - Rmin1) / 10
      Rmin1 = Rmin1 - D1
      RMAX1 = RMAX1 + D1
      D2 = (RMAX2 - Rmin2) / 10
      Rmin2 = Rmin2 - D2
      RMAX2 = RMAX2 + D2
2630  Dx = RMAX1 - Rmin1
      Dy = RMAX2 - Rmin2
c
***** if (Dy .lt. 0.5) Dy = 0.5
c
      IF (Dx.LE.Dy * Ratio) THEN
                             DX1 = Dy * Ratio
                             DEL = (DX1 - Dx) / 2
                             Rmin1 = Rmin1 - DEL
                             RMAX1 = RMAX1 + DEL
                             Dx = DX1
                           ELSE
                             DY1 = Dx / Ratio
                             DEL = (DY1 - Dy) / 2
                             Rmin2 = Rmin2 - DEL
                             RMAX2 = RMAX2 + DEL
                             Dy = DY1
                           END IF
      IF (Azione .EQ. 4) RETURN
      Xmin = Rmin1
      Ymin = Rmin2
      YMax = Rmin2 + Dy
      XMax = Rmin1 + Dx
      RMAX1 = XMax
      RMAX2 = YMax
2690  CALL WINDOW (Xmin, Ymin, XMax, YMax)
      DDX = (XMax - Xmin) / (Lim3 - Lim1)
      DDY = (YMax - Ymin) / (Lim4 - Lim2)
c
      RETURN
      END
C -----------------------------------------------------------------
      SUBROUTINE Window(Amin1, Amin2, AMax1, AMax2)
      common /screen/ kscreen,iy,ivd,kscrx,kscry,jscreen,kprog,ifMouse
      common /scale/ x11scale(2),x11disp(2),ragmed,deltax,deltay
 
      if (ABS(Amin1 - AMax1) .lt. 1.) then
         Amin1 = Amin1 - 0.5
         AMax1 = AMax1 + 0.5
      end if
      if (ABS(Amin2 - AMax2) .lt. 1.) then
         Amin2 = Amin2 - 0.5
         AMax2 = AMax2 + 0.5
      end if
      XXmin = Amin1
      XXMax = AMax1
      YYmin = Amin2
      YYMax = AMax2
      dx=XXMax-XXMin
      dy=YYMax-YYMin
      x11scale(1)=(float(kscrx)-deltax)/dx
      x11scale(2)=(float(kscry)-deltay)/dy
      x11disp(1)=-XXMin + deltax / x11scale(1)
      x11disp(2)=-YYMin - deltay / x11scale(2)
c
      RETURN
      END
C -----------------------------------------------------------------
      SUBROUTINE AngToPix
      CHARACTER *5 Lab
      COMMON /atomi/ xyz(3,800),NAT, RR(800), iCol(800), iOrd(800),nv,
     *               MLU(800), Lab(800), RS(800), ipix(3,800),iEqui(800)
      common /scale/ x11scale(2),x11disp(2),ragmed,deltax,deltay
      common /screen/ kscreen,iy,ivd,kscrx,kscry,jscreen,kprog,ifMouse
c
      RagMed = 0.0
      NatVis = 0
      do 20 j = 1, NAT + nv
      a = ( xyz(1,j) + x11disp(1) ) * x11scale(1)
      b = ( xyz(2,j) + x11disp(2) ) * x11scale(2)
      c =                     RS(j) * x11scale(2)
      if (j.le.NAT .and. c.gt.0.0) then
          NatVis = NatVis + 1
          RagMed = RagMed + c
      end if
      ipix(1,j)=nint(a)
      ipix(2,j)=(kscry-deltay) - nint(b)
      ipix(3,j)=nint(c)
   20 continue
      if (NatVis.gt.0) RagMed = RagMed / float(NatVis)
c
      RETURN
      END
C -----------------------------------------------------------------
      SUBROUTINE SticksOrd
c
      IMPLICIT REAL*4 (M)
      INTEGER O1,O2
      INTEGER *4 CC, CC1, XX1, YY1, XX2, YY2, DDX, DDY, DDDX, DDDY
      INTEGER *4  XX3, YY3, XD1, XD2
      CHARACTER *1 Lett
      CHARACTER *5 Lab
      CHARACTER *80 Titolo
c
      COMMON /atomi/ xyz(3,800),NAT, RR(800), iCol(800), iOrd(800),nv,
     *               MLU(800), Lab(800), RS(800), ipix(3,800),iEqui(800)
      COMMON /Crt/ iBarre(62, 4),Lett(72),NumBar(70), iCheBarre(70, 6)
     2     , Rmin1, Rmin2, RMAX1, RMAX2, XMax, YMax, DDX, DDY, NPX, NPY
     3     , Lim1,Lim2,Lim3,Lim4,PI,Xmin,Ymin,LegCol,nlp, nMaxLeg
     5     , NumLeg, iPlotType , RK(4), VV(10,3), LE(800,2), RI(3)
      COMMON /Contr/ NF,iFirstTime,Titolo,Ratio,IfCont,IfEdge,IfScale,
     *               kplty,radii(8), IfScaleB
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
c
      DO 20 i = 1 , (NAT + nv) - 1
         DO 10 K = i + 1 , NAT + nv
            O1 = iOrd(i)
            O2 = iOrd(K)
            O3 = xyz(3,O1)
            O4 = xyz(3,O2)
            IF (O3.GT.O4) THEN
               iOrd(i) = O2
               iOrd(K) = O1
            END IF
   10    CONTINUE
   20 CONTINUE
      DDY = 1
      DDX = 1
c
      CALL NewPage
c
      DO 40 JJ = 1 , NAT + nv
         IJ = iOrd(JJ)
         if (RS(IJ).LE.0) go to 40
         if (IfEdge.eq.0 .AND. IJ.gt.NAT) GOTO 40
         ZETA = xyz(3,IJ)
         Legato = 0
         DO 30 NLL = 1 , NumLeg
            N1 = LE(NLL, 1)
            N2 = LE(NLL, 2)
            IF (N1.NE.IJ.AND.N2.NE.IJ) GOTO 30
            IF (N1 .EQ. IJ .AND. xyz(3,N2) .GT. ZETA)  GOTO 30
            IF (N2 .EQ. IJ .AND. xyz(3,N1) .GT. ZETA)  GOTO 30
            IF (RS(N1) .LE. 0 .OR. RS(N2) .LE. 0)  GOTO 30
            Legato = -1
            XX1 = ipix(1,N1)
            XX2 = ipix(1,N2)
            YY1 = ipix(2,N1)
            YY2 = ipix(2,N2)
            ZZ1 = xyz(3,N1)
            ZZ2 = xyz(3,N2)
c           write(lo,'(6f10.4,6i5)') xyz(1,n1),xyz(2,n1),xyz(3,n1),
c    * xyz(1,n2),xyz(2,n2),xyz(3,n2),ipix(1,n1),ipix(2,n1),ipix(3,n1),
c    * ipix(1,n2),ipix(2,n2),ipix(3,n2)
            IF (XX1.LT.XX2) THEN
               DDDX = DDX
            ELSE
               DDDX = -DDX
            END IF
            IF (YY1.LT.YY2) THEN
               DDDY = DDY
            ELSE
               DDDY = -DDY
            END IF
            XD1= XX1 + DDDX
            XD2= XX2 - DDDX
            Ize = 0
            CALL Linea (XD1, YY1-DDDY, XD2, YY2 - DDDY, Ize)
            CALL Linea (XD1, YY1+DDDY, XD2, YY2 + DDDY, Ize)
            CALL Linea (XD1, YY1-2 * DDDY, XD2, YY2 - 2 * DDDY,Ize)
            CALL Linea (XD1, YY1+2 * DDDY, XD2, YY2 + 2 * DDDY,Ize)
            XX3 = (XX1 + XX2) / 2
            YY3 = (YY1 + YY2) / 2
            CC1 = iCol(N1) + 8
            CC  = iCol(N2) + 8
            CALL Linea (XX1, YY1, XX3, YY3, CC1)
            CALL Linea (XX3, YY3, XX2, YY2, CC)
            IF (iPlotType .EQ. 2 .AND. N1 .LE. NAT) THEN
               iCC = 8
               IfF = -1
               Call Cerchio(XX1, YY1, 3 * DDX, iCC, IfF, iCC)
               iCC = 0
               IfF = 0
               iFC = 0
               Call Cerchio( XX1, YY1, 4 * DDX, iCC, IfF, iFC)
               Call Paint(XX1, YY1, CC1-8, iFC,4*DDx)
               IDum = 15
               CALL MettiPixel(XX1 + DDX, YY1 - 2 * DDY, IDum)
               if (Lab(N1)(1:1).eq.'Q') then
                  IfF = -1
                  iFC = 0
                  Call Cerchio( XX2, YY2, 2 * DDX, iCC, IfF, iFC)
               end if
               if (N2 .LE. NAT) THEN
               iCC = 8
               IfF = -1
               Call Cerchio( XX2, YY2, 3 * DDX, iCC, IfF, iCC)
               iCC = 0
               IfF = 0
               iFC = 0
               Call Cerchio( XX2, YY2, 4 * DDX, iCC, IfF, iFC)
               Call Paint(XX2, YY2, CC-8, iFC,4*DDx)
               IDum = 15
               CALL MettiPixel(XX2 + DDX, YY2 - 2 * DDY, IDum)
               if (Lab(N2)(1:1).eq.'Q') then
                  IfF = -1
                  iFC = 0
                  Call Cerchio( XX2, YY2, 2 * DDX, iCC, IfF, iFC)
               end if
               END IF
            END IF
   30    CONTINUE
         if (Legato .eq. 0) then
             ix = ipix(1,IJ)
             iy = ipix(2,IJ)
             IDum = iCol(IJ) + 8
             if (iPlotType .eq. 1) then
                CALL MettiPixel(ix , iy , IDum)
             else
                if (IJ.LE.NAT) THEN
                iCC = 8
                IfF = -1
                Call Cerchio(ix, iy, 3 , iCC, IfF, iCC)
                iCC = 0
                IfF = 0
                iFC = 0
                Call Cerchio( ix, iy, 4 , iCC, IfF, iFC)
                Call Paint(ix, iy, IDum-8, iFC, 4)
                IDum = 15
                CALL MettiPixel(ix + 1, iy - 2, IDum)
                if (Lab(IJ)(1:1).eq.'Q') then
                  IfF = -1
                  iFC = 0
                  Call Cerchio( ix, iy, 2, iCC, IfF, iFC)
                end if
                END IF
             end if
         end if
   40 CONTINUE
c
      RETURN
      END
C -----------------------------------------------------------------
      FUNCTION Lung (Stringa)
 
      CHARACTER  Stringa *(*)
 
      K = len (Stringa)
      DO 10 I = K, 1, -1
          IF (Stringa(I:I) .NE. ' ') then
                                       Lung = I
                                       RETURN
                                     END IF
   10 CONTINUE
      Lung = 0
c
      RETURN
      END
C -----------------------------------------------------------------
      SUBROUTINE NewPage
      character*80 string
      common /buffer/ ixv(100),iyv(100),dummr(315)
c* *ind == 6 : clear screen
      ind=6
      icolor=1
      call graphs( ixv,iyv,iz,ind,string,icolor)
c
      RETURN
      END
C -----------------------------------------------------------------
      SUBROUTINE Linea (ix, iy, ix2, iy2, iColor)
      character*80 string
      common /buffer/ ixv(100),iyv(100),dummr(315)
c
      call SetColr (iColor)
      ixv(1)=ix
      ixv(2)=ix2
      iyv(1)=iy
      iyv(2)=iy2
      ind=2
      call graphs( ixv, iyv, iz, ind, string, iColor)
c
      RETURN
      END
C -----------------------------------------------------------------
      SUBROUTINE Linea0(x, y, x2, y2, iColor)
c
      common /scale/ x11scale(2),x11disp(2),ragmed,deltax,deltay
      common /screen/ kscreen,iy,ivd,kscrx,kscry,jscreen,kprog,ifMouse
c
      ix  = nint( (  x + x11disp(1) ) * x11scale(1) )
      iy  = nint( (  y + x11disp(2) ) * x11scale(2) )
      ix2 = nint( ( x2 + x11disp(1) ) * x11scale(1) )
      iy2 = nint( ( y2 + x11disp(2) ) * x11scale(2) )
      iy  = (kscry - deltay) - iy
      iy2 = (kscry - deltay) - iy2
      call Linea (ix, iy, ix2, iy2, iColor)
c
      RETURN
      END
C -----------------------------------------------------------------
      SUBROUTINE Paint (ix1, iy1, iColore, iColoreBordo, Raggio)
      CHARACTER *1 Lett
      COMMON /Crt/ iBarre(62, 4),Lett(72),NumBar(70), iCheBarre(70, 6)
     2     , Rmin1, Rmin2, RMAX1, RMAX2, XMax, YMax, DDX, DDY, NPX, NPY
     3     , Lim1,Lim2,Lim3,Lim4,PI,Xmin,Ymin,LegCol,nlp, nMaxLeg
     5     , NumLeg, iPlotType , RK(4), VV(10,3), LE(800,2), RI(3)
      common /screen/ kscreen,iy,ivd,kscrx,kscry,jscreen,kprog,ifMouse
      common /buffer/ ixv(100),iyv(100),dummr(315)
      character*80 string
      integer Raggio
c
      call SetColr (iColore)
c
      ixv(1) = ix1 - Raggio
      iyv(1) = iy1 - Raggio
      iz = 2 * Raggio
      ind=11
      call graphs( ixv,iyv,iz,ind,string,iColoreBordo)
c
      RETURN
      END
C -----------------------------------------------------------------
      SUBROUTINE MettiPixel (ix, iy, IColor)
      character*80 string
      common /buffer/ ixv(100),iyv(100),dummr(315)
c
      call SetColr (iColor)
      ixv(1)=ix
      ixv(2)=ix
      iyv(1)=iy
      iyv(2)=iy
      ind=2
      call graphs( ixv,iyv,iz,ind,string,iColor)
c
      RETURN
      END
C -----------------------------------------------------------------
      SUBROUTINE Cerchio (ix1, iy1, Radius, iColor, IfFill, iFillColor)
      common /screen/ kscreen,iy,ivd,kscrx,kscry,jscreen,kprog,ifMouse
      common /buffer/ ixv(100),iyv(100),dummr(315)
      character*80 string
      integer Radius
C
C     X , Y  :  Center Coordinates
C     Radius :  Circle Radius
C     iColor  :  Line Color
C     IfFill = 0 don't fill    = -1  Fill
C     iFillColor : Filling Color
C
      ixv(1) = ix1 - Radius
      iyv(1) = iy1 - Radius
      iz = 2 * Radius
      IF (IfFill .NE. 0) THEN
         call SetColr (iFillColor)
         ind=11
         call graphs( ixv,iyv,iz,ind,string,iFillcolor)
      ELSE
         call SetColr (iColor)
         ind=10
         call graphs( ixv,iyv,iz,ind,string,iColor)
      END IF
c
      RETURN
      END
C ------------------------------------------------------------------
      SUBROUTINE SetColr(iColor)
      character*80 string
      common /buffer/ ixv(100),iyv(100),dummr(315)
c
      ind = 12
      ix=0
      iy=0
      call graphs( ixv,iyv,iz,ind,string,iColor)
c
      return
      end
C -----------------------------------------------------------------
      SUBROUTINE Genera(B)
 
      common /atoms/ x(5,200),nz(200),ngp,ninf(10),nag(10)
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      COMMON /GeneraC/ DePA, DeMA, DePB, DeMB, DePC, DeMC,
     *                 R(3, 3, 48), T(3, 48),
     *                 Shf(3, 3), Tra(3, 20), nsym, NatInd, nt1
      COMMON /atomi/ xyz(3,800),NAT, RR(800), iCol(800), iOrd(800),nv,
     *               MLU(800), Lab(800), RS(800), ipix(3,800),iEqui(800)
      COMMON /Contr/ NF,iFirstTime,Titolo,Ratio,IfCont,IfEdge,IfScale,
     *               kplty,radii(8), IfScaleB
      common/work/rm(3,3), eval(3), evec(3,3), ainer(3,3)
      common/rc/p(6),cx(9),dumm(9)
      common /screen/ kscreen,iy,ivd,kscrx,kscry,jscreen,kprog,ifMouse
 
      CHARACTER  Lab*5, nt1*1, titolo *80
      REAL MLU
      DIMENSION B(3, 3)
      DIMENSION cb(3), x1(3), r1(3)
      common/spec/ soper(3,4,24),centrt(7,12),aaa(6),noper,ncentr,icent,
     *         kpol,jsys,lat,indv(32),mpv(64),jspini,ddmin,ncawu,ncwu
      character*7 reticoli
c
      nMaxAtm = 800
c
c                P E Z Z A  ! ! !
c
      if (mod(kprog,10) .lt. 3) then
      reticoli='pabcifr'
      nt1=reticoli(lat:lat)
      nsym = noper
      do k=1,nsym
         do i=1,3
            do j=1,3
               R(i,j,k)=soper(i,j,k)
               if (icent.eq.1) R(i,j,k+nsym)=-R(i,j,k)
            enddo
            T(i,k)=soper(i,4,k)
            if (icent.eq.1) T(i,k+nsym)=T(i,k)
         enddo
      enddo
      if (icent.eq.1) nsym=nsym*2
      end if
c
c
 
      Tra(1, 1) = 1
      Tra(2, 1) = 0
      Tra(3, 1) = 0
      Tra(1, 2) = 0
      Tra(2, 2) = 1
      Tra(3, 2) = 0
      Tra(1, 3) = 0
      Tra(2, 3) = 0
      Tra(3, 3) = 1
 
      DeA = 3.0/cx(1)
      DeB = 3.0/cx(2)
      DeC = 3.0/cx(3)
      if ( DeA .gt. cx(1)*0.5 ) DeA = cx(1) * 0.5
      if ( DeB .gt. cx(2)*0.5 ) DeB = cx(2) * 0.5
      if ( DeC .gt. cx(3)*0.5 ) DeC = cx(3) * 0.5
 
      DePA = 1.0 + DeA
      DeMA =     - DeA
      DePB = 1.0 + DeB
      DeMB =     - DeB
      DePC = 1.0 + DeC
      DeMC =     - DeC
 
      iCentrato = 0
      nce = 0
      nit = 3
      do 50 i = 1, NAT
         xyz(1, i) = x(1,i)
         xyz(2, i) = x(2,i)
         xyz(3, i) = x(3,i)
         iEqui(i) = i
   50 continue
c
      IF (nt1 .NE. 'p') THEN
         CALL Centra(nce, Shf, nt1)
         iCentrato = -1
      END IF
 
      natot = NAT
      do 200 na = 1, NAT
         do 150 n = 1, nsym
            CALL Ruota(R, T, n, na, cb)
            idop = iDoppio(natot, cb)
            IF (idop .EQ. 0) THEN
               natot = natot + 1
               xyz(1, natot) = cb(1)
               xyz(2, natot) = cb(2)
               xyz(3, natot) = cb(3)
               iEqui(natot) = na
               if (natot.eq.nMaxAtm - nv) go to 480
            END IF
  150    continue
  200 continue
 
      NAT = natot
      IF (iCentrato .NE. 0) THEN
         do 250 na = 1, NAT
            do 220 n =1, nce
               CALL Trasl(Shf, n, na, cb, -1)
               idop = iDoppio(natot, cb)
               IF (idop .EQ. 0) THEN
                  natot = natot + 1
                  xyz(1, natot) = cb(1)
                  xyz(2, natot) = cb(2)
                  xyz(3, natot) = cb(3)
                  iEqui(natot) = iEqui(na)
                  if (natot.eq.nMaxAtm - nv) go to 480
               END IF
  220       continue
  250    continue
      END IF
 
      NAT = natot
      do 450 it = 1, nit
         do 400 ic = -1, 1, 2
            do 350 na = 1 , NAT
               do 300 i = 1, 3
                  Tra(i, it) = ic * ABS(Tra(i, it))
  300          continue
               CALL Trasl(Tra, it, na, cb, -1)
               idop = iDoppio(natot, cb)
               IF (idop .EQ. 0) THEN
                  natot = natot + 1
                  xyz(1, natot) = cb(1)
                  xyz(2, natot) = cb(2)
                  xyz(3, natot) = cb(3)
                  iEqui(natot) = iEqui(na)
                  if (natot.eq.nMaxAtm - nv) go to 480
               END IF
  350       continue
 
            NAT = natot
 
  400    continue
  450 continue
 
  480 NAT = natot
 
c     io=2
c     open(unit=2,status='unknown',file='Compl.mol')
c     write(io,'(a)') titolo
c     write(io,'(6f10.6)') a, b, c, alfa, beta, gamma
c     write(io,'(i5)') NAT
 
      do 550 na = 1, NAT
         ieq = iEqui(na)
         Lab(na) = Lab(ieq)
         MLU(na) = MLU(ieq)
         RS(na) = RS(ieq)
         iCol(na) = iCol(ieq)
         Lab(na) = Lab(ieq)
c     write(io,'(a4,1h,,5f10.6,i4)')Lab(na),(xyz(i,na),i=1,3),
c    +                                MLU(na),RS(na),iCol(na)
         x1(1) = xyz(1, na)
         x1(2) = xyz(2, na)
         x1(3) = xyz(3, na)
         call molt1(rm,x1,r1)
         xyz(1, na) = r1(1)
         xyz(2, na) = r1(2)
         xyz(3, na) = r1(3)
  550 continue
      call AggiuSpig
c
      call LsPlane(NATV)
c
      call BuildBonds(2)
c
      Rmin1 = 99999.
      Rmin2 = 99999.
      RMAX1 = -99999.
      RMAX2 = -99999.
c
      CALL FindOr(B)
c
      RETURN
      END
c --------------------------------------------------------------------
      SUBROUTINE Centra (nce, Shf, nt1)
 
      CHARACTER *1 nt1
      DIMENSION Shf(3,3)
 
      IF (nt1 .EQ. 'f') THEN
         nce = 3
         Shf(1, 1) = 0.
         Shf(2, 1) = .5
         Shf(3, 1) = .5
         Shf(1, 2) = .5
         Shf(2, 2) = 0.
         Shf(3, 2) = .5
         Shf(1, 3) = .5
         Shf(2, 3) = .5
         Shf(3, 3) = 0.
      END IF
      IF (nt1 .EQ. 'r') THEN
         nce = 2
         Shf(1, 1) = .333
         Shf(2, 1) = .666
         Shf(3, 1) = .333
         Shf(1, 2) = .666
         Shf(2, 2) = .333
         Shf(3, 2) = .666
      END IF
      IF (nt1 .EQ. 'i') THEN
         nce = 1
         Shf(1, 1) = .5
         Shf(2, 1) = .5
         Shf(3, 1) = .5
      END IF
      IF (nt1 .EQ. 'a') THEN
         nce = 1
         Shf(1, 1) = 0.
         Shf(2, 1) = .5
         Shf(3, 1) = .5
      END IF
      IF (nt1 .EQ. 'b') THEN
         nce = 1
         Shf(1, 1) = .5
         Shf(2, 1) = 0.
         Shf(3, 1) = .5
      END IF
      IF (nt1 .EQ. 'c') THEN
         nce = 1
         Shf(1, 1) = .5
         Shf(2, 1) = .5
         Shf(3, 1) = 0.
      END IF
 
      RETURN
      END
c --------------------------------------------------------------------
      FUNCTION iDoppio (natot, c)
 
      COMMON /atomi/ xyz(3,800),NAT, RR(800), iCol(800), iOrd(800),nv,
     *               MLU(800), Lab(800), RS(800), ipix(3,800),iEqui(800)
      DIMENSION c(3)
      character *5 Lab
      real *4 MLU
 
      iDoppio = 0
      DO 20 nn = 1, natot
         DO 10 i = 1, 3
            IF (ABS(xyz(i, nn) - c(i)) .GT. .001) THEN
                GOTO 20
            END IF
   10    CONTINUE
         iDoppio = -1
         RETURN
   20 CONTINUE
 
      RETURN
      END
c --------------------------------------------------------------------
      SUBROUTINE RimettiDentro (c)
 
      character * 1 nt1
      COMMON /GeneraC/ DePA, DeMA, DePB, DeMB, DePC, DeMC,
     *                 R(3, 3, 48), T(3, 48),
     *                 Shf(3, 3), Tra(3, 20), nsym, NatInd, nt1
      DIMENSION c(3)
 
   10 if (c(1) .gt. DePA) then
         c(1) = c(1) - 1
         goto 10
      end if
   20 if (c(1) .lt. DeMA) then
         c(1) = c(1) + 1
         goto 20
      end if
   30 if (c(2) .gt. DePB) then
         c(2) = c(2) - 1
         goto 30
      end if
   40 if (c(2) .lt. DeMB) then
         c(2) = c(2) + 1
         goto 40
      end if
   50 if (c(3) .gt. DePC) then
         c(3) = c(3) - 1
         goto 50
      end if
   60 if (c(3) .lt. DeMC) then
         c(3) = c(3) + 1
         goto 60
      end if
 
      RETURN
      END
c --------------------------------------------------------------------
      SUBROUTINE Ruota (R, T, n, na, cb)
 
      COMMON /atomi/ xyz(3,800),NAT, RR(800), iCol(800), iOrd(800),nv,
     *               MLU(800), Lab(800), RS(800), ipix(3,800),iEqui(800)
      DIMENSION A(3, 3), B(3), R(3,3,48), T(3,48), cb(3)
      character *5 Lab
      real *4 MLU
 
      DO 20 j = 1, 3
         DO 10 k = 1, 3
            A(k, j) = R(k, j, n)
  10     CONTINUE
         B(j) = xyz(j, na)
  20  CONTINUE
      DO 40 i = 1, 3
         cb(i) = 0
         DO 30 j = 1, 3
            cb(i) = cb(i) + A(i, j) * B(j)
  30     CONTINUE
         cb(i) = cb(i) + T(i, n)
  40  CONTINUE
 
      CALL RimettiDentro(cb)
 
      RETURN
      END
c --------------------------------------------------------------------
      SUBROUTINE Trasl (T, n, na, cb, ird)
 
      COMMON /atomi/ xyz(3,800),NAT, RR(800), iCol(800), iOrd(800),nv,
     *               MLU(800), Lab(800), RS(800), ipix(3,800),iEqui(800)
      DIMENSION T(3,3), cb(3)
      character *5 Lab
      real *4 MLU
 
      DO 10 i = 1, 3
       cb(i) = xyz(i, na) + T(i, n)
   10 CONTINUE
      IF (ird .NE. 0) THEN
       CALL RimettiDentro(cb)
      END IF
      RETURN
      END
c --------------------------------------------------------------------
      SUBROUTINE SoloInd(B,NatInd)
 
      common /atoms/ x(5,200),nz(200),ngp,ninf(10),nag(10)
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      COMMON /atomi/ xyz(3,800),NAT, RR(800), iCol(800), iOrd(800),nv,
     *               MLU(800), Lab(800), RS(800), ipix(3,800),iEqui(800)
      COMMON /Contr/ NF,iFirstTime,Titolo,Ratio,IfCont,IfEdge,IfScale,
     *               kplty,radii(8), IfScaleB
      common/work/rm(3,3), eval(3), evec(3,3), ainer(3,3)
      COMMON /Crt/ iBarre(62, 4),Lett(72),NumBar(70), iCheBarre(70, 6)
     2     , Rmin1, Rmin2, RMAX1, RMAX2, XMax, YMax, DDX, DDY, NPX, NPY
     3     , Lim1,Lim2,Lim3,Lim4,PI,Xmin,Ymin,LegCol,nlp, nMaxLeg
     5     , NumLeg, iPlotType , RK(4), VV(10,3), LE(800,2), RI(3)
      COMMON /Leg1/ LE1(800,2),nLegInd
c
      CHARACTER *1 Lett
      CHARACTER *5 Lab, titolo *80
      REAL MLU
      DIMENSION  x1(3), r1(3), B(3, 3)
 
c
      do 2 i=NatInd+1, NAT
         if (RS(i) .gt. 0.0) then
            RS(iEqui(i)) = abs(RS(i))
         end if
    2 continue
      NAT = NatInd
      do 5 i = 1, NAT
         x1(1) = x(1, i)
         x1(2) = x(2, i)
         x1(3) = x(3, i)
         call molt1(rm,x1,r1)
         xyz(1, i) = r1(1)
         xyz(2, i) = r1(2)
         xyz(3, i) = r1(3)
         iEqui(i) = i
    5 continue
      call AggiuSpig
c
      call LsPlane(NATV)
c
      NumLeg = nLegInd
      call GetBonds(2)
c
      do 70 i = 1, NumLeg
         LE(i, 1) = LE1(i, 1)
         LE(i, 2) = LE1(i, 2)
   70 continue
c
      if (NATV.eq.0) then
          return
      end if
c
      Rmin1 = 99999.
      Rmin2 = 99999.
      RMAX1 = -99999.
      RMAX2 = -99999.
c
      CALL FindOr(B)
c
      return
      END
C -----------------------------------------------------------------
      SUBROUTINE DelAt
      IMPLICIT REAL*4 (M)
      CHARACTER *1 Lett
      CHARACTER *5 Lab
      COMMON /atomi/ xyz(3,800),NAT, RR(800), iCol(800), iOrd(800),nv,
     *               MLU(800), Lab(800), RS(800), ipix(3,800),iEqui(800)
      COMMON /Crt/ iBarre(62, 4),Lett(72),NumBar(70), iCheBarre(70, 6)
     2     , Rmin1, Rmin2, RMAX1, RMAX2, XMax, YMax, DDX, DDY, NPX, NPY
     3     , Lim1,Lim2,Lim3,Lim4,PI,Xmin,Ymin,LegCol,nlp, nMaxLeg
     5     , NumLeg, iPlotType , RK(4), VV(10,3), LE(800,2), RI(3)
      common /mess/ Message,ifMess,lMess
      common /atoms/ x(5,200),nz(200),ngp,ninf(10),nag(10)
      character blank,digit*12,card(100)*80,ffile*80
      common /chara/ blank,digit,card,ffile
      common /buffer/ ixv(100),iyv(100),dummr(315)
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      character *80 Message, Deltd*130
      integer X11,Y11
c
      do 5 i=1, 126
         Deltd(i:i) = ' '
    5 continue
c
      NumCanc = 0
      NumCTot = 0
      iscr=0
      do 60 n = 1, 99
         ix = ixv(n)
         if(ix.lt.0) goto 70
         iy = iyv(n)
         jfound = 0
         idmin = 9999
         DO 50 III = NAT + nv, 1 , -1
            IJ = iOrd(III)
            if (IJ.gt.NAT .OR. RS(IJ).lt.0 ) go to 50
            X11 = ipix(1,IJ)
            Y11 = ipix(2,IJ)
            dx= ix - X11
            dy= iy - Y11
            dist = sqrt( dx*dx + dy*dy )
            idist=nint(dist)
            if (idist.le.ipix(3,IJ) .and. RS(IJ).gt.0) then
               if (idist.le.idmin) then
                  idmin = idist
                  jfound= IJ
               endif
            endif
   50    continue
c  40    format(i4,1h) ,2x,a4,8i5)
         if (jfound.gt.0) then
            RS(jfound) = -(10. + RS(jfound))
            NumCanc = NumCanc + 1
            NumCTot = NumCTot + 1
            ipu = (NumCanc - 1) * 6 + 1
            if (ipu.eq.127) then
                if (iscr.eq.0) write(lo,120)
                write(lo,'(1h ,a)') Deltd
                do 51 i=1, 130
                   Deltd(i:i) = ' '
   51           continue
                iscr = 1
                NumCanc = 1
                ipu = 1
            end if
            Deltd(ipu:ipu+4) = Lab(jfound)
            do 55 i=1, NAT
               if (iEqui(i).eq.iEqui(jfound)) then
                   RS(i) =  RS(jfound)
               end if
   55       continue
         endif
   60 continue
   70 if (NumCTot.gt.0) then
         write(Message,100) NumCTot
         lMess = 30
      else
         write(Message,110)
         lMess = 18
      endif
      if (NumCanc.gt.0) then
         if (iscr.eq.0) write(lo,120)
         if (Deltd(1:1).ne.' ') write(lo,'(1h ,a)') Deltd
      end if
c
  100 format(i3,' Atom(s) has been deleted !')
  110 format(' No Atom deleted !')
  120 format(/,' The following Atom(s) has been deleted :')
      ifMess=1
c
      return
      end
C -----------------------------------------------------------------
      SUBROUTINE DelHide(iz)
      IMPLICIT REAL*4 (M)
      CHARACTER *1 Lett
      CHARACTER *5 Lab
      COMMON /atomi/ xyz(3,800),NAT, RR(800), iCol(800), iOrd(800),nv,
     *               MLU(800), Lab(800), RS(800), ipix(3,800),iEqui(800)
      COMMON /Crt/ iBarre(62, 4),Lett(72),NumBar(70), iCheBarre(70, 6)
     2     , Rmin1, Rmin2, RMAX1, RMAX2, XMax, YMax, DDX, DDY, NPX, NPY
     3     , Lim1,Lim2,Lim3,Lim4,PI,Xmin,Ymin,LegCol,nlp, nMaxLeg
     5     , NumLeg, iPlotType , RK(4), VV(10,3), LE(800,2), RI(3)
      common /mess/ Message,ifMess,lMess
      common /atoms/ x(5,200),nz(200),ngp,ninf(10),nag(10)
      character blank,digit*12,card(100)*80,ffile*80
      common /chara/ blank,digit,card,ffile
      common /buffer/ ixv(100),iyv(100),dummr(315)
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      character *80 Message, Deltd*132
c
      do 5 i=1, 132
         Deltd(i:i) = ' '
    5 continue
c
c   rendi visibili tutti gli atomi hidden (show all)
c
      if (iz.eq.123) then
         do 500 i=1, NAT 
            IJ = i
            if (RS(IJ) .gt. -10.) then
               RS(IJ) = abs(RS(IJ))
            end if
  500    continue
         return
      end if
c
      do 10 i = 1, 99
         if (ixv(i).lt.0) goto 20
   10 continue
   20 nvpol = i - 1
      n = 1
   21 n = n + 1
      if (ixv(n).eq.ixv(n - 1) .AND. iyv(n).eq.iyv(n - 1)) then
         do 22 i = n, nvpol - 1
            ixv(i) = ixv(i + 1)
            iyv(i) = iyv(i + 1)
   22    continue
         nvpol = nvpol - 1
         n = n - 1
      end if
      if (n.lt.nvpol) goto 21
   23 icont = 0
      do 26 i = 1, nvpol - 2
         do 24 j = i + 1, nvpol - 1
            IF (IABS(iyv(i) - iyv(j)) .le. 2) THEN
               iyv(j) = iyv(j) - 1
               icont = -1
            END IF
   24    continue
   26 continue
      if (icont .ne. 0) goto 23
      NumCanc = 0
      NumCancTot = 0
      NumHidd = 0
      iscr = 0
      DO 50 III = NAT + nv, 1 , -1
         IJ = iOrd(III)
         if (IJ .GT. NAT. OR. RS(IJ). LT. 0) go to 50
         ix = ipix(1,IJ)
         iy = ipix(2,IJ)
         in = Interno(ix, iy, nvpol)
         inn = Interno(ix, iy - 1, nvpol)
         if (iz .eq. 223) then
c --        voglio nascondere gli esterni
            if (in .ne. -2 .and. inn .ne. -2) then
c --           e' esterno
               RS(IJ) = -RS(IJ)
               NumHidd = NumHidd + 1
            end if
         else
c --        gli interni sono selezionati ...
            if (in.eq.-2 .or. inn.eq.-2) then
               if (iz.lt.0) then
c --              ... per cancellarli
                  RS(IJ) = -(10. + RS(IJ))
                  NumCanc = NumCanc + 1
                  NumCancTot = NumCancTot + 1
                  ipu = (NumCanc - 1) * 6 + 1
                  if (ipu.eq.133) then
                     if (iscr.eq.0) write(lo,120)
                      write(lo,'(a)') Deltd
                      do 51 i=1, 132
                         Deltd(i:i) = ' '
   51                 continue
                      iscr = 1
                      NumCanc = 1
                      ipu = 1
                  end if
                  Deltd(ipu:ipu+4) = Lab(IJ)
                  do 55 i=1, NAT
                     if (iEqui(i) .eq. iEqui(IJ)) then
                         RS(i) =  RS(IJ)
                     end if
   55             continue
               else
c --              ... per nasconderli
                  RS(IJ) = -RS(IJ)
                  NumHidd = NumHidd + 1
               end if
            end if
         end if
   50 continue
      if(iz.lt.0) then
         if (NumCancTot.gt.0) then
            write(Message,100) NumCancTot
            lMess = 30
            if (NumCanc.gt.0) then
               if (iscr.eq.0) write(lo,120)
               if (Deltd(1:1).ne.' ') write(lo,'(a)') Deltd
            end if
         else
            write(Message,110)
            lMess = 18
         endif
      else
         if (NumHidd.gt.0) then
            write(Message,200) NumHidd
            lMess = 30
         else
            write(Message,210)
            lMess = 18
         endif
      end if
c
  100 format(i3,' Atom(s) has been deleted !')
  110 format(' No Atom deleted !')
  120 format(/,' The following Atom(s) has been deleted :')
  200 format(i3,' Atom(s) has been hidden  !')
  210 format(' No Atom hidden  !')
      ifMess=1
c
      return
      end
C -----------------------------------------------------------------
      SUBROUTINE ReLab(ix,iy,iz)
      IMPLICIT REAL*4 (M)
      CHARACTER *1 Lett
      CHARACTER *5 Lab,Labb
      CHARACTER *80 Titolo
      COMMON /atomi/ xyz(3,800),NAT, RR(800), iCol(800), iOrd(800),nv,
     *               MLU(800), Lab(800), RS(800), ipix(3,800),iEqui(800)
      COMMON /Crt/ iBarre(62, 4),Lett(72),NumBar(70), iCheBarre(70, 6)
     2     , Rmin1, Rmin2, RMAX1, RMAX2, XMax, YMax, DDX, DDY, NPX, NPY
     3     , Lim1,Lim2,Lim3,Lim4,PI,Xmin,Ymin,LegCol,nlp, nMaxLeg
     5     , NumLeg, iPlotType , RK(4), VV(10,3), LE(800,2), RI(3)
      COMMON /Contr/ NF,iFirstTime,Titolo,Ratio,IfCont,IfEdge,IfScale,
     *               kplty,radii(8), IfScaleB
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,kat,f(9),nalf(8)
      common /mess/ Message,ifMess,lMess
      character *80 Message
      character blank,digit*12,card(100)*80,ffile*80
      common /chara/ blank,digit,card,ffile
      common /atoms/ x(5,200),nz(200),ngp,ninf(10),nag(10)
      common /neutro/ neutro,bmat(2,98),neuwei,vetint(200)
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      integer X11,Y11
c
      if (neutro.eq.0) then
      if(no(1).eq.1) iz = iz + 1
                       endif
      jfound = 0
      idmin = 9999
      DO 50 III = NAT + nv, 1 , -1
         IJ = iOrd(III)
         if (IJ .GT. NAT) go to 50
         X11 = ipix(1,IJ)
         Y11 = ipix(2,IJ)
         dx= ix - X11
         dy= iy - Y11
         dist = sqrt( dx*dx + dy*dy )
         idist=nint(dist)
         if (idist.le.ipix(3,IJ)) then
            if (idist.le.idmin) then
               idmin = idist
               jfound= IJ
             endif
         endif
   50 continue
c  40 format(i4,1h) ,2x,a4,8i5)
      if (jfound.gt.0) then
         jfeq = iequi(jfound)
         lnz=mod(nz(jfeq),100)
         nz(jfeq)=iz*100+lnz
         write(Message(1:33),100) Lab(jfound)
         call CreaLab(iequi(jfound),iz,Labb)
         Lab(jfound) = Labb
         write(Message(34:46),120) Lab(jfound)
         lMess = 46
         if (no(1).eq.1) then
            jlig=1
         else
            jlig=0
         endif
         if (neutro.eq.1) jlig=0
         iCol(jfound) = iz - jlig
         Rs  (jfound) = radii(iz) / 3.0
         MLu (jfound) = 2*radii(iz)+0.3
         do 55 i=1, NAT
            if (iEqui(i).eq.iEqui(jfound)) then
                if (RS(i) .gt.-10.) then
                   if (RS(i) .gt. 0.) then
                       RS(i) =  RS(jfound)
                   else
                       RS(i) = -RS(jfound)
                   end if
                end if
                iCol(i) = iCol(jfound)
                MLu(i) = MLu(jfound)
                Lab(i) = Lab(jfound)
            end if
   55    continue
      else
         write(Message,110)
         lMess = 21
      endif
c
  100 format(' Atom ',a5,' has been reLabelled  ')
  110 format(' No Atom reLabelled !')
  120 format(' as   ',a5,' !')
c
      ifMess=1
      if (lMess.gt.21) write(lo,'(a)') Message(1:lMess)
c
      return
      end
C -----------------------------------------------------------------
      SUBROUTINE Distance
      IMPLICIT REAL*4 (M)
      CHARACTER *1 Lett
      CHARACTER *5 Lab
      COMMON /atomi/ xyz(3,800),NAT, RR(800), iCol(800), iOrd(800),nv,
     *               MLU(800), Lab(800), RS(800), ipix(3,800),iEqui(800)
      COMMON /Crt/ iBarre(62, 4),Lett(72),NumBar(70), iCheBarre(70, 6)
     2     , Rmin1, Rmin2, RMAX1, RMAX2, XMax, YMax, DDX, DDY, NPX, NPY
     3     , Lim1,Lim2,Lim3,Lim4,PI,Xmin,Ymin,LegCol,nlp, nMaxLeg
     5     , NumLeg, iPlotType , RK(4), VV(10,3), LE(800,2), RI(3)
      common /mess/ Message,ifMess,lMess
      common /atoms/ x(5,200),nz(200),ngp,ninf(10),nag(10)
      character blank,digit*12,card(100)*80,ffile*80
      common /chara/ blank,digit,card,ffile
      common /buffer/ ixv(100),iyv(100),dummr(315)
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/xwi/ color,xo,yo,khead,Species,NumSpec,ihcopy,ipres,jpres
      character *80 Message, Species(8)*2
      integer *2 color, xo, yo, khead
      integer X11,Y11, jfou(100)
      dimension dis(100)
c
      iscr=0
      nf = 0
      do 60 n = 1, 99
         jfound = 0
         ix = ixv(n)
         if(ix.lt.0) goto 55
         iy = iyv(n)
         idmin = 9999
         DO 50 IJ = NAT, 1 , -1
            if ( RS(IJ).lt.0 ) go to 50
            X11 = ipix(1,IJ)
            Y11 = ipix(2,IJ)
            dx= ix - X11
            dy= iy - Y11
            dist = sqrt( dx*dx + dy*dy )
            idist=nint(dist)
            if (idist.le.ipix(3,IJ) .and. RS(IJ).gt.0) then
               if (idist.le.idmin) then
                  idmin = idist
                  jfound= IJ
               endif
            endif
   50    continue
   55    if (jfound.gt.0) then
            nf = nf + 1
            jfou(nf) = jfound
         elseif (nf .eq. 0) then
            write(Message,300)
            LMess = 35
            ifMess = 1
            goto 100
         elseif (nf .eq.1) then
            j1 = jfou(1)
            ndist = 0
            distmin = 999.
            do 30 jj = 1, NAT
               if (jj .ne. j1 .and. RS(jj).gt.0 ) then
                  dist = 0.
                  do 20 i=1,3
                     dist = dist + (xyz(i,j1)-xyz(i,jj))**2
   20             continue
                  dist = sqrt(dist)
                  if (dist .lt. distmin) then
                     distmin = dist
                     jf = jj
                  end if
                  if ( dist .le. 1.5 * MLU(j1) .or.
     *                 dist .le. 1.5 * MLU(jj)       ) then
                     ndist = ndist + 1
                     dis(ndist) = dist
                     jfou(ndist) = jj
                   end if
               endif
   30       continue
            if (ndist .eq. 0) then
               ndist = 1
               dis(1) = distmin
               jfou(1) = jf
            end if
            call DispDist(dis, jfou, j1, ndist)
            goto 100
c           nf = 0
         end if
         if (nf.eq.2) then
            dist = 0.
            j1 = jfou(1)
            j2 = jfou(2)
            do 80 i=1,3
               dist = dist + (xyz(i,j1)-xyz(i,j2))**2
   80       continue
            dist = sqrt(dist)
            write (Message,200) Lab(j1),Lab(j2),dist
            lMess = 35
            Call PrintMess
            nf = 0
            goto 100
         end if
   60 continue
c
  200 format(' Distance ',a,'- ',a,' = ',f7.4)
c
  100 khead = 0
      ipres = 31
      jpres = 52
      return
  300 format(' Sorry ....   Wrong selection !')
      end
C -----------------------------------------------------------------
      SUBROUTINE DispDist(dis, jfou, j1, ndist)
c
      IMPLICIT REAL *4 (M)
c
      COMMON /atomi/ xyz(3,800),NAT, RR(800), iCol(800), iOrd(800),nv,
     *               MLU(800), Lab(800), RS(800), ipix(3,800),iEqui(800)
      common/xwi/ color,xo,yo,khead,Species,NumSpec,iHCopy,ipres,jpres
      common /buffer/ ixv(100),iyv(100),dummr(315)
      common /mess/ Message,ifMess,lMess
      dimension dis(100), jfou(100)
      character *80 Message, Species(8)*2
      character *5 Lab
      integer *2 color, xo, yo, khead
c
      n = 1
   10 j2 = jfou(n)
      write (Message,200) n,ndist,Lab(j1),Lab(j2),dis(n)
      lMess = 38
      Call PrintMess
      khead = 1
c     ind = 5
      iz = 11
      ipres = 0
      jpres = 0
      call getkey(iz)
      if (iz.eq.0) then
         return
      else
         n = n + iz
         if (n .gt. ndist) n = 1
         if (n .lt. 1) n = ndist
         goto 10
      end if
  200 format (i3,' /',i3,') Dist. ',a,'- ',a,'=',f7.4)
      end
C -----------------------------------------------------------------
      SUBROUTINE CalcAngle
      IMPLICIT REAL*4 (M)
      CHARACTER *1 Lett
      CHARACTER *5 Lab
      COMMON /atomi/ xyz(3,800),NAT, RR(800), iCol(800), iOrd(800),nv,
     *               MLU(800), Lab(800), RS(800), ipix(3,800),iEqui(800)
      COMMON /Crt/ iBarre(62, 4),Lett(72),NumBar(70), iCheBarre(70, 6)
     2     , Rmin1, Rmin2, RMAX1, RMAX2, XMax, YMax, DDX, DDY, NPX, NPY
     3     , Lim1,Lim2,Lim3,Lim4,PI,Xmin,Ymin,LegCol,nlp, nMaxLeg
     5     , NumLeg, iPlotType , RK(4), VV(10,3), LE(800,2), RI(3)
      common /mess/ Message,ifMess,lMess
      common /atoms/ x(5,200),nz(200),ngp,ninf(10),nag(10)
      character blank,digit*12,card(100)*80,ffile*80
      common /chara/ blank,digit,card,ffile
      common /buffer/ ixv(100),iyv(100),dummr(315)
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/xwi/ color,xo,yo,khead,Species,NumSpec,iHCopy,ipres,jpres
      character *80 Message, Species(8)*2
      integer *2 color, xo, yo, khead
      integer X11,Y11, jfou(100)
c
      iscr=0
      nf = 0
      do 60 n = 1, 99
         jfound = 0
         ix = ixv(n)
         if(ix.lt.0) goto 55
         iy = iyv(n)
         idmin = 9999
         DO 50 IJ = NAT , 1 , -1
            if (RS(IJ).lt.0 ) go to 50
            X11 = ipix(1,IJ)
            Y11 = ipix(2,IJ)
            dx= ix - X11
            dy= iy - Y11
            dist = sqrt( dx*dx + dy*dy )
            idist=nint(dist)
            if (idist.le.ipix(3,IJ) .and. RS(IJ).gt.0) then
               if (idist.le.idmin) then
                  idmin = idist
                  jfound= IJ
               endif
            endif
   50    continue
   55    if (jfound.gt.0) then
            nf = nf + 1
            jfou(nf) = jfound
         end if
         if (nf.eq.3) then
            dist = 0.
            j1 = jfou(1)
            j2 = jfou(2)
            j3 = jfou(3)
c
            if (j1.eq.j2 .or. j2.eq.j3 .or. j1.eq.j3) then
               write(Message,300)
               LMess = 35
               ifMess = 1
               goto 100
            end if
c
            nvc = 0
            do 85 j=1, 3, 2
               nvc = nvc + 1
               jj = jfou(j)
               do 80 i=1, 3
                  VV(nvc,i) = xyz(i,jj) - xyz(i,j2)
   80          continue
   85       continue
            Mod1 = sqrt(VV(1,1)**2+VV(1,2)**2+VV(1,3)**2)
            Mod2 = sqrt(VV(2,1)**2+VV(2,2)**2+VV(2,3)**2)
            ModuS = VV(1,1)*VV(2,1)+VV(1,2)*VV(2,2)+VV(1,3)*VV(2,3)
            CosAng = ModuS/(Mod1*Mod2)
            if (CosAng .gt. 0.999999) CosAng = 0.999999
            if (CosAng .lt.-0.999999) CosAng =-0.999999
            Ang = acos(CosAng) * 180. / PI
            write (Message,200) Lab(j1),Lab(j2),Lab(j3),Ang
            ifMess = 1
            lMess = 38
            nf = 0
            goto 100
         elseif (ix .lt. 0) then
            write(Message,300)
            LMess = 35
            ifMess = 1
            goto 100
         end if
   60 continue
c
  200 format(' Angle ',a,'- ',a,'- ',a,' = ',f6.1)
  300 format(' Sorry ....   Wrong selection !')
c
  100 khead = 1
      ipres = 31
      jpres = 53
      return
      end
C -----------------------------------------------------------------
      SUBROUTINE AddDelBonds(iAction, NatInd)
      IMPLICIT REAL*4 (M)
      CHARACTER *1 Lett
      CHARACTER *5 Lab
      COMMON /atomi/ xyz(3,800),NAT, RR(800), iCol(800), iOrd(800),nv,
     *               MLU(800), Lab(800), RS(800), ipix(3,800),iEqui(800)
      COMMON /Crt/ iBarre(62, 4),Lett(72),NumBar(70), iCheBarre(70, 6)
     2     , Rmin1, Rmin2, RMAX1, RMAX2, XMax, YMax, DDX, DDY, NPX, NPY
     3     , Lim1,Lim2,Lim3,Lim4,PI,Xmin,Ymin,LegCol,nlp, nMaxLeg
     5     , NumLeg, iPlotType , RK(4), VV(10,3), LE(800,2), RI(3)
      COMMON /Leg1/ LE1(800,2),nLegInd
      common /mess/ Message,ifMess,lMess
      common /atoms/ x(5,200),nz(200),ngp,ninf(10),nag(10)
      character blank,digit*12,card(100)*80,ffile*80
      common /chara/ blank,digit,card,ffile
      common /buffer/ ixv(100),iyv(100),dummr(315)
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/xwi/ color,xo,yo,khead,Species,NumSpec,iHCopy,ipres,jpres
      character *80 Message, Species(8)*2
      integer *2 color, xo, yo, khead
      integer X11,Y11, jfou(100)
c
      NumAD = 0
      nf = 0
      do 60 n = 1, 99
         jfound = 0
         ix = ixv(n)
         if(ix.lt.0) goto 55
         iy = iyv(n)
         idmin = 9999
         DO 50 IJ = NAT, 1 , -1
            if ( RS(IJ).lt.0 ) go to 50
            X11 = ipix(1,IJ)
            Y11 = ipix(2,IJ)
            dx= ix - X11
            dy= iy - Y11
            dist = sqrt( dx*dx + dy*dy )
            idist=nint(dist)
            if (idist.le.ipix(3,IJ) .and. RS(IJ).gt.0) then
               if (idist.le.idmin) then
                  idmin = idist
                  jfound= IJ
               endif
            endif
   50    continue
   55    if (jfound.gt.0) then
            nf = nf + 1
            jfou(nf) = jfound
         else
            nf = 0
            goto 100
         end if
         if (nf.eq.2) then
            j1 = jfou(1)
            j2 = jfou(2)
            if (j1.eq.j2) goto 95
            NumAD = NumAD + 1
            if (iAction.eq.631) then
               do 70 i = NumLeg, NumLeg - nlp + 1, -1
                  LE(i + 1, 1) = LE(i, 1)
                  LE(i + 1, 2) = LE(i, 2)
   70          continue
               NumLeg = NumLeg + 1
               LE(NumLeg - nlp, 1) = j1
               LE(NumLeg - nlp, 2) = j2
               IF (NumLeg .EQ. nMaxLeg) goto 100
            else
               do 90 nll = 1, NumLeg
                  if(LE(nll, 1).eq.j1 .and. LE(nll, 2).eq.j2 .or.
     *               LE(nll, 1).eq.j2 .and. LE(nll, 2).eq.j1 )  then
                     if (nll.lt.NumLeg) then
                        do 80 i = nll + 1, NumLeg
                           LE(i-1, 1) = LE(i, 1)
                           LE(i-1, 2) = LE(i, 2)
   80                   continue
                     end if
                     NumLeg = NumLeg - 1
                     goto 95
                  end if
   90          continue
            end if
   95       nf = 0
         end if
   60 continue
c
  200 format(i4,'  bond(s) have been added  ')
  300 format(i4,'  bond(s) have been deleted')
c
  100 if (iAction.eq.631) then
         write(Message,200) NumAD
      else
         write(Message,300) NumAD
      end if
      IfMess = 1
      LMess = 32
c
      khead = 1
      ipres = 31
      if (iAction.eq.631) then
         jpres = 57
      else
         jpres = 58
      end if
      if (NAT .eq. NatInd) then
         do 170 i = 1, NumLeg
            LE1(i, 1) = LE(i, 1)
            LE1(i, 2) = LE(i, 2)
  170    continue
         nLegInd = NumLeg
      end if
      return
      end
C -----------------------------------------------------------------
      SUBROUTINE TorsAngle
      IMPLICIT REAL*4 (M)
      CHARACTER *1 Lett
      CHARACTER *5 Lab
      COMMON /atomi/ xyz(3,800),NAT, RR(800), iCol(800), iOrd(800),nv,
     *               MLU(800), Lab(800), RS(800), ipix(3,800),iEqui(800)
      COMMON /Crt/ iBarre(62, 4),Lett(72),NumBar(70), iCheBarre(70, 6)
     2     , Rmin1, Rmin2, RMAX1, RMAX2, XMax, YMax, DDX, DDY, NPX, NPY
     3     , Lim1,Lim2,Lim3,Lim4,PI,Xmin,Ymin,LegCol,nlp, nMaxLeg
     5     , NumLeg, iPlotType , RK(4), VV(10,3), LE(800,2), RI(3)
      common /mess/ Message,ifMess,lMess
      common /atoms/ x(5,200),nz(200),ngp,ninf(10),nag(10)
      character blank,digit*12,card(100)*80,ffile*80
      common /chara/ blank,digit,card,ffile
      common /buffer/ ixv(100),iyv(100),dummr(315)
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/xwi/ color,xo,yo,khead,Species,NumSpec,iHCopy,ipres,jpres
      character *80 Message, Species(8)*2
      integer *2 color, xo, yo, khead
      integer X11,Y11, jfou(100)
c
      nf = 0
      do 60 n = 1, 99
         jfound = 0
         ix = ixv(n)
         if(ix.lt.0) goto 55
         iy = iyv(n)
         idmin = 9999
         DO 50 IJ = NAT, 1 , -1
            if ( RS(IJ).lt.0 ) go to 50
            X11 = ipix(1,IJ)
            Y11 = ipix(2,IJ)
            dx= ix - X11
            dy= iy - Y11
            dist = sqrt( dx*dx + dy*dy )
            idist=nint(dist)
            if (idist.le.ipix(3,IJ) .and. RS(IJ).gt.0) then
               if (idist.le.idmin) then
                  idmin = idist
                  jfound= IJ
               endif
            endif
   50    continue
   55    if (jfound.gt.0) then
            nf = nf + 1
            jfou(nf) = jfound
         else
            nf = -1
            goto 100
         end if
         if (nf.eq.4) then
            j1 = jfou(1)
            j2 = jfou(2)
            j3 = jfou(3)
            j4 = jfou(4)
            if (j1.eq.j2 .or. j2.eq.j3 .or. j3.eq.j4) then
               nf = -1
               goto 100
            end if
c
c--- Calcola i vettori V1, V2 e V3
c
            do 80 i = 1, 3
               do 70 j = 1, 3
                  VV(i, j) = xyz(j, jfou(i+1)) - xyz(j, jfou(i))
   70          continue
   80       continue
c
c--- Calcola gli angoli V1^V2 e V2^V3
c
            ModuA = sqrt(VV(1,1)**2+VV(1,2)**2+VV(1,3)**2)
            ModuB = sqrt(VV(2,1)**2+VV(2,2)**2+VV(2,3)**2)
            ModuS = VV(1,1)*VV(2,1)+VV(1,2)*VV(2,2)+VV(1,3)*VV(2,3)
            CosAng = ModuS/(ModuA*ModuB)
            if (CosAng .gt. 0.999999) CosAng = 0.999999
            if (CosAng .lt.-0.999999) CosAng =-0.999999
            AngG = acos(CosAng)
            SinG = sin(AngG)
c
            ModuC = sqrt(VV(3,1)**2+VV(3,2)**2+VV(3,3)**2)
            ModuS = VV(2,1)*VV(3,1)+VV(2,2)*VV(3,2)+VV(2,3)*VV(3,3)
            CosAng = ModuS/(ModuB*ModuC)
            if (CosAng .gt. 0.999999) CosAng = 0.999999
            if (CosAng .lt.-0.999999) CosAng =-0.999999
            AngA = acos(CosAng)
            SinA = sin(AngA)
c
c--- Calcola le componenti dei prodotti vettoriali V1 x V2, V2 x V3
c   ( V4 e V5 )
c
            do 180 i = 2, 3
               VV(2+i,1) = VV(i-1,2)*VV(i,3) - VV(i-1,3)*VV(i,2)
               VV(2+i,2) =-VV(i-1,1)*VV(i,3) + VV(i-1,3)*VV(i,1)
               VV(2+i,3) = VV(i-1,1)*VV(i,2) - VV(i-1,2)*VV(i,1)
  180       continue
c
c--- Calcola il prodotto scalare V4 . V5
c
            ModuS = VV(4,1)*VV(5,1)+VV(4,2)*VV(5,2)+VV(4,3)*VV(5,3)
c
            ModuB = ModuB * ModuB
            CosAng = ModuS / (ModuA*ModuB*ModuC*SinA*SinG)
            if (CosAng .gt. 0.999999) CosAng = 0.999999
            if (CosAng .lt.-0.999999) CosAng =-0.999999
            Ang = acos(CosAng) * 180. / PI
            goto 100
c
         end if
   60 continue
c
  200 format(' Torsion angle ',a,'- ',a,'- ',a,'- ',a,' =',f6.1)
  300 format(' Sorry ....   Wrong selection !')
c
  100 if (nf.lt.0) then
         write(Message,300)
         LMess = 35
      else
         write(Message,200) Lab(j1),Lab(j2),Lab(j3),Lab(j4),Ang
         LMess = 50
      end if
      IfMess = 1
      khead = 1
      ipres = 31
      jpres = 54
c
      return
      end
C -----------------------------------------------------------------
      SUBROUTINE NumTable(iz)
      IMPLICIT REAL*4 (M)
      CHARACTER *1 Lett, nt1
      CHARACTER *5 Lab
      COMMON /atomi/ xyz(3,800),NAT, RR(800), iCol(800), iOrd(800),nv,
     *               MLU(800), Lab(800), RS(800), ipix(3,800),iEqui(800)
      COMMON /Crt/ iBarre(62, 4),Lett(72),NumBar(70), iCheBarre(70, 6)
     2     , Rmin1, Rmin2, RMAX1, RMAX2, XMax, YMax, DDX, DDY, NPX, NPY
     3     , Lim1,Lim2,Lim3,Lim4,PI,Xmin,Ymin,LegCol,nlp, nMaxLeg
     5     , NumLeg, iPlotType , RK(4), VV(10,3), LE(800,2), RI(3)
      common /mess/ Message,ifMess,lMess
      common /atoms/ x(5,200),nz(200),ngp,ninf(10),nag(10)
      COMMON /GeneraC/ DePA, DeMA, DePB, DeMB, DePC, DeMC,
     *                 RB(3, 3, 48), T(3, 48),
     *                 Shf(3, 3), Tra(3, 20), nsy, NatInd, nt1
      common /buffer/ ixv(100),iyv(100),kpointer(200),dummr(115)
      common /screen/ kscreen,iy,ivd,kscrx,kscry,jscreen,kprog,ifMouse
      common /scale/ x11scale(2),x11disp(2),ragmed,deltax,deltay
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,bfac(200),lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      common/xwi/ color,xo,yo,khead,Species,NumSpec,ihcopy,ipres,jpres
      character *80 Message, Species(8)*2
      integer *2 color, xo, yo, khead
c
      npointer = 0
      do 2 i=1,NatInd
         if (RS(i).gt.-10.0) then
                               npointer = npointer + 1
                               kpointer(npointer) = i
                             endif
    2 continue
      j=1
      do 5 i=1,20
         Message(j:j+3) = '    '
         j = j + 4
    5 continue
c
      call NewPage
      ixp = 10
      iyp0= deltay + 30
      iyp = iyp0
      ini = 1
      NumPerPag = 0
      npp = 0
      npl = 0
   15 write(Message,18)
   18 format('Atom  Height    B       Atom  Height    B       Atom  H'
     *,'eight    B  ')
      call SetColr(10)
      ind = 9
      ixv(1)= ixp
      iyv(1)= iyp
      iz = 65
      call graphs(ixv, iyv, iz, ind, Message, iot)
      iyp = iyp + 30
      call SetColr(7)
      Message = ' '
      do 20 iii = ini, npointer
         i = kpointer(iii)
         if (npp .eq. 0) NumPerPag = NumPerPag + 1
CCC      if (RS(i) .gt. -10.) then
            is = npl * 24 + 2
            npl = npl + 1
            write(Message(is:is+18),100) Lab(i),x(4,i),bfac(i)
CCC      end if
c        write(Message,100) Lab(i),x(4,i),bfac(i),
c    *         Lab(i+1),x(4,i+1),bfac(i+1),Lab(i+2),x(4,i+2),bfac(i+2)
c 100    format(2(a5,f7.0,f7.3,4x),a5,f7.0,f7.3)
  100    format(a5,f7.0,f7.3)
CCC      if (npl.eq.3 .or. i.eq.NatInd) then
         if (npl.eq.3 .or. iii.eq.npointer) then
            npl = 0
            ind = 9
            ixv(1)= ixp
            iyv(1)= iyp
            iz = 68
            call graphs(ixv, iyv, iz, ind, Message, iot)
            j=1
            do 25 id=1, 20
               Message(j:j+3) = '    '
               j = j + 4
   25       continue
            iyp = iyp + 25
CCC         if (iyp.gt.kscry-35 .or. i.eq.NatInd) then
            if (iyp.gt.kscry-35 .or. iii.eq.npointer) then
c              if (NumPerPag .eq.0) NumPerPag = i + 2
               npp = 1
               ifine = i
               khead = 1
               iz = 12
CCC            if (NumPerPag .ge. NatInd) iz = 13
               if (NumPerPag .ge. npointer) iz = 13
               ipres = 0
               jpres = 0
               call getkey(iz)
               if (iz.eq.0 .or. iz.eq.2) then
                  return
               else
  222             if (iz.lt.0) then
                     np = 0
  333                if (ini-np.gt.1) np = np + 1
CCC                  if (RS(ini - np) .gt. -10.) then
                        if (np.eq.NumPerPag .or. ini-np.eq.1) goto 444
                        goto 333
CCC                  end if
  444                ini = ini - np
                  else
                     ini = ifine + 1
  555                if (mod(ini-1,3).ne.0) then
                        ini = ini+1
                        goto 555
                     end if
CCC                  if (ini.gt.NatInd) then
                     if (ini.gt.npointer) then
                                          iz = -1 
                                          goto 222
                                        endif
                  end if
                  call NewPage
                  iyp = iyp0
                  goto 15
               end if
            end if
         end if
   20 continue
      return
      end
C -----------------------------------------------------------------
      SUBROUTINE Histogr(iz)
      IMPLICIT REAL*4 (M)
      CHARACTER *1 Lett, nt1
      CHARACTER *5 Lab
      COMMON /atomi/ xyz(3,800),NAT, RR(800), iCol(800), iOrd(800),nv,
     *               MLU(800), Lab(800), RS(800), ipix(3,800),iEqui(800)
      COMMON /Crt/ iBarre(62, 4),Lett(72),NumBar(70), iCheBarre(70, 6)
     2     , Rmin1, Rmin2, RMAX1, RMAX2, XMax, YMax, DDX, DDY, NPX, NPY
     3     , Lim1,Lim2,Lim3,Lim4,PI,Xmin,Ymin,LegCol,nlp, nMaxLeg
     5     , NumLeg, iPlotType , RK(4), VV(10,3), LE(800,2), RI(3)
      common /mess/ Message,ifMess,lMess
      common /atoms/ x(5,200),nz(200),ngp,ninf(10),nag(10)
      COMMON /GeneraC/ DePA, DeMA, DePB, DeMB, DePC, DeMC,
     *                 RB(3, 3, 48), T(3, 48),
     *                 Shf(3, 3), Tra(3, 20), nsy, NatInd, nt1
      common /buffer/ ixv(100),iyv(100),dummr(315)
      common /screen/ kscreen,iy,ivd,kscrx,kscry,jscreen,kprog,ifMouse
      common /scale/ x11scale(2),x11disp(2),ragmed,deltax,deltay
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,bfac(200),lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      common/xwi/ color,xo,yo,khead,Species,NumSpec,ihcopy,ipres,jpres
      character *80 Message, Species(8)*2
      integer *2 color, xo, yo, khead
c
      Message(1:5) = '     '
c
      call NewPage
      Max = -999.
      MaxB = -999.
      NatV=0
      do 10 i = 1, NatInd
         if (RS(i) .gt. -10.) then
            NatV = NatV + 1
            if (x(4,i).gt.Max) Max = x(4,i)
            if (bfac(i).gt.MaxB) MaxB = bfac(i)
         end if
   10 continue
      if (abs(Max).le.0.0001) Max = 1.
c
   12 ixp = deltax + 5
      ixpi = ixp
      iyp = kscry - 30
      iypm = deltay + 10
      ini = 1
      NumPerRig = NatV
      nRig = 1
      Larg = (kscrx - deltax) / NumPerRig
      if (Larg .lt.10) then
         NumPerRig = NumPerRig /2
         Larg = (kscrx - deltax) / NumPerRig
         nRig = 2
         iyp = (kscry - deltay - 60) / 2
      end if
      Larg1 = .75 * Larg
      if (Larg .eq. Larg1) Larg1 = Larg - 1
      call SetColr(7)
      ix1 = deltax
      call Linea(ix1,iyp,kscrx,iyp,7)
      do 15 i=1,3
         iypp = iyp + i * (iypm - iyp) / 4
         do 14 np=deltax, kscrx, 5
            ix2 = np + 2
            call Linea (np,iypp,ix2,iypp,7)
   14    continue
   15 continue
      nfatti = 0
      do 20 i = 1, NatInd
         if (RS(i).le.-10.) goto 20
         nfatti = nfatti + 1
         if (nfatti . eq. NumPerRig + 1) then
            iypm = iypm + iyp
            iyp = iypm + iyp
            ixp = ixpi
            call Linea(ix1,iyp,kscrx,iyp,7)
            do 18 j=1,3
               iypp = iyp + j * (iypm - iyp) / 4
               do 16 np=deltax, kscrx, 5
                  ix2 = np + 2
                  call Linea (np,iypp,ix2,iypp,7)
   16          continue
   18       continue
         end if
         AltInPix = nint(abs((x(4,i))/Max) * (iypm - iyp))
         if (AltInPix .gt. -1) AltInPix = 0.03 * (iypm-iyp)
         ixv(1) = ixp
         iyv(1) = iyp
         ixv(2) = ixp
         iyv(2) = iyp + AltInPix
         ixv(3) = ixp + Larg1
         iyv(3) = iyp + AltInPix
         ixv(4) = ixp + Larg1
         iyv(4) = iyp
         ixv(5) = ixv(1)
         iyv(5) = iyv(1)
         ind = 13
         iot = iCol(i)
         iz = 5
         call graphs(ixv, iyv, iz, ind, Message, iot)
c-- fill !!!
         ind = 14
         call graphs(ixv, iyv, iz, ind, Message, iot)
         ixp = ixp + Larg
   20 continue
c
         khead = 1
         iz = 13
         ipres = 0
         jpres = 0
         call getkey(iz)
         if (iz.eq.0 .or. iz.eq.2) then
            return
         else
            call NewPage
            goto 12
         end if
      return
      end
C -----------------------------------------------------------------
      SUBROUTINE PrintMess
      common /mess/ Message,ifMess,lMess
      character *80 Message
      common /buffer/ ixv(100),iyv(100),dummr(315)
c
      icolor=14
      call SetColr(icolor)
      ind = 15
      iz = min0(lMess+1,80)
      Message(iz:iz)=char(0)
      call graphs( ixv,iyv,lMess,ind,Message,icolor)
      ifMess=0
c
      return
      end
c-----------------------------------------------------------------------
      SUBROUTINE zflush
      character*80 string
      common /buffer/ ixv(100),iyv(100),dummr(315)
c* *ind == 7 : xflush
      ind=7
      icolor=1
      call SetColr(icolor)
      call graphs(ixv,iyv,iz,ind,string,icolor)
c
      return
      end
c-----------------------------------------------------------------------
      SUBROUTINE getkey(iz)
      character string*80, Species(8)*2
      common /buffer/ ixv(100),iyv(100),dummr(315)
      common/xwi/ color,xo,yo,khead,Species,NumSpec,iHCopy,ipres,jpres
      integer *2 color, xo, yo, khead
c
c* *ind == 5 : eventloop (mouse)
      ind=5
      icolor=1
      if (if_mouse_there().eq.1) then 
      call graphs(ixv,iyv,iz,ind,string,icolor)
                               else 
                                 iz=0
                               endif 
c
      return
      end
c-----------------------------------------------------------------------
      SUBROUTINE CreaLab(i,lnz,Labb)
      CHARACTER *5  Lab, Labb
      CHARACTER *6  Buffer
      COMMON /atomi/ xyz(3,800),NAT, RR(800), iCol(800), iOrd(800),nv,
     *               MLU(800), Lab(800), RS(800), ipix(3,800),iEqui(800)
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,kat,f(9),nalf(8)
      common /atoms/ x(5,200),nz(200),ngp,ninf(10),nag(10)
      common /neutro/ neutro,bmat(2,98),neuwei,vetint(200)
      common /screen/ kscreen,iy,ivd,kscrx,kscry,jscreen,kprog,ifMouse
      common/xwi/ color,xo,yo,khead,Species,NumSpec,ihcopy,ipres,jpres
      character  Species(8)*2
      integer *2 color, xo, yo, khead
c
      Buffer = '      '
      if (lnz.ne.0) then
         if (mod(kprog,10) .lt. 3) then
             write(Buffer(1:2),'(a2)') nalf(lnz)
         else
             Buffer(1:2) = Species(lnz)
         end if
      else
         Buffer(1:2)='Q '
      endif
      sg=1.0
      if(neutro.gt.0.and.lnz.gt.0) sg=x(4,i)*bs(1,lnz)
      if(sg.lt.0.0) then
                      write(Buffer(1:2),'(a2)') 'nl'
                    else
      call ucase(Buffer(1:1))
                    endif
      if (Buffer(2:2).eq.' ') then
         k=2
      else
         if (i.le.999) then
            k=3
         else
            Buffer(1:1)='X'
            k=2
         endif
      endif
      write(Buffer(k:k+3),'(i4)') i
      call xcmprp(Buffer,lstri)
      Labb=Buffer(1:lstri)
c
      return
      end
c-----------------------------------------------------------------------
      SUBROUTINE ModCom(jrest0)
c
      CHARACTER *5  Lab
      CHARACTER *1 Lett, nt1
      COMMON /Crt/ iBarre(62, 4),Lett(72),NumBar(70), iCheBarre(70, 6)
     2     , Rmin1, Rmin2, RMAX1, RMAX2, XMax, YMax, DDX, DDY, NPX, NPY
     3     , Lim1,Lim2,Lim3,Lim4,PI,Xmin,Ymin,LegCol,nlp, nMaxLeg
     5     , NumLeg, iPlotType , KR(4), VV(10,3), LE(800,2), RI(3)
      COMMON /atomi/ xyz(3,800),NAT, RR(800), iCol(800), iOrd(800),nv,
     *               MLU(800), Lab(800), RS(800), ipix(3,800),iEqui(800)
      COMMON /GeneraC/ DePA, DeMA, DePB, DeMB, DePC, DeMC,
     *                 RB(3, 3, 48), T(3, 48),
     *                 Shf(3, 3), Tra(3, 20), nsy, NatInd, nt1
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,bfac(200),lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,natsir,f(9),nalf(8)
      common /atoms/ x(5,200),nz(200),ngp,ninf(10),nag(10)
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common /xdata/ store(244000)
      common /temp/  conn(9800)
      dimension B(3, 3)
c
c     NAT = NATind
      call SoloInd(B,NATind)
c
c-- update atoms
c
      j=0
      ndel = 0
      do 200 i=1,nats
         if (RS(i).lt.-10.0) then
            ndel = ndel +1
            MLU(i) = 0
         else
            MLU(i) = i - ndel
            j = j + 1
            nz(j) = nz(i)
            bfac(j) = bfac(i)
            do 100 k = 1 , 5
               x(k,j) = x(k,i)
  100       continue
         endif
  200 continue
c
      nats = j
c
c-- update connectivity
c
      NLeg = NumLeg - nlp
c
      k=0
      do 300 j=1,NLeg
         le1=LE(j,1)
         le2=LE(j,2)
         if (MLU(le1).gt.0 .and. MLU(le2).gt.0) then
c             if (le1.eq.iequi(le1) .and. le2.eq.iequi(le2)) then
                 k=k+1
                 LE(k,1) = MLU(le1)
                 LE(k,2) = MLU(le2)
c             end if
         endif
  300 continue
c
      NLeg = k
c
      j=1
      conn(1)=NLeg
      do 400 i=1,NLeg
         do 400 k=1,2
            j=j+1
            conn(j)=LE(i,k)
  400 continue
c
      jrest=jrest0
      interp=1
      call frm15(nats,numset,interp)
      call cp1530
c
      return
      end
C ----------------------------------------------------------------------
      SUBROUTINE ReGro
c
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,bfac(200),lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      common /atoms/ x(5,200),nz(200),ngp,ninf(10),nag(10)
      common /atomo/ xyzo(5,200),nzo(200),dold(400)
      common/sf/al(4,8),bs(4,8),cl(8),nnw(8),nno(8),nk,nat,f(9),nalf(8)
      common/ureq/ ihx(3),ksigma,knw,jpart,jtran,fosog,nonos,iprin,iflag
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common/inpcl/ntype,ttype(10,5),nprojx,nbond,dmaxi,radnew(8)
      dimension izpk(500)
c
      nbond=1
c
c-- regroup the molecule.
c
      kact=5
      call maincl(izpk,kact,iprin)
c
c-- save atom list for future use
c
      interp=1
      call frm15(nats,numset,interp)
c
      return
      end
C -----------------------------------------------------------------
      SUBROUTINE Traslate (iAction)
c
      CHARACTER *1 Lett
      COMMON /Crt/ iBarre(62, 4),Lett(72),NumBar(70), iCheBarre(70, 6)
     2     , Rmin1, Rmin2, RMAX1, RMAX2, XMax, YMax, DDX, DDY, NPX, NPY
     3     , Lim1,Lim2,Lim3,Lim4,PI,Xmin,Ymin,LegCol,nlp, nMaxLeg
     5     , NumLeg, iPlotType , RK(4), VV(10,3), LE(800,2), RI(3)
c
      Rmin1 = Xmin
      Rmin2 = Ymin
      RMax1 = XMax
      RMax2 = YMax
      D1 = (RMAX1 - Rmin1) / 10
      D2 = (RMAX2 - Rmin2) / 10
      IF (iAction.EQ.13) then
         Rmin1 = Rmin1 + D1
         RMax1 = RMax1 + D1
      else IF (iAction.EQ.14) then
         Rmin1 = Rmin1 - D1
         RMax1 = RMax1 - D1
      else IF (iAction.EQ.15) then
         Rmin2 = Rmin2 + D2
         RMax2 = RMax2 + D2
      else IF (iAction.EQ.16) then
         Rmin2 = Rmin2 - D2
         RMax2 = RMax2 - D2
      else IF (iAction.EQ.17) then
         Rmin1 = Rmin1 - D1
         RMax1 = RMax1 + D1
         Rmin2 = Rmin2 - D2
         RMax2 = RMax2 + D1
      else IF (iAction.EQ.18) then
         Rmin1 = Rmin1 + D1
         RMax1 = RMax1 - D1
         Rmin2 = Rmin2 + D2
         RMax2 = RMax2 - D2
      end if
      Xmin = Rmin1
      Ymin = Rmin2
      XMax = RMax1
      YMax = RMax2
      CALL SetScale(3)
      RETURN
      END
C -----------------------------------------------------------------
      SUBROUTINE tomolplo1(a,b,c,alf,bet,gam)
      CHARACTER *1 Lett
      CHARACTER *80 Titolo
      CHARACTER *5 Lab
      COMMON /Contr/ NF,iFirstTime,Titolo,Ratio,IfCont,IfEdge,IfScale,
     *               kplty,radii(8), IfScaleB
      COMMON /Crt/ iBarre(62, 4),Lett(72),NumBar(70), iCheBarre(70, 6)
     2     , Rmin1, Rmin2, RMAX1, RMAX2, XMax, YMax, DDX, DDY, NPX, NPY
     3     , Lim1,Lim2,Lim3,Lim4,PI,Xmin,Ymin,LegCol,nlp, nMaxLeg
     5     , NumLeg, iPlotType , RK(4), VV(10,3), LE(800,2), RI(3)
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      COMMON /atomi/ xyz(3,800),NAT, RR(800), iCol(800), iOrd(800),nv,
     *               MLU(800), Lab(800), RS(800), ipix(3,800),iEqui(800)
      common/rc/p(6),cx(9),dumm(9)
      common /screen/ kscreen,iy,ivd,kscrx,kscry,jscreen,kprog,ifMouse
c
      if (mod(kprog,10) .lt. 3) then
         a   = cx(1)
         b   = cx(2)
         c   = cx(3)
         alf = cx(4)
         bet = cx(5)
         gam = cx(6)
         write(Titolo,'(20a4)') (itle(i),i=1,20)
      else
         read(ln,'(a)') titolo
         read(ln,*) a, b, c, alf, bet, gam
         cx(1) = a
         cx(2) = b
         cx(3) = c
         cx(4) = alf
         cx(5) = bet
         cx(6) = gam
      end if
c
      return
      end
C -----------------------------------------------------------------
      SUBROUTINE tomolplo2
      REAL *4 MLu
      CHARACTER  str2*2,str*80
      CHARACTER *1 Lett,carat,nt1
      CHARACTER *80 Titolo
      CHARACTER *5  Lab, Labb
      COMMON /Contr/ NF,iFirstTime,Titolo,Ratio,IfCont,IfEdge,IfScale,
     *               kplty,radii(8), IfScaleB
      COMMON /Crt/ iBarre(62, 4),Lett(72),NumBar(70), iCheBarre(70, 6)
     2     , Rmin1, Rmin2, RMAX1, RMAX2, XMax, YMax, DDX, DDY, NPX, NPY
     3     , Lim1,Lim2,Lim3,Lim4,PI,Xmin,Ymin,LegCol,nlp, nMaxLeg
     5     , NumLeg, iPlotType , RK(4), VV(10,3), LE(800,2), RI(3)
      COMMON /GeneraC/ DePA, DeMA, DePB, DeMB, DePC, DeMC,
     *                 RB(3, 3, 48), T(3, 48),
     *                 Shf(3, 3), Tra(3, 20), nsy, NatInd, nt1
      common/work/rm(3,3), eval(3), evec(3,3), ainer(3,3)
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common /atoms/ x(5,200),nz(200),ngp,ninf(10),nag(10)
      COMMON /atomi/ xyz(3,800),NAT, RR(800), iCol(800), iOrd(800),nv,
     *               MLU(800), Lab(800), RS(800), ipix(3,800),iEqui(800)
      common /tape/ cell(6),neqv,icent,lat,natm,ts(3,24),is(2,3,24),nsym
     *             ,dumb(3)
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,kat,f(9),nalf(8)
      common/lst03/l3,m3,md3,n3,l3t,m3t,l3ti,m3ti,l3g,n3g,sys03
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,bfac(200),lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      common / data/  store(5000)
      common /temp/  conn(9800)
      common /buffer/ ixv(100),iyv(100),dummr(315)
      common /screen/ kscreen,iy,ivd,kscrx,kscry,jscreen,kprog,ifMouse
      common /neutro/ neutro,bmat(2,98),neuwei,vetint(200)
      common/xwi/ color,xo,yo,khead,Species,NumSpec,ihcopy,ipres,jpres
      character  Species(8)*2
      integer *2 color, xo, yo, khead
      dimension x1(3),r(3),ibuff(5000)
      equivalence (store(1),ibuff(1))
c
      nMaxLeg = 800
c
      if (mod(kprog,10) .lt. 3) then
      call yfl03
      m3=l3
      do 5 i= 1,n3
          radii(i) = store(m3+15)
          m3=m3+md3
    5 continue
      if (no(1).eq.1) then
          jlig=1
      else
          jlig=0
      endif
      if (neutro.eq.1) jlig=0
      if (jscreen.eq.1) then
          str=' '
          write(str2,10) nalf(jlig+1)
          call ucase(str2(1:1))
          write(str(1:2),10) str2
   10     format(a2)
          j=3
          iz=nk-jlig
          do 20 i=2,iz
          write(str2,10) nalf(jlig+i)
          call ucase(str2(1:1))
          write(str(j:j+2),30) str2
          j=j+3
   20     continue
   30     format('+',a2)
CHAR      str(j:j)=char(0)
          ind=16
          call graphs( ixv,iyv,iz,ind,str,icolor)
          jscreen = 2
                        endif
c
      idisp = 1
      call sfl15(nats,idisp,numset,interp)
c
      do 50 i = 1, nats
          NAT = i
          knz=nz(i)/100
*          if (knz.eq.0) go to 50
          do 40 j = 1, 3
              x1(j)=x(j,i)
   40     continue
c                                               max
c                                             lung di raggio  1-7
c                                  label  xyz legame  palla  colore
c     read(ic,'(a3,1x,5f10.0,i4)') Lab(i), x, MLu(i), RS(i), iCol(i)
          call molt1(rm,x1,r)
          xyz(1,i) = r(1)
          xyz(2,i) = r(2)
          xyz(3,i) = r(3)
          lnz=iabs(knz)
          call CreaLab(i,lnz,Labb)
          Lab(i)=Labb
          if (knz.ne.0) then
              jnz = lnz
              iCol(i)=lnz - jlig
          else
              jnz = jlig+1
              iCol(i)= 7
          endif
          if(Labb(1:2).eq.'nl') iCol(i)=7
          Rs(i)=radii(jnz) / 3.0
          MLu(i)=2*radii(jnz)+0.3
          iEqui(i) = i
   50 continue
      else
         NumSpec = 0
         read(ln,*) NAT
         do 70 i=1, NAT
            read(ln,'(a5,1x,5f10.0,i4)') Lab(i), x1, MLu(i), RS(i),ic
            x(1,i) = x1(1)
            x(2,i) = x1(2)
            x(3,i) = x1(3)
            call molt1(rm,x1,r)
            xyz(1,i) = r(1)
            xyz(2,i) = r(2)
            xyz(3,i) = r(3)
            iEqui(i) = i
            iCol(i) = ic
            if (RS(i) .lt. 0.11) then
               RS(i) = 0.22
            endif
            carat=Lab(i)(2:2)
            numcar=ichar(carat)
            if (numcar.gt.48 .and. numcar .lt.58) then
               str2 = Lab(i)(1:1) // ' '
            else
               str2 = Lab(i)(1:2)
            end if
            do 60 nc=1, NumSpec
               if (Species(9 - nc).eq.str2 .or. str2.eq.'Q ') goto 70
   60       continue
            NumSpec = NumSpec + 1
            Species(9 - NumSpec) = str2
            Radii(NumSpec) = 3. * RS(i)
   70    continue
         do 75 i=1, NumSpec
            Species(i) = Species(8 - NumSpec + i)
cccccccccc  nalf(i) = Species(i)
            Species(8 - NumSpec + i) = '  '
   75    continue
         read(ln,*) nsy
         nsym = nsy
         do 80 i=1, nsym
            read(ln,*) (T(j,i), j=1,3), ((RB(j,k,i), k=1,3), j=1,3)
   80    continue
         read(ln,'(a)') nt1
      end if
c
      CALL AggiuSpig
c
      NATind = NAT
c
      return
      end
C -----------------------------------------------------------------
      SUBROUTINE topl
      character*80 string
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common /buffer/ ixv(100),iyv(100),dummr(315)
c* *ind == 3 : reset title and menu window
      ind=3
      write(string,'(20a4)') itle
      call graphs(ixv,iyv,iz,ind,string,icolor)
c
      return
      end
C ----------------------------------------------------------------------
      SUBROUTINE defswi
      character*80 string
      CHARACTER *80 Titolo
      COMMON /Contr/ NF,iFirstTime,Titolo,Ratio,IfCont,IfEdge,IfScale,
     *               kplty,radii(8), IfScaleB
      common /buffer/ ixv(100),iyv(100),dummr(315)
c* *ind == 8 : Set Switches to default value
      IfEdge = 0
      IfCont  = 0
      IfScale = 1
      ind=8
      call graphs(ixv,iyv,iz,ind,string,icolor)
c
      return
      end
 
C --------------------------------------------------------------------
      FUNCTION Interno (ix, iy, nv)
      COMMON /buffer/ ixv(100), iyv(100),dummr(315)
      real  m
c
      NumIntD = 0
      NumIntS = 0
      Inter = 0
      do 10 k = 1, nv - 1
          ia = iy - iyv(k + 1)
          IF (ia .ne. 0) THEN
              a1 = iy - iyv(k + 1)
              b1 = iyv(k) - iy
              IF (b1 / a1 .ge. 0.0) THEN
                  IF (iyv(k + 1) .ne. iyv(k)) THEN
                      a = ixv(k + 1) - ixv(k)
                      b = iyv(k + 1) - iyv(k)
                      IF (ABS(b) .gt. .00001) THEN
                          m = a / b
                      ELSE
                          m = 0
                      END IF
                      rix1 = ixv(k) + (iy - iyv(k)) * m
                  ELSE
                      rix1 = ixv(k)
                  END IF
                  IF (rix1 .lt. ix) THEN
                      NumIntS = NumIntS + 1
                  END IF
                  IF (rix1 .gt. ix) THEN
                      NumIntD = NumIntD + 1
                  END IF
              END IF
          END IF
10    continue
      IF (NumIntD .gt. 0) THEN
         IF (INT(NumIntD / 2) * 2 .ne. NumIntD) THEN
            Inter = -1
         END IF
      END IF
      IF (NumIntS .gt. 0) THEN
         IF (INT(NumIntS / 2) * 2 .ne. NumIntS) THEN
            Inter = Inter - 1
         END IF
      END IF
      Interno = Inter
c
      return
      END
C --------------------------------------------------------------------
      SUBROUTINE ChePiano(iScelta)
c
      CHARACTER *1 Lett
      CHARACTER *5 Lab
      CHARACTER *80 Titolo
c
      COMMON /Crt/ iBarre(62, 4),Lett(72),NumBar(70), iCheBarre(70, 6)
     2     , Rmin1, Rmin2, RMAX1, RMAX2, XMax, YMax, DDX, DDY, NPX, NPY
     3     , Lim1,Lim2,Lim3,Lim4,PI,Xmin,Ymin,LegCol,nlp, nMaxLeg
     5     , NumLeg, iPlotType , RK(4), VV(10,3), LE(800,2), RI(3)
      COMMON /atomi/ xyz(3,800),NAT, RR(800), iCol(800), iOrd(800),nv,
     *               MLU(800), Lab(800), RS(800), ipix(3,800),iEqui(800)
      COMMON /work/ rm(3,3), eval(3), evec(3,3), ainer(3,3)
      COMMON /Contr/ NF,iFirstTime,Titolo,Ratio,IfCont,IfEdge,IfScale,
     *               kplty,radii(8), IfScaleB
      common /screen/ kscreen,iy,ivd,kscrx,kscry,jscreen,kprog,ifMouse
      DIMENSION B(3, 3)
c
      if (iScelta.ge.1 .and. iScelta .le.3) then
          Call LsPlane(NATV)
          if (NATV.eq.0) then
              return
          end if
          VecX = evec(1, iScelta)
          VecY = evec(2, iScelta)
          VecZ = evec(3, iScelta)
      elseif (iScelta.ge.4 .and. iScelta .le.6) then
          k = NAT + iScelta - 3
          VecX = xyz(1, k) - xyz(1, NAT + 4)
          VecY = xyz(2, k) - xyz(2, NAT + 4)
          VecZ = xyz(3, k) - xyz(3, NAT + 4)
      end if
      if (iScelta .lt. 7) then
          CALL PlaneFound(VecX, VecY, VecZ)
          CALL FindOr(B)
      END IF
c
      return
      end
C -----------------------------------------------------------------
      SUBROUTINE PlaneFound (VecX, VecY, VecZ)
c
      CHARACTER *1 Lett
      CHARACTER *5 Lab
      CHARACTER *80 Titolo
c
      COMMON /Crt/ iBarre(62, 4),Lett(72),NumBar(70), iCheBarre(70, 6)
     2     , Rmin1, Rmin2, RMAX1, RMAX2, XMax, YMax, DDX, DDY, NPX, NPY
     3     , Lim1,Lim2,Lim3,Lim4,PI,Xmin,Ymin,LegCol,nlp, nMaxLeg
     5     , NumLeg, iPlotType , RK(4), VV(10,3), LE(800,2), RI(3)
      COMMON /atomi/ xyz(3,800),NAT, RR(800), iCol(800), iOrd(800),nv,
     *               MLU(800), Lab(800), RS(800), ipix(3,800),iEqui(800)
      COMMON /work/ rm(3,3), eval(3), evec(3,3), ainer(3,3)
      COMMON /Contr/ NF,iFirstTime,Titolo,Ratio,IfCont,IfEdge,IfScale,
     *               kplty,radii(8), IfScaleB
      common /screen/ kscreen,iy,ivd,kscrx,kscry,jscreen,kprog,ifMouse
c
      nRot = 1
      nRTot = 1
      VMod = VecX ** 2 + VecY ** 2
      V1Mod = SQRT(VMod + VecZ ** 2)
      VMod = SQRT(VMod)
      s = VMod / V1Mod
      IF (s .lt. .999) THEN
          Ang = ATAN(s / SQRT(1 - s * s))
          Ang = 180 * Ang / PI
      ELSE
          Ang = 90
      END IF
      if (VecZ .lt. 0) then
          s = -1
      else
          s = 1
      end if
      Ang = s * ABS(Ang)
      RK(1) = Ang
      RK(2) = 4
      RK(3) = 1
      VV(1, 1) = VecY
      VV(1, 2) = -VecX
      VV(1, 3) = 0
      IF (abs(VecX).lt.0.00001 .AND. abs(VecY).lt.0.00001) THEN
          VV(1, 3) = 1
      END IF
c
      return
      end
