c     generate complete hemisphere of reflexion data
      subroutine expand(numb2,mode,ccfom,ier)
      character space*16
      dimension cfom(2250),ep(31000),i1(3),i2(3),kind(24),tab(15)
      dimension ipos(302),lh(60),lk(60),ll(60),ew(60),ed(60)
      common /erl/ kmat(48,3,3),tmat(48,3),nt(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common /xdata/ ihkl(31000),e(31000),iphaz(31000),iphb(31000)
     *              ,wt(31000),nzsav(500),occsav(500),duma(4000)
     *              ,dummpc(84000)
      common /atomo/ xyzo(5,200),nzo(200),dold(400)
      common /atoms/ x(5,200),nz(200),ngp,ninf(10),nag(10)
      common/rc/p(6),cx(9),nref,nb,rhomax,mm,en,mz,er,th,rhomin
      common /refl/ ih(100),g(2,100)
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/ureq/ ihx(3),ksigma,knw,jpart,jtran,fosog,nonos,iprin,iflag
      common / ureq1/ jpatt,jpunt(501),ksacc,jseteq,jumpp,jmpsie,nsec 
      common/impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
      common/trig/sint(450),pi,twopi,dtor,rtod
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common /kuse/ kuser1,kuser2,kuser3
      common /tran/ scale,mh(3),level,it4,xlim(3)
      common /tape/ cell(6),neqv,icent,lat,natm,ts(3,24),is(2,3,24),nsym
     *             ,dumb(3)
      common /misc/ t(3,3),dxmax(3),mcon,iwt,fom(11),pts
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,bfac(200),lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      common/sf/al(4,8),bs(4,8),cl(8),nnw(8),nno(8),nk,nat,f(9),nalf(8)
      dimension vet(12),ivet(12)
      equivalence (vet(1),ivet(1))
      equivalence (iphaz(1),ep(1),cfom(1))
      equivalence (ih(1),lh(1)),(ih(61),lk(1)),(g(1,11),ll(1)),
     1  (g(1,41),ew(1)),(g(1,71),ed(1))
c
      nexp=0
      call inptf(npseud,numb)
      if (mode.ne.1) numb=numb2
      if (mode.ne.1) numb=nref
      if (numb.gt.31000) numb=31000
      if (jpatt.eq.0) call getref(ratio,mode,npseud,numb,ep)
c
c     temporary call to prepare common area
c     to manage atoms in special position
c
      call xspinb
      if (jpatt.eq.0) then
c
c     examine sets of phases in order of combined figure of merit unless
c     set is specified by the user
c
      if (mode.eq.1) then
      call srlin (16,lsn,lfw,llw,lpb,ll16)
      if(lfw.gt.0) then
                     call ysfl16(cfom,ipos,nset)
                   else
                     write(lo,140)
                     ier=-1
                     return
                   endif
  140 format(/,' *** error ***  no sets of phases available')
      if (numset.ge.1000) numset=nset-(numset-1000)
      if(numset.gt.0.and.numset.le.nset) goto 170
      if(numset.gt.0.and.numset.gt.nset) then
                                           write(lo,150) numset,nset
                                           ier=-1
                                           return
                                         endif
  150 format(/,' *** error ***  set ',i3,' has been required',/,
     *         '                but only ',i3,' sets are available')
      npos = 1
      do 160 j=1,nset
      if (cfom(j) .gt. cfom(npos)) npos = j
  160 continue
c     mark selected set
      cfom(npos) = cfom(npos)-100.0
      call ysup16(cfom,ipos,nset)
c   select set
  170 if (numset.gt.0) then
         no=numset
         nono=ipos(numset)
      else
         no=npos
         nono=ipos(npos)
      endif
      numset = no
      call snr16(nono,fom,ep,iphb)
      endif
  431 format(//,1h1, 79('+'),//,12x,
     1       '***   E-map interpretation  ***',//)
  432 format(//,1h , 79('+'),//,20x,
     1       '***   Fourier recycling section  ***',//, 9x,20a4)
  433 format(//,1h , 79('+'),//,19x,
     1       '***   Intermediate interpretation  ***',//)
  434 format(//,1h , 79('+'),//,20x,
     1 '***   Fourier recycling restarted  ***',//, 9x,
     3 '  In step B scale factor, atomic coordinates and isotropic',
     * /,13x,' thermal factors are refined via diagonal matrix.',
     4 //,23x,'Step      cycle       residual',/)
  435 format(//,1h , 79('+'),//,19x,
     1       '***   Final interpretation  ***',//,
     2       //, 9x,20a4,//)
  436 format(/,10x,i5,' (',i3,'% of total ) reflections used with Fo > '
     4   ,f8.2,//,23x,'Step      cycle       residual',/)
  437 format(/,10x,i5,' (',i3,'% of total ) reflections used with Fo > '
     4   ,f4.2,' * sigma(Fo)',//,23x,'Step      cycle       residual',/)
c
      if(mode.ne.1)then
                     if (mode.eq.2) then
                                      write(lo,432) itle
                                      perc=100.0*float(numb)/float(nref)
                                      iperc=nint(perc)
                                      if (ratio.lt.0.0) then
                                      write(lo,436) numb,iperc,fosog
                                                        else
                                      write(lo,437) numb,iperc,ratio
                                                        endif
                                    endif
                     idisp=1
                     call sfl15(natsn,idisp,idumm,interp)
      if (krecy.eq.1) write(lo,434) 
      if (krecy.gt.0) then
                        nemap(1)=nats
                        jlig=1
                        if (nno(1).eq.1) jlig=2
                        jlig=jlig*100+1
                        do 438 i=1,nats
                        if (nz(i).ne.0.and.jrest.eq.0) nz(i)=jlig
  438                   continue
                      endif
                     call pkl15(nats)
                     if (jrest.eq.0) then
                        if (krecy.eq.0) then
                        call sftra(mode,numb,ep)
                                        else
                        call sftrb(mode,numb,ep)
                        krecy=krecy+1
                                        endif
                                     else
                        call sftrc(mode,numb,ep)
                        krecy=krecy+1
                                     endif
                     rfac=erre*100.0
                     if (mode.eq.jrecyc+1) then
                                             write(lo,435) itle
                                             ier=1
                                             return
                                           endif
                     deltar=erreo-erre
                     if (krecy.le.0) then
                     if (deltar.lt.0.0025) then
                         write(lo,433)
Corig                    if (deltar.lt.0.0) 
Corig*                       call cp3015
                         if (deltar.lt.0.0) then
                             call cp3015
                             call sfl15(nats,idisp,idumm,interp)
                           endif
                         krecy=1
                         ier=1
                         return
                       endif
                                       else
                     if (deltar.lt.0.0) then
                               if (krecy.gt.3) then
      if (iprin.gt.2) write(lo,*) ' r-fac stop %',krecy
                                             write(lo,435) itle
                             call cp3015
                             call sfl15(nats,idisp,idumm,interp)
                                                 ier=1
                                                 return
                                               endif
                                        endif
                                       endif
                     erreo=erre
                     call cp1530 
                   endif
      do 185 i=1,numb
      wt(i)   = ep(i)
      e(i)    = e(i)*ep(i)
      iphaz(i)= iphb(i)
  185 continue
c
c-- richiamo subr. gestione psi-e
      if (mode.eq.1.and.jmpsie.eq.0) call gpsie(numb,error,dalfa,nexp)
      if (mode.eq.1) numb2=numb
c
      if (mode.ne.1.or.jpatt.ne.0) go to 195
      write(lo,187)
      write(lo,188)
      write(lo,189)
      write(lo,191)
      write(lo,193)
      write(lo,192) no,(fom(i),i=1,5)
      ccfom=fom(5)
      write(lo,187)
  187 format( 6x,'+------------',54('-'),'+')
  188 format( 6x,'i           i        F i g u r e s      o f     '
     1 ,' m e r i t         i')
  189 format( 6x,'i  Set no.  i',54('-'),'i')
  191 format( 6x,'i           i   mabs   i  alcomb  i  R(x,y)  i'
     1 ,'  cphase  i   cfom   i')
  192 format( 6x,'i ',i6,'    i',5(f8.4,'  i'))
  193 format( 6x,'i-----------i',5('          i'))
  195 continue
      endif 
      if (numb.eq.0) then
         write(lo,196)
         ier=-1
         return
      endif
  196 format(/,' *** error *** no reflections supplied')
      if (mode.eq.1) then
c-- psi-e informations
      if (nexp.ne.0) then
      if (knw.eq.0) then
                      write(lo,4500) nexp
                    else
                      write(lo,4510) error,dalfa,nexp
                    endif
                    else 
                      write(lo,281)
                    endif
                    endif
 4500 format(/,19x,' number of added psi-e reflections  ',i6,/)
 4510 format(/,19x,'                  mean phase error  ',f9.2,/
     *         19x,'         weighted mean phase error  ',f9.2,/,
     *         19x,' number of added psi-e reflections  ',i6,/)
      if (jpatt.eq.0) then
                        do 199 i=1,numb
                        phase=dtor*float(iphaz(i))
                        ep(i)=e(i)*sin(phase)
                        e(i)=e(i)*cos(phase)
  199                   continue
                      endif
c
c     set default values of program parameters unless specified by user
c
c
c     calculate number of grid points for fourier map
c
  248 continue
      do 280 i=1,3
         np(i)=cell(i)/factr+0.5
         if(i.eq.3) np(i)=np(i)+mod(np(i),2)
  250    ntest=np(i)
         do 270 j=2,5
  260       if(ntest.ne.(ntest/j)*j) go to 270
            ntest=ntest/j
            if(ntest.eq.1) go to 280
            go to 260
  270    continue
         np(i)=np(i)+1
         if(i.eq.3) np(i)=np(i)+1
         go to 250
  280 continue
      if (np(1).le.150) go to 282
      factr=factr+0.02
      go to 248
  282 if (mode.ne.1) go to 315
      write(lo,292)
      write(space,'(16a1)') (nt(i),i=1,16)
      call ucase(space(1:1))
      write(lo,284) space,cell
  284 format( 6x,
     * 'i                           Space group symbol  i',
     * 2h  ,a16,1hi,/, 6x,
     1 'i                     Unit cell parameters   a  i',
     2 f10.3,8x,'i',/, 6x,'i',44x,'b  i',f10.3,8x,'i',/, 6x,'i',
     3 44x,'c  i',f10.3,8x,'i',/, 6x,'i',40x,'alpha  i',f10.3,8x,'i',/
     4 , 6x,'i',41x,'beta  i',f10.3,8x,'i',/, 6x,'i',40x,'gamma  i',
     5 f10.3,8x,'i',/, 6x,'i',47x,'i',18x,'i')
  281 format(///)
  292 format( 6x,'+',47('-'),'+------------------+')
      write(lo,294) factr,np,mh
  294 format( 6x,
     1 'i  Grid spacing (in angstrom) is approximately  i',
     2 f10.3,8x,1hi,/, 6x,'i',47x,'i',18x,'i',/, 6x,
     3 'i    Number of grid points in fourier map   nx  i',
     4 i6,12x,'i',/, 6x,'i',43x,'ny  i',i6,12x,'i',/, 6x,
     5 'i',43x,'nz  i',i6,12x,'i',/, 6x,'i',47x,'i',18x,'i',/, 6x,
     6 'i                   Maximum indices value    h  i',
     7 i6,12x,'i',/, 6x,'i',44x,'k  i',i6,12x,'i',/, 6x,
     5 'i',44x,'l  i',i6,12x,'i',/, 6x,'i',47x,'i',18x,'i')
  315 if (np(1) .le. 150) go to 400
      write(lo,320)
  320 format (/,22x,'nx greater than 150. increase array inut in subro
     1utine outpuf of fft modul',/,
     2            22x,'or increase the grid value')
      ier=-1
      return
  400 continue
      if (mode.eq.1) write(lo,460) numb
      rewind jrel
  460 format ( 6x,
     1 'i      Number of independent reflections input  i',
     2 i6,12x,'i',/, 6x,'i',47x,'i',18x,'i')
c
c     generate one complete hemisphere of reflexions
c
      do 470 i=1,15
         tab(i)=sin(float(30*i)*dtor)
  470 continue
      nex = 0
      fsum=0.0
      ip5=256*(262144+512+1)
      nbatch=0
      if (jpatt.ne.0) then
                        if (npseud.eq.0) then
                                           jind=4
                                         else
                                           jind=6
                                         endif
                        if (jpatt.eq.2) jind=5
                      endif
      do 800 jn=1,numb
      if (jpatt.eq.0) then
                        i1(1)=ihkl(jn)/262144
                        j=ihkl(jn)-262144*i1(1)
                        i1(2)=j/512-256
                        i1(3)=j-512*(i1(2)+256)-256
                        eep=ep(jn)
                        ee =e (jn)
                      else
                        eep=0.0
                        call snr07(vet)
                        i1(1)=ivet(1)
                        i1(2)=ivet(2)
                        i1(3)=ivet(3)
                        if (jpatt.eq.3) then
                                          ee=vet(jind)*vet(jind+1)
                                        else
                                          ee=vet(jind)*vet(jind)
                                        endif
                      endif
      do 700 j=1,neqv
      do 540 i=1,3
  540 i2(i)=0
      do 560 i=1,3
      do 550 k=1,2
      m=iabs(is(k,i,j))
      if(m.ne.0) i2(m)=i2(m)+i1(i)*isign(1,is(k,i,j))
  550 continue
  560 continue
      b1=1.0
      js=1
      if(i2(3)) 590,570,600
  570 if(i2(1)) 590,580,600
  580 if(i2(2)) 590,600,600
  590 b1=-1.0
      js=-1
  600 kind(j)=ip5+js*(262144*i2(1)+512*i2(2)+i2(3))
      do 610 i=1,3
      if(iabs(i2(i)).ge.np(i)/2) go to 700
      if(i2(i).gt.mh(i)) mh(i)=i2(i)
  610 continue
      if(j.eq.1) go to 630
      nd=j-1
      do 620 i=1,nd
      if(kind(j).eq.kind(i)) go to 700
  620 continue
  630 nbatch=nbatch+1
      nex=nex+1
      nu=0
      do 640 i=1,3
  640 nu=nu-i1(i)*int(ts(i,j)*12.0+0.1)
      nu=mod(nu,12)
      if(nu.le.0) nu=nu+12
      xc=tab(nu+3)
      xs=tab(nu)
      gr=xc*ee-xs*eep
      gi=(xs*ee+xc*eep)*b1
      fsum=fsum+sqrt(gr*gr+gi*gi)
      g(1,nbatch)=gr
      g(2,nbatch)=gi
      ih(nbatch)=kind(j)
      if(nbatch.lt.100) go to 700
      write(jrel) ih,g
      nbatch=0
  700 continue
  800 continue
      if(nbatch.ne.0) write(jrel) ih,g
      scale=3000.0/fsum
      if (mode.eq.1) write(lo,990) nex,scale
  990 format( 6x,
     1 'i      Number of reflections in one hemisphere  i',
     2 i6,12x,'i',/, 6x,'i',47x,'i',18x,'i',/, 6x,
     3 'i                                        Scale  i',
     4 f10.3,8x,'i',/, 6x,'+',47('-'),'+------------------+')
      if(mode.eq.1) write(lo,431)
      if (it4 .gt. 0) write(lo,410) xlim,level
  410 format (///13x,43hfourier map to be printed from x =  0.0  to,
     1  f7.3, 15h,  y =  0.0  to, f7.3, 15h,  z =  0.0  to, f7.3,//,
     1 40x,33hpoints underlined if greater than,i5)
      return
      end
c--------------------------------------------------------------------------
      subroutine getref(ratio,mode,npseud,numb,ep)
      common /xdata/ ihkl(31000),e(31000),iphaz(31000),iphb(31000)
     *              ,wt(31000),duma(5000)
     *              ,dummpc(84000)
      common/c/flgw(30),flgd(30),avr(30),dcv(50),slope,flgk,bt,sc,del,ks
      common/rc/p(6),cx(9),nref,nb,rhomax,mm,en,mz,er,th,rhomin
      common/ureq/ ihx(3),ksigma,knw,jpart,jtran,fosog,nonos,iprin,iflag
      common/sym/is(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emme
     *          ,s3s2p
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,nat,f(9),nalf(8)
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,bfac(200),lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      dimension ep(31000)
      dimension vet(12),ivet(12)
      equivalence(vet(1),ivet(1))
c
c-- if pseudo exists the file  normalized e's are used
c-- ( not the renormalized e's used for invariants )
c
      if (ksigma.gt.0.and.
     *    tsigma.gt.0.0) then
                           ratio=tsigma
                         else
                           ratio=-1.0
                           if (fomin.gt.0.0) fosog=fomin
                           fsog=sqrt(fosog*fosog*sc)
                         endif
      if (npseud.eq.0) then
                         jps=4
                       else
                         jps=6
                       endif
      icont=0
      do 100 i=1,numb
      call snr07(vet)
      if (mode.eq.1) then
                       icont=icont+1
                       e(icont)=vet(jps)
                       ihkl(icont) = 262144*ivet(1) +512*ivet(2) 
     *                              +ivet(3) +131328
                     else
                       fo=vet(5)
                       iuse=0
                       if (ratio.gt.0.0) then
                                          sigma=vet(9)
                                          a=ratio*sigma
                                          if (fo.gt.a) iuse=1
                                        else
                                          if (fo.gt.fsog) iuse=1
                                        endif
                       if (iuse.eq.1) then
                          icont=icont+1
                          rho=rhof(p,ivet(1),ivet(2),ivet(3))
                          rho=rho*rho
                          e(icont)=fo
                          wt(icont)=rho
                          ep(icont)=vet(jps)
                          ihkl(icont) = 262144*ivet(1) +512*ivet(2) 
     *                                 +ivet(3) +131328
                       endif
                     endif
  100 continue
      numb=icont
      return
      end
c--------------------------------------------------------------------------
      subroutine sftra(mode,numb,ep)
c     structure factor and phases for fourier refinement 
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/ureq/ ihx(3),ksigma,knw,jpart,jtran,fosog,nonos,iprin,iflag
      common/sym/is(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emme
     *          ,s3s2p
      common/trig/sint(450),pi,twopi,dtor,rtod
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,nat,f(9),nalf(8)
      common/rc/p(6),cx(9),nref,nb,rhomax,mm,en,mz,er,th,rhomin
      common /atoms/ x(5,200),nz(200),ngp,ninf(10),nag(10)
      common/c/flgw(30),flgd(30),avr(30),dcv(50),slope,flgk,bt,sc,del,ks
      common /erl/ kmat(48,3,3),tmat(48,3),nt(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/xbuil/ift1,ift2,ift3,nfl,npeahi,ngrup,nfrag,ngh,ngl
     1,dmax,dmin,g(18),dmn(9),dmx(9),dmnmx(9,9,2),angi(3),angs(3)
     2,l3dum,md,lclus,mclus,laddr,ldis,mddis,lang,lnegl,mnegl,nnegl
     3,ladcon,lcon,mcon,ncon,mdcon,ladinc,linc,minc,mdinc
     4,ive(9),ive3i(9),ive3s(9),ive15i(9),ive15s(9)
     5,icopk(9),icoel(9),icogr(500)
      common/xdata/ ihkl(31000),e(31000),iphaz(31000),iphb(31000)
     *              ,wt(31000),nzsav(500),occsav(500),
     *               fvar(500),q(500),qq(500),dummy(2500)
     *              ,dummpc(84000)
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,bfac(200),lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
c
      dimension ep(31000)
c
      jlig=1
      if (no(1).eq.1) jlig=2
      anatm=0.0
      do 12 i=jlig,nk
   12 anatm=anatm+float(nw(i))
      anat=anatm
      kfrag=nemap(4)
c
c-- compute the number of peaks to consider
c
      totop=(icent+1)*nsym*pts
      delta=1.0/12.0
      sum=0.0
      enne=0.0
      jnats=0
      do 99 i=1,nats
      nzsav(i)=nz(i)
      occsav(i)=x(5,i)
      if (nz(i).eq.0) then
                        jnats=jnats+1
                        else
                         occ=x(5,i)
                         sum=sum+occ*totop
                         if ((sum-anat).lt.delta) enne=enne+1.0
                        endif
  99  continue
      bnats=float(nats-jnats)
      nenne=nint(enne)
      jnats=0
      j=nats
      do 991 i=1,nats
      if (nz(i).eq.0) go to 991
      if (jnats.ge.nenne) go to 991
      j=i
      jnats=jnats+1
  991 continue
      jnats=j
      denom=x(4,jnats)
      ii=0
      do 111 i=1,nats
      fvar(i)=1.0
      if (nz(i).eq.0) go to 111
      ii=ii+1
      b667=bnats-ii+1
      a667=b667/bnats
      a667=0.8*sqrt(a667)
      if (i.le.jnats) then
                        if (nz(i).lt.0) fvar(i)=a667
                      else
                        fvar(i)=0.667*x(4,i)/denom
                        if (nz(i).lt.0) fvar(i)=fvar(i)*a667
                      endif
  111 continue
      c=x(4,1) 
      jfirst=iabs(nz(   1)/100)
      jnats=nats+1
  115 jnats=jnats-1
      jlast =iabs(nz(jnats)/100)
      if (jlast.eq.0) go to 115
      sog=float(no(jlast))/float(no(jfirst))
      sog=sog*0.667
      iflag=0
      do 102 i=1,nats
      if (nz(i).eq.0) go to 102
      if (iflag.eq.0) then
                        qq(i)=x(4,i)/c
                        if (qq(i).lt.sog) then
                                            rife=x(4,i)
                                            iflag=1
                                            qq(i)=sog
                                          endif
                      else
                        qq(i)=sqrt(x(4,i)/rife)*sog
                      endif
      nz(i)=iabs(nz(i)/100)
      if (kfrag.ne.0.and.mode.eq.2) go to 102
      q(i)=fvar(i)
      x(5,i)=x(5,i)*qq(i)*q(i)
      if (nz(i).gt.0) nz(i)=nk
Corig sogz=x(5,i)*no(nk)

      sogz=qq(i)*q(i)*no(nk)

      if (sogz.lt.1.0) then
                         nz(i)=0
                         if (iprin.gt.2) write(lo,101) 
     *                       i,occsav(i),x(4,i),q(i),qq(i),sog,sogz
                       endif
  101 format(' atom ',i3,' rejected',6f10.5)
  102 continue
      call pkl15(nats)
      nlsm=1
      iref=0
      call sftryyy(iref,mode,nlsm,numb,ep,scalan)
      do 300 i=1,nats
      if (nz(i).ne.0) nz(i)=nzsav(i)
      x(5,i)=occsav(i)
  300 continue    
      interp=1
      call frm15(nats,numset,interp)
c
c-- plot
c
      mode1=mode-1
      call scrf(numset,mode1,1)
c
      return
      end
c---------------------------------------------------------------------
      subroutine sftrb(mode,numb,ep)
c     structure factor and phases for fourier refinement 
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/sym/is(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emme
     *          ,s3s2p
      common/trig/sint(450),pi,twopi,dtor,rtod
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common/ureq/ ihx(3),ksigma,knw,jpart,jtran,fosog,nonos,iprin,iflag
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,nat,f(9),nalf(8)
      common/rc/p(6),cx(9),nref,nb,rhomax,mm,en,mz,er,th,rhomin
      common /atoms/ x(5,200),nz(200),ngp,ninf(10),nag(10)
      common/c/flgw(30),flgd(30),avr(30),dcv(50),slope,flgk,bt,sc,del,ks
      common /erl/ kmat(48,3,3),tmat(48,3),nt(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/xbuil/ift1,ift2,ift3,nfl,npeahi,ngrup,nfrag,ngh,ngl
     1,dmax,dmin,g(18),dmn(9),dmx(9),dmnmx(9,9,2),angi(3),angs(3)
     2,l3dum,md,lclus,mclus,laddr,ldis,mddis,lang,lnegl,mnegl,nnegl
     3,ladcon,lcon,mcon,ncon,mdcon,ladinc,linc,minc,mdinc
     4,ive(9),ive3i(9),ive3s(9),ive15i(9),ive15s(9)
     5,icopk(9),icoel(9),icogr(500)
      common/xdata/ ihkl(31000),e(31000),iphaz(31000),iphb(31000)
     *             ,wt(31000),nzsav(500),occsav(500),
     *              fvar(500),q(500),qq(500),dummy(2500)
     *              ,dummpc(84000)
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,bfac(200),lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      integer izpk(500)
      dimension vet(8),ivet(8)
      dimension ep(31000)
      equivalence(vet,ivet)
c
      coef=1.35
      coefr=1.0/3.0
      call ysfl07(nrifl,nstr,mmmz,npseud,iy)
c
      delta=1.0/12.0
c-- compute the numer of peaks to consider
      totop=(icent+1)*nsym*pts
      jlig=1
      if (no(1).eq.1) jlig=2
      anat=0.0
      do 12 i=jlig,nk
   12 anat=anat+float(nw(i))
c
c-- azzero il vettore contenente un flag (0=atomo escluso,1=preso)
c
      sum=0.0
      nne=0.0
      do 99 i=1,nats
      if (krecy.ge.1) nz(i)=jlig*100+1
      if (nz(i).eq.0) go to 99
      if (sum.le.anat) then
                         occ=x(5,i)
                         sum=sum+occ*totop
                         if ((sum-anat).lt.delta) nne=nne+1
                      endif
   99 continue
      jnats=0
      j=nats
      do 991 i=1,nats
      if (nz(i).eq.0) go to 991
      if (jnats.ge.nne) go to 991
      j=i
      jnats=jnats+1
  991 continue
      nne=j
      call label(nne)
      call muovi
      if (krecy.ne.1) call assbty
      hei=x(4,nne)
      kzo=iabs(nz(nne)/100)
      sum=1.0
      do 97 i=1,nne-1
      if(sum.gt.2.5) go to 992
      j=nne-i
      kz=iabs(nz(j)/100)
      if (kz.eq.kzo) then
                       hei=hei+x(4,j)
                       sum=sum+1.0
                     endif
   97 continue
  992 continue
      hei=sum/hei
c
      do 98 i=1,nats
      nzsav(i)=nz(i)
      occsav(i)=x(5,i)
      if (nz(i).eq.0) go to 98
      xleg=1.000
      if (i.le.nne) then
                      ww=1.00
                      wws=1.00
                    else
                      ww=x(4,i)*hei*erre**coefr
                      wws=ww*xleg
Corig                 if (wws.le.0.2) then
                      if (wws.le.0.3) then
                                        ww=0.0
                                        nz(i)=0
                                      endif
                    endif
      x(5,i)=x(5,i)*xleg*ww
      nz(i)=iabs(nz(i)/100)
      if (iprin.gt.1) then
      if(nz(i).gt.0) then
      write(lo,9999) i,nalf(nz(i)),x(4,i),xleg,hei,erre*100.0,
     *              coefr,ww,occsav(i),x(5,i),wws
                      else
      write(lo,9998) i,x(4,i),xleg,hei,erre*100.0,
     *              coefr,ww,occsav(i),x(5,i),wws
                      endif
                      endif
   98 continue
 9999 format(i4,1h),2x,a2,2x,f8.1,4f10.3,f10.8,f6.2,f8.4,3f8.4)
 9998 format(i4,1h),6x,f8.1,4f10.3,f10.8,f6.2,f8.4,3f8.4)
c
      call pkl15(nats)
      nlsm=7
      iref=3
      call sftryyy(iref,mode,nlsm,numb,ep,scalan)
      do 300 i=1,nats
      kfrag=mod(nzsav(i),100)
      if (nzsav(i).gt.0) then
                           isg=1
                         else
                           isg=-1
                         endif
      if (nz(i).ne.0) nz(i)=isg*(nz(i)*100+kfrag)
      x(5,i)=occsav(i)
  300 continue    
c--- bisogna riassemblare la molecola.
      kact=5
      call maincl(izpk,kact,iprin)
c
      maxcyc=mode-1
      interp=1
      call frm15(nats,numset,interp)
c
c-- plot
c
      mode1=mode-1
      call scrf(numset,mode1,2)
      return
      end
c---------------------------------------------------------------------
      subroutine label(nne)
c
c-- subroutine to re-label peaks according only to
c-- the relative peak height and to the cell content
c-- if jall = 0 only heavy atoms (z=>11) are labelled
c-- if jall = 1 all atoms are labelled
c
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/trig/sint(450),pi,twopi,dtor,rtod
      common/sym/is(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emme
     *          ,s3s2p
      common /atoms/ x(5,200),nz(200),idumx(21)
      common/ureq/ ihx(3),ksigma,knw,jpart,jtran,fosog,nonos,iprin,iflag
      common/impl/jdir,kform,jfile,jout,nlen,knwr,kenvir,kstory(99),kff
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,bfac(200),lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      common /xdata/ ihkl(31000),e(31000),iphaz(31000),iphb(31000)
     *              ,wt(31000),izpk(500),duma(4500)
     *              ,dummpc(84000)
c-- nw(i) = number of atoms of the i-th specie
c-- no(i) = Z of atom of the i-th specie
c-- nkl   = number of non-hydrogen species
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,nat,f(9),nalf(8)
c
      dimension number(8,2)
C
      rap1s=0.6
      rap2s=1.4
      if (erre.lt.0.2) then
                         rap1s=0.4
                         rap2s=10000
                       endif
      do 100 i=1,nne 
      if (nz(i).eq.0) then
                        izpk(i)=0
                      else
                        izpki=iabs(nz(i))/100
                        izpk(i)=nk-izpki+1
                      endif
  100 continue
      jall=1
      t2=(icent+1)*nsym*pts
      jlig=0
      if (no(1).eq.1) jlig=1
c--NEW
      nkl=nk-jlig
c--NEW
      j=nk+1
      do 1000 i=1,nk
      j=j-1
      number(i,1)=nw(j)
      kz=no(j)
      if (kz.gt.1 ) then
                      number(i,2)=kz
                    else
                      number(i,2)=0
                    endif
 1000 continue
c
      k=1
      heig1=x(4,1)
      z1  =float(number(1,2))
c
      do 1100 i=1,nne 
      if(izpk(i).eq.0) go to 1100
c
      do 1090 j=1,nkl
      if (number(j,1).eq.0) go to 1090
      k=j
      lasth=i-1
      numb=nint(x(5,i)*t2)
 1120 number(k,1)=number(k,1)-numb
      kz=number(k,2)
      heign=x(4,i)
      zn  =float(number(k,2))
      if (jall.eq.0.and.kz.lt.11) go to 1400
      if (number(k,1).ge.0) then
         rap=heig1*zn/z1
         rap1=rap*rap1s
         rap2=rap*rap2s
         if ((heign.gt.rap1.and.heign.lt.rap2).or.kz.eq.0) then
Cnew     if ((heign.gt.rap1                  ).or.kz.eq.0) then
                                             izpk(i)=k
                                             if (number(k,1).eq.0) k=k+1
                                             go to 1100
                                              else
                                            number(k,1)=number(k,1)+numb
                                              endif
                            else
                              number(k,1)=number(k,1)+numb
                              k=k+1
                              if (k.le.nkl) then
                                             go to 1120
                                           else
                                             go to 1400
                                           endif
                            endif
 1090 continue
 1100 continue
      go to 1900
 1400 continue
 1900 continue
      do 2000 i=1,nne 
      if(izpk(i).eq.0) go to 2000
      if (nz(i).gt.0) then
                           isg=1
                         else
                           isg=-1
                         endif
      izpki=izpk(i)
      izpki=nk-izpki+1
      kfrag=mod(nz(i),100)
      nz(i)=isg*(izpki*100+kfrag)
 2000 continue
      return
      end
c---------------------------------------------------------------------
      subroutine pkl15(nats)
c
c-- deletes ghost peaks from atom list
c
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common /atoms/ x(5,200),nz(200),ngp,ninf(10),nag(10)
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,bfac(200),lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      common/ureq/ ihx(3),ksigma,knw,jpart,jtran,fosog,nonos,iprin,iflag
c
      j=0
      do 200 i=1,nats
      if (nz(i).ne.0) j=j+1
  200 continue
      if (j.eq.0) return
      k=nemap(1)-j
      nemap(1)=j
      if (k.gt.0.and.iprin.gt.1) write(lo,*) k,' ghost(s) rejected'
      return
      end
c---------------------------------------------------------------------
      subroutine stopr(host,izpk,mode)
c
c-- terminates the recycling procedure
c
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,bfac(200),lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      common /atoms/ x(5,200),nz(200),ngp,ninf(10),nag(10)
      common /atomo/ xyzo(5,200),nzo(200),dold(400)
      common/sf/al(4,8),bs(4,8),cl(8),nnw(8),nno(8),nk,nat,f(9),nalf(8)
      common/ureq/ ihx(3),ksigma,knw,jpart,jtran,fosog,nonos,iprin,iflag
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      dimension izpk(500)
      character*80 host
c
      idisp=1
      call sfl15(nats,idisp,idumm,interp)
      iprsav=iprin
      if (iprin.eq.0) iprin=2
      do 100 i=1,nats
c
c
      nz(i) = iabs( nz(i) )
c
c
      nzo(i)=nz(i)
      do 100 j=1,4
      xyzo(j,i)=x(j,i)
  100 continue
      natsav=nats
      k=0
      do 200 i=nats,1,-1
      if (nz(i).ne.0) then
                        k=i
                        rife=x(4,i)
                        go to 210
                      endif
  200 continue
  210 continue
      rife=0.5*rife
      if (k.ne.0) then
                    iniz=k+1
                    do 300 i=iniz,nats
                    if (x(4,i).gt.rife) k=k+1
  300               continue
                    nats=k
                  endif
      kaction=4
      call maincl(izpk,kaction,iprin)
      do 500 i=1,nats
      izpki=izpk(i)
      if (izpki.gt.0) then
                        isg= 1
                      else
                        isg=-1
                        izpki=-izpki
                       endif
      kfrag=mod(izpki,100)
      if (kfrag.eq.99) kfrag=0
      if (nzo(i).ne.0) then
                         nzz=nzo(i)/100
                         nzz=nk-nzz+1
                         izpk(i)=nzz*100+kfrag
                         izpk(i)=isg*izpk(i)
                       endif
  500 continue
      if (natsav.gt.nats) then
                            do 510 i=nats+1,natsav
                            nz(i)=0
                            izpk(i)=-1
  510                       continue
                          endif
      nats=natsav
      krecy=2000
      kact=4
      call outpea(host,izpk,kact)
c
c-- prepare atom list for future use
c
      do 600 i=1,nats
      if (nzo(i).eq.0) nz(i)=0
  600 continue
      errem=erre
      interp=1
      call frm15(nats,numset,interp)
      mode=0
      iprin=iprsav
      return
      end
c--------------------------------------------------------------------------
      subroutine sftryyy(iref,mode,nlsm,numb,ep,scalan)
c----
c     structure factor least squares
c
c     iref = 0 only structure factor computation
c     iref = 1 only B has to be refined
c     iref = 2 only X's have to be refined
c     iref = 3 B and X's have to be refined

      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/sym/is(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emme
     *          ,s3s2p
      common/trig/sint(450),pi,twopi,dtor,rtod
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common/ureq/ ihx(3),ksigma,knw,jpart,jtran,fosog,nonos,iprin,iflag
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,nat,f(9),nalf(8)
      common/rc/p(6),cx(9),nref,nb,rhomax,mm,en,mz,er,th,rhomin
      common /atoms/ x(5,200),nz(200),ngp,ninf(10),nag(10)
      common /atomo/ apd(4,200),bpd(4,200)
      common/c/flgw(30),flgd(30),avr(30),dcv(50),slope,flgk,bt,sc,del,ks
      common /erl/ kmat(48,3,3),tmat(48,3),nt(16),jsys,ngen
     *,irot(48,48),jsvet(10),isvet(8),nori,modul(3),nss(3)
      common/xdata/ ihkl(31000),e(31000),iphaz(31000),iphb(31000)
     *      ,wt(31000),nzsav(500),occsav(500),hkle(4,24)
     *      ,deltaf(4,200),qvet(4,200),kcond(4,200),newvet(48,3)
     *      ,duma(1360)
     *      ,dummpc(84000)
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,bfac(200),lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      common/spec/ soper(3,4,24),centrt(7,12),aaa(6),noper,ncentr,icett,
     *         kpol,jsyt,lat,indv(32),mpv(64),jspini,ddmin,ncawu,ncwu
      integer i1(3)
      dimension ep(31000),xo(11),xn(11),keyx(10)
      character jstep
c


      mode1=mode-1
      if (iref.ge.2) then
      iactn=2
      do 130 i=1,nats
         do 100 j=1,3
            xo(j)=x(j,i)
  100    continue
         k=kspecb(newvet,xo,xn,keyx,itype,iser,khead,iactn)
         iflk=0
         do 110 j=1,3
            ke=keyx(j)
            if (ke.ne.0.and.ke.ne.j) iflk=1
            kcond(j,i)=keyx(j)
  110    continue
         if (iflk.eq.1) then
             do 120 j=1,3
                kcond(j,i)=0
  120        continue
             endif
  130 continue
      if (kpol.ne.0) then 
                       jpol=kpol
                       i100=100
                       do 140 i=1,3
                       k=jpol/i100
                       if (k.ne.0) kcond(i,1)=0
                       jpol=jpol-k*i100
                       i100=i100/10
  140                  continue
                     endif
c
                   endif
c
c     if (krecy.le.1) oscale=1.0
      if (jrest.eq.0) then
      if (mode1.eq.1) oscale=1.0
                      endif
      uno=1
      gof=100.0
      gofold=gof
      gofsold=gof
      gofmin=0.5
      bt3=3.0*biso
      dump=0.5
      jlig=1
      if (no(1).eq.1) jlig=2
           if (iref.eq.1) then
                            k1=4
                            k2=4
                            jstep='B'
      else if (iref.eq.2) then
                            k1=1
                            k2=3
                            jstep='C'
      else if (iref.eq.3) then
                            k1=1
                            k2=4
                            jstep='B'
                          else
                            jstep='A'
                          endif
      if (iref.eq.1.or.iref.eq.3) then
                                    do 150 i=1,nats
                                    kcond(4,i)=1
  150                               continue
                                  endif
c
      jstop=0
      do 3000 nls=1,nlsm
      if (nls.eq.nlsm) iref=0
      scale=1.0/oscale
      if (gof.lt.gofmin) jstop=1
      if (jstop.eq.1.and.nls.ne.nlsm) go to 3000
      gof =0.0
      agof=0.0
      gofs=0.0
      sumfo=0.0
      sumfor=0.0
      sumfc=0.0
      sumdf=0.0
      bison=0.0
      bisod=0.0
      if (iref.ge.1) then
                       df1=0.0
                       df2=0.0
                       b11=0.0
                       b22=0.0
                       b12=0.0
                       do 200 jj=1,nats
                       do 200 k=k1,k2
                       deltaf(k,jj)=0.0
  200                  qvet(k,jj)=0.0
                     endif
      do 500 i=1,numb
      i1(1)=ihkl(i)/262144
      j=ihkl(i)-262144*i1(1)
      i1(2)=j/512-256
      i1(3)=j-512*(i1(2)+256)-256
c
c-- compute H*R and H*T
c
      do 250 j=1,nsym
      t=1000.0
      do 230 l=1,3
      t=t+float(i1(l))*tmat(j,l)
      hkle(l,j)=0
c------------
      do 240 k=1,3
  240 hkle(l,j)=hkle(l,j)+i1(k)*kmat(j,k,l)
c------------
  230 continue
      hkle(4,j)=t
  250 continue
      fo=e(i)
      rho=wt(i)
      act=0.0
      bct=0.0
      do 300 ij=1,nk
      f(ij)=cl(ij)
      do 300 ii=1,4
      f(ij)=f(ij)+al(ii,ij)*exp(-bs(ii,ij)*rho)
  300 continue
      if (iref.ge.1) then
                       do 350 jj=1,nats
                       do 350 k=k1,k2
                       apd(k,jj)=0.0
                       bpd(k,jj)=0.0
  350                  continue
                     endif
      do 400 jj=1,nats
      if (nz(jj).eq.0) go to 400
      kz=nz(jj)
      fkz=f(kz)
      arg=-bfac(jj)*rho
      effe=pts*fkz*exp(arg)
      tfocc=effe*x(5,jj)
      tfocp=tfocc*twopi*float(icent+1)
      call sfacyyy(hkle,jj,contc,conts,tfocp,iref,rho,kcond)
      contc=contc*tfocc
      conts=conts*tfocc
      act=act+contc
      bct=bct+conts
      if (kcond(4,jj).eq.1) then
                              apd(4,jj)=-rho*contc
                              bpd(4,jj)=-rho*conts
                            endif
  400 continue
      args=act*act+bct*bct
      if (args.gt.0.000001) then
                              fc=sqrt(args)
                              if(nls.eq.nlsm)
     *                        faze=rtod*atan2(bct,act)+360.0
                              ac=act/fc
                              bc=bct/fc
                            else
                              fc=0.0
                              if(nls.eq.nlsm)
     *                        faze=0.0
                              ac=0.0
                              bc=0.0
                            endif
      ep(i)=fc
      sumfor=sumfor+fo
      fo=fo*scale
      df=fo-fc
      sumfo=sumfo+fo
      sumfc=sumfc+fc
      sumdf=sumdf+abs(df)
      if (iref.ge.1) then
c
c--  accumulation of l.s. normal equations
c
                       fcs=fc*scale
                       sw=-rho*fc
                       b11=b11+fcs*fcs
                       b22=b22+sw *sw
                       b12=b12+fcs*sw
                       df1=df1+df*fcs
                       df2=df2+df*sw
                       do 450 jj=1,nats
                       do 450 k=k1,k2
                       if (kcond(k,jj).eq.0) go to 450
                       if (nz(jj).eq.0) go to 450
                       dfdb=apd(k,jj)*ac+bpd(k,jj)*bc
                       qvet(k,jj)=qvet(k,jj)+dfdb*dfdb
                       deltaf(k,jj)=deltaf(k,jj)+dfdb*df
  450                  continue
                     else
c
c-- compute stuff for fourier
c
                       iphap=mod(int(faze+0.5),360)
                       if(iphap.eq.0) iphap=360
                       iphb(i)=iphap
                     endif
  500 continue
c
c--  compute r-factor
c
      scalan=sumfc/sumfor
      ksca=0
      if (jrest.eq.0) then
                        if (krecy.eq.0) ksca=1
                      else
                        if (krecy.eq.1) ksca=1
                      endif
Corig if (krecy.eq.0) then
      if (ksca.eq.1) then
                        oscale=1.0/scalan
                        sumdf=0.0
                        sumfo=0.0
                        do 510 i=1,numb
                        sumdf=sumdf+abs(ep(i)-scalan*e(i))
                        sumfo=sumfo+scalan*e(i)
  510                   continue
                      endif
      erre=sumdf/sumfo
      rfac=100.0*erre
      if (iprin.gt.2) then
      write(lo,540) mode1,rfac,nemap(1),nemap(2),nemap(3),
     *              scale,gofold,gofsold,scalan,dg,biso,bt3
                      else
      if (iref.eq.0) write(lo,545) jstep,mode1,rfac
                      endif
  540 format(' cycle #',i3,' r-fac.=',f7.2,'%, ',
     *       i3,1h/,i3,1h/,i3,' atoms, ',7f9.4)
  545 format(25x,a1,i10,8x,f7.2,'%',4i5)
c
      if (iref.eq.0) go to 3000
c
c--  compute correction for scale factor
c
      denom =  b11 * b22 - b12 * b12        
      dbm=(b11*df2-b12*df1)/denom
      dbs=df2/b22
      dg =(b22*df1-b12*df2)/denom
      corr= dbm- dbs
c     
c--  compute new scale-factor
c
      oscale=oscale+dg
c
      nesub=nats-nemap(3)
      nrej=0
      do 600 jj=1,nats
      if (nz(jj).eq.0) go to 600
      kz=nz(jj)
      do 550 k=k1,k2
      if (kcond(k,jj).eq.0) go to 550
      shift=deltaf(k,jj)/qvet(k,jj)
      if (k.le.3) then
                    xnew=x(k,jj)+shift*dump
                    if (iprin.gt.2) write(lo,2000) nalf(nz(jj)),jj,
     *                x(k,jj),shift,xnew,deltaf(k,jj),qvet(k,jj),x(5,jj)
                    x(k,jj)=xnew
                  else
                    ashift=(shift+corr)*dump
                    bnew=bfac(jj)+ashift
                    if (iprin.gt.2) write(lo,2001) nalf(nz(jj)),jj,
     *                bfac(jj),shift,ashift,bnew,dbm,dbs,corr
c
c-- reset occupancy factor if thermal factor is negative
c
                    if (bnew.lt.0.0) bnew=0.1
c
c-- reject atom if thermal factor is too large
c
                    if (nls.gt.1) then
                        if (bnew.gt.bt3) then
                                   if (kz.eq.jlig.and.nesub.gt.0) then
                                                   nesub=nesub-1
                                                   nrej=nrej+1
                                                   nz(jj)=0
                                                 endif
                                         endif
                                  endif
                    if (nz(jj).ne.0) then
                                       bison=bison+bnew*no(nz(jj))
                                       bisod=bisod+no(nz(jj))
                                       gof=gof+abs(ashift)
                                       gofs=gofs+ashift
                                       agof=agof+1.0
                                     endif
                    bfac(jj)=bnew
                  endif
  550 continue
  600 continue
 2000 format(2x,a2,i3,3f10.5,2f12.1,f8.3)
 2001 format(2x,a2,i3,7f10.5)
      if (iref.eq.2) go to 3000
      gof =gof /agof
      gofs=gofs/agof
      if (nls.eq.1) gof=10+gof
      biso=bison/bisod
c
c     bt3=3.0*biso
c
      if (nrej.gt.0) call pkl15(nats)
      if (gof.gt.gofold) then
                           gofold=gof
                           gofsold=gofs
                           gof=0.0
                         else
                           gofold=gof
                           gofsold=gofs
                         endif
 3000 continue
c
c-- compute fourier coefficients and weights
c
      do 3015 i=1,numb
      fo=e(i)*scalan
      fc=ep(i)
c
c-- new: coeff.= 2 Fo - Fc
c--      weight= 1
c
      e(i)= 2.0*fo - fc
      ep(i)=1.0
 3015 continue
      return
      end
c------------------------------------------------------------
c     structure factor calculation
      subroutine sfacyyy(hkle,jj,contc,conts,tfocp,iref,rho,kcond)
c
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common/sym/is(2,3,24),ts(3,24),nsym,pts,ksys,icent,latt,s3s2,emme
     *          ,s3s2p
      common /atoms/ x(5,200),nz(200),ngp,ninf(10),nag(10)
      common /atomo/ apd(4,200),bpd(4,200)
      common/trig/sint(450),pi,twopi,dtor,rtod
      dimension cost(360),hkle(4,24),kcond(4,200)
      equivalence (sint(91),cost(1))
c
      at=0.0
      bt=0.0
      do 1000 j=1,nsym
      arg=amod(hkle(1,j)*x(1,jj)
     *        +hkle(2,j)*x(2,jj)
     *        +hkle(3,j)*x(3,jj)
     *        +hkle(4,j),1.0)
      iarg=int(360.0*arg+0.5)+1
      if(iarg.eq.361) iarg=1
      at=at+cost(iarg)
      bt=bt+sint(iarg)
      if (iref.ge.2) then
                       do 900 k=1,3
                                 hkltf=hkle(k,j)*tfocp
                                 apd(k,jj)=apd(k,jj)-hkltf*sint(iarg)
                                 if (icent.eq.0) 
     *                           bpd(k,jj)=bpd(k,jj)+hkltf*cost(iarg)
  900                  continue
                     endif
 1000 continue
      if (icent.eq.0) then
                        contc=at
                        conts=bt
                      else
                        contc=2.0*at
                        conts=0.0
                      endif
      return
      end
c--------------------------------------------------------------------------
      subroutine assbty
c
c  assign to atoms the thermal factor list according to previous atom list
c
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common/ureq/ ihx(3),ksigma,knw,jpart,jtran,fosog,nonos,iprin,iflag
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,nat,f(9),nalf(8)
      common/c/flgw(30),flgd(30),avr(30),dcv(50),slope,flgk,bt,sc,del,ks
      common/xdata/ ihkl(31000),e(31000),iphaz(31000),iphb(31000)
     *              ,wt(31000),nzsav(500),occsav(500),
     *               fvar(500),q(500),bnew(500),dummy(2500)
     *              ,dummpc(84000)
      common /atoms/ x(5,200),nz(200),ngp,ninf(10),nag(10)
      common /atomo/ xyzo(5,200),nzo(200),dold(400)
      common/spec/ soper(3,4,24),centrt(7,12),aaa(6),noper,ncentr,icent
     *        ,kpol,jsys,latx,indv(32),mpv(64),jspini,ddmin,ncawu,ncwu
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,bfac(200),lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      dimension xn(3),xo(3),xeq(3),vet(2),s(3)
c
      idisp=1
      call sfl30(natso,idisp,idumm,interp)
              if (iprin.gt.2) then
      write(lo,*) ' vecchia lista '
      do 1 i=1,natso
      nzzo=iabs(nzo(i)/100)
      if (nzzo.eq.0) then
	  write(lo,'(2x,2x,i5,f8.1,3f10.3)')
     *          i,xyzo(4,i),(xyzo(j,i),j=1,3)
                     else
	  write(lo,'(2x,a2,i5,f8.1,3f10.3)')
     *          nalf(nzzo),i,xyzo(4,i),(xyzo(j,i),j=1,3)
                     endif
    1 continue
      write(lo,*) ' nuova lista '
                          endif
      do 5 j=1,nats
          if (iprin.gt.2) then
          nzzo=iabs(nz(j)/100)
          if (nzzo.gt.0) then
	  write(lo,'(2x,a2,i5,f8.1,3f10.3)')
     *    nalf(nzzo),j,x(4,j),(x(k,j),k=1,3)
                         else
	  write(lo,'(2x,2x,i5,f8.1,3f10.3)')
     *               j,x(4,j),(x(k,j),k=1,3)
                         endif
                          endif
      q(j)=0.0
   5  bnew(j)=biso
      vet(1)= 1.0
      vet(2)=-1.0
      ifin=icent+1
      do 100 i=1,natso
      if (nzo(i).eq.0) go to 100
      nzo(i)=iabs(nzo(i)/100)
      do 10 j=1,3
   10 xo(j)=xyzo(j,i)
      distm=9999
      jpunt=0
      do 90 j=1,nats
      if (nz(j).eq.0) go to 90
      if (q(j).gt.0.5) go to 90
      do 20 k=1,3
   20 xn(k)=x(k,j)
      do 50 kt=1,ncentr
        do 50 ifi=1,ifin
          coef=vet(ifi)
          do 50 k=1,noper
            call xequi(xo,k,coef,xeq,kt)
            call xdist(xn,xeq,d,s)
            if (d.lt.distm.and.d.lt.ddmin) then
                                             distm=d
                                             jpunt=j
                                           endif
   50 continue
   90 continue
c
      if (jpunt.ne.0) then
                        q(jpunt)=i
                        nzn=iabs(nz(jpunt)/100)
                        if (nzo(i).eq.nzn) then
                                             bnew(jpunt)=bfac(i)
                                           else
                                             z1=no(nzo(i))
                                             z2=no(nzn)
                                             bmod=bfac(i)*z1/z2
                                             bmod=(bmod+biso)/2.0
                                             bnew(jpunt)=bmod
c
c-- proviamo ad assegnare il b medio calcolato
c
                                             bnew(jpunt)=biso
c
              if (iprin.gt.2)
     *  write(lo,98) nalf(nzo(i)),i    ,z1,bfac(i),(xyzo(jj,i),jj=1,5),
     *               nalf(nzn)   ,jpunt,z2,bmod   ,(x(jj,jpunt),jj=1,5)
   98 format(' Era ',a2,i4,f5.0,f7.3,5f8.3,10h  e sara' ,
     *                       a2,i4,f5.0,f7.3,5f8.3)        
                                           endif
                      endif
c
  100 continue
      if (iprin.gt.2) then
      do 110 j=1,nats
      if (nz(j).eq.0) go to 110
      nzn=iabs(nz(j)/100)
      i=nint(q(j))
      if (i.gt.0) then
                    write(lo,92) nalf(nzn),j,(x(k,j),k=1,3),bnew(j),
     *                          nalf(nzo(i)),i,(xyzo(k,i),k=1,3),bfac(i)
                       else
                    write(lo,92) nalf(nzn),j,(x(k,j),k=1,3),bnew(j)
                       endif
  110 continue
                      endif
      do 120 j=1,nats
      bfac(j)=bnew(j)
c
c-- assign old coordinates to new peaks
c
      i=q(j)
      if (i.gt.0) then
                    do 115 jj=1,3
  115               x(jj,j)=xyzo(jj,i)
                    x(5,j)=xyzo(5,i)
                  endif
  120 continue
   92 format(2x,a2,i4,4f10.3,10x,a2,i4,4f10.3,10x)
      return
      end
c--------------------------------------------------------------------------
      subroutine muovi
c
c  assign to atoms the thermal factor list according to previous atom list
c
      common/unit/ln,lo,ifour,jrel,iscra,jhost,itle(20),jgrap
      common /const/ nex,np(3),numset,npic,nats,jall,nset,iset(20),factr
      common/ureq/ ihx(3),ksigma,knw,jpart,jtran,fosog,nonos,iprin,iflag
      common/sf/al(4,8),bs(4,8),cl(8),nw(8),no(8),nk,nat,f(9),nalf(8)
      common/c/flgw(30),flgd(30),avr(30),dcv(50),slope,flgk,bt,sc,del,ks
      common/xdata/ ihkl(31000),e(31000),iphaz(31000),iphb(31000)
     *              ,wt(31000),nzsav(500),occsav(500),
     *               fvar(500),q(500),bnew(500),dummy(2500)
     *              ,dummpc(84000)
      common /atoms/ x(5,200),nz(200),ngp,ninf(10),nag(10)
      common /atomo/ xyzo(5,200),nzo(200),dold(400)
      common/spec/ soper(3,4,24),centrt(7,12),aaa(6),noper,ncentr,icent
     *        ,kpol,jsys,latx,indv(32),mpv(64),jspini,ddmin,ncawu,ncwu
      common /emap/ jrecyc,krecy,erre,erreo,nemap(4),biso,bfac(200),lsx,
     *              oscale,errem,fomin,tsigma,maxcyc,jrest
      common/lst03/l3,m3,md3,n3,l3t,m3t,l3ti,m3ti,l3g,n3g,sys03
      common / data/  store (5000)
      dimension xn(3),xo(3),xeq(3),vet(2),s(3),radii(8)
      character*8 reject
c
c-- get informations about radii
c
      call yfl03
      m3=l3
      do 24  i= 1,n3
      radii(i) = store(m3+15)
      m3=m3+md3
   24 continue

c
      vet(1)= 1.0
      vet(2)=-1.0
      ifin=icent+1
      do 100 i=1,nats-1
      if (nz(i).eq.0) go to 100
      nzi=iabs(nz(i)/100)
      do 10 j=1,3
   10 xo(j)=x(j,i)
      distm=9999
      jpunt=0
      do 90 j=i+1,nats
      if (nz(j).eq.0) go to 90
      do 20 k=1,3
   20 xn(k)=x(k,j)
      do 50 kt=1,ncentr
        do 50 ifi=1,ifin
          coef=vet(ifi)
          do 50 k=1,noper
            call xequi(xo,k,coef,xeq,kt)
            call xdist(xn,xeq,d,s)
            if (d.lt.distm) then
                              distm=d
                              jpunt=j
                            endif
   50 continue
   90 continue
c
      if (jpunt.ne.0) then
                        nzj=iabs(nz(jpunt)/100)
                        reject='        '
                        drej=radii(nzi)+radii(nzj)-0.5
                        if (distm.lt.drej) then
                                             nz(jpunt)=0
                                             reject='rejected'
                                           endif
                      else
                      endif
      if (iprin.gt.0)
     *write(lo,91) nalf(nzi),i,nalf(nzj),jpunt,drej,distm,reject
   91 format(2(1h ,a2,i4),2f10.4,2x,a8)
c
  100 continue
      if (iprin.gt.0)
     *write(lo,'(5(i4,1h),i5,5x))') (i,nz(i),i=1,nats)
      return
      end
c--------------------------------------------------------------------------

